import{a as t,o as r,e as i,y as o,u as s,q as e}from"./runtime-core.esm-bundler.22ec0346.js";const c=s("div",{class:"markdown-body"},[s("p",null,[e("Deploying directus to IIS will require "),s("a",{href:"https://github.com/Azure/iisnode",target:"_blank",rel:"noopener noreferrer"},"iisnode"),e(", the IIS URL Rewrite module, an entrypoint file, and some specific web.config configurations.")]),s("h2",{id:"iisnode",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#iisnode"},"#"),e(" iisnode")]),s("p",null,[e("iisnode can be downloaded from the "),s("a",{href:"https://github.com/Azure/iisnode/releases",target:"_blank",rel:"noopener noreferrer"},"azure/iisnode releases"),e(" page.")]),s("h2",{id:"iis-url-rewrite-module",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#iis-url-rewrite-module"},"#"),e(" IIS URL Rewrite module")]),s("p",null,[e("The URL Rewrite module can be downloaded from the "),s("a",{href:"https://www.iis.net/downloads/microsoft/url-rewrite",target:"_blank",rel:"noopener noreferrer"},"Microsoft IIS website"),e(".")]),s("h2",{id:"environment-variables",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#environment-variables"},"#"),e(" Environment variables")]),s("p",null,[e("The "),s("code",null,"PORT"),e(" entry needs to be removed or disabled in the "),s("code",null,".env"),e(" file to get Directus working on IIS.")]),s("pre",null,[s("code",null,`# The port Directus will run on [8055]
# PORT=8055
`)]),s("p",null,[e("The "),s("code",null,"PUBLIC_URL"),e(" entry must match the site binding in IIS. Port number is optional.")]),s("pre",null,[s("code",null,`PUBLIC_URL="https://cms.yourdomain.com/"
`)]),s("h2",{id:"entrypoint",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#entrypoint"},"#"),e(" Entrypoint")]),s("p",null,[e("iisnode acts as a reverse proxy, and simply forwards requests to files based on any rewrite rules and the files available. Since iisnode simply pipes requests to files, running the directus CLI directly won\u2019t work. To get around this, use an entrypoint script like the "),s("code",null,"index.js"),e(" below.")]),s("pre",null,[s("code",{class:"language-js"},[s("span",{class:"hljs-keyword"},"var"),e(" { startServer } = "),s("span",{class:"hljs-built_in"},"require"),e("("),s("span",{class:"hljs-string"},"'directus/server'"),e(`);

`),s("span",{class:"hljs-title function_"},"startServer"),e(`();
`)])]),s("h2",{id:"web.config",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#web.config"},"#"),e(" web.config")]),s("p",null,"With an entrypoint created, add a web.config to the root of the project. The following web.config is a simple example of running directus with iisnode"),s("pre",null,[s("code",{class:"language-xml"},[s("span",{class:"hljs-meta"},[e("<?xml version="),s("span",{class:"hljs-string"},'"1.0"'),e(" encoding="),s("span",{class:"hljs-string"},'"utf-8"'),e("?>")]),e(`
`),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"configuration"),e(">")]),e(`
  `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"location"),e(),s("span",{class:"hljs-attr"},"path"),e("="),s("span",{class:"hljs-string"},'"."'),e(),s("span",{class:"hljs-attr"},"inheritInChildApplications"),e("="),s("span",{class:"hljs-string"},'"false"'),e(">")]),e(`
    `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"system.webServer"),e(">")]),e(`
      `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"handlers"),e(">")]),e(`
        `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"add"),e(),s("span",{class:"hljs-attr"},"name"),e("="),s("span",{class:"hljs-string"},'"iisnode"'),e(),s("span",{class:"hljs-attr"},"path"),e("="),s("span",{class:"hljs-string"},'"index.js"'),e(),s("span",{class:"hljs-attr"},"verb"),e("="),s("span",{class:"hljs-string"},'"*"'),e(),s("span",{class:"hljs-attr"},"modules"),e("="),s("span",{class:"hljs-string"},'"iisnode"'),e(" />")]),e(`
      `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"handlers"),e(">")]),e(`
      `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"iisnode"),e(),s("span",{class:"hljs-attr"},"node_env"),e("="),s("span",{class:"hljs-string"},'"%node_env%"'),e(),s("span",{class:"hljs-attr"},"loggingEnabled"),e("="),s("span",{class:"hljs-string"},'"true"'),e(),s("span",{class:"hljs-attr"},"enableXFF"),e("="),s("span",{class:"hljs-string"},'"true"'),e(" />")]),e(`
      `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"rewrite"),e(">")]),e(`
        `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"rules"),e(">")]),e(`
          `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"rule"),e(),s("span",{class:"hljs-attr"},"name"),e("="),s("span",{class:"hljs-string"},'"root"'),e(">")]),e(`
            `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"match"),e(),s("span",{class:"hljs-attr"},"url"),e("="),s("span",{class:"hljs-string"},'"(.*)"'),e(" />")]),e(`
            `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"action"),e(),s("span",{class:"hljs-attr"},"type"),e("="),s("span",{class:"hljs-string"},'"Rewrite"'),e(),s("span",{class:"hljs-attr"},"url"),e("="),s("span",{class:"hljs-string"},'"index.js"'),e(" />")]),e(`
          `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"rule"),e(">")]),e(`
        `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"rules"),e(">")]),e(`
      `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"rewrite"),e(">")]),e(`
      `),s("span",{class:"hljs-tag"},[e("<"),s("span",{class:"hljs-name"},"httpErrors"),e(),s("span",{class:"hljs-attr"},"existingResponse"),e("="),s("span",{class:"hljs-string"},'"PassThrough"'),e(" />")]),e(`
    `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"system.webServer"),e(">")]),e(`
  `),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"location"),e(">")]),e(`
`),s("span",{class:"hljs-tag"},[e("</"),s("span",{class:"hljs-name"},"configuration"),e(">")]),e(`
`)])]),s("p",null,"A few important points regarding this file:"),s("ol",null,[s("li",null,[e("The iisnode handler "),s("code",null,"path"),e(" parameter is set to the entrypoint filepath")]),s("li",null,[e("The iisnode handler "),s("code",null,"verb"),e(" parameter is set to handle all verbs (*)")]),s("li",null,[e("The iisnode "),s("code",null,"node_env"),e(" parameter is bound to the environment variable "),s("code",null,"node_env")]),s("li",null,[e("The iisnode "),s("code",null,"enableXFF"),e(" parameter is set to "),s("code",null,"true"),e(". Since iisnode acts as a reverse proxy, this is required to pass client IP and other details on to the directus server, which directus modules expect and depend on.")]),s("li",null,"The rewrite rule is in place to send all requests made to this site to the entrypoint, ensuring that directus handles the routing and not IIS"),s("li",null,"The error page response needs to be untouched by IIS for two-factor authentication to work.")]),s("p",null,"While there are dozens even hundreds of options within IIS, this should help in getting started with Directus on IIS.")],-1),j="IIS (Internet Information Services)",m=!1,g="How to host Directus on IIS",f="2 min read",w={__name:"iis",setup(h,{expose:a}){const n={title:"IIS (Internet Information Services)",modularExtension:!1,description:"How to host Directus on IIS",readTime:"2 min read"};return a({frontmatter:n}),(p,d)=>{const l=t("docs-wrapper");return r(),i(l,{frontmatter:n},{default:o(()=>[c]),_:1})}}};export{w as default,g as description,m as modularExtension,f as readTime,j as title};
