import{a as o,o as c,e as h,y as t,u as s,q as e,z as a}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},p=s("hr",null,null,-1),u=s("h2",{id:"the-revision-object",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#the-revision-object"},"#"),e(" The Revision Object")],-1),_=s("p",null,[s("code",null,"id"),e(),s("strong",null,"integer"),s("br"),e(" Primary key of the revision.")],-1),m=s("code",null,"activity",-1),v=s("strong",null,"many-to-one",-1),j=s("br",null,null,-1),y=s("p",null,[s("code",null,"collection"),e(),s("strong",null,"string"),s("br"),e(" Collection in which this revision happened.")],-1),g=s("p",null,[s("code",null,"item"),e(),s("strong",null,"string"),s("br"),e(" Primary key of the item that was changed.")],-1),b=s("p",null,[s("code",null,"data"),e(),s("strong",null,"object"),s("br"),e(" Snapshot of the top-level item data.")],-1),f=s("p",null,[s("code",null,"delta"),e(),s("strong",null,"object"),s("br"),e(" Snapshot of the changes made in this revision.")],-1),x=s("p",null,[s("code",null,"parent"),e(),s("strong",null,"many-to-one"),s("br"),e(" Parent revision that triggered this revision. Many-to-one to revisions (recursive).")],-1),q=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"id"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"368"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"activity"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"438"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"collection"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"articles"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"item"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"1"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"data"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"title"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Hello World"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"delta"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"title"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Hello from the Docs!"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"parent"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),R=s("hr",null,null,-1),k=s("h2",{id:"list-revisions",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#list-revisions"},"#"),e(" List revisions")],-1),w=s("p",null,"List all revisions that exist in Directus.",-1),E=s("div",{class:"tip hint"},[s("div",{class:"hint-title"},"Permissions"),s("p",null,"The data returned in this endpoint will be filtered based on the user\u2019s permissions. For example, revisions that apply to a collection that the current user doesn\u2019t have access to are stripped out.")],-1),T=s("h3",{id:"query-parameters",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters"},"#"),e(" Query Parameters")],-1),P=s("h3",{id:"returns",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns"},"#"),e(" Returns")],-1),S=s("a",{href:"#the-revision-object"},"revision objects",-1),L=s("h3",{id:"rest-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api"},"#"),e(" REST API")],-1),Q=s("pre",null,[s("code",null,`GET /revisions
SEARCH /revisions
`)],-1),A=s("h3",{id:"graphql",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql"},"#"),e(" GraphQL")],-1),C=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),G=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	revisions: [directus_revisions]
}
`)])],-1),D=s("h5",{id:"examples",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#examples"},"#"),e(" Examples")],-1),I=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	revisions {
		id
		data
		delta
	}
}
`)])],-1),H=s("hr",null,null,-1),B=s("h2",{id:"retrieve-a-revision",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#retrieve-a-revision"},"#"),e(" Retrieve a revision")],-1),N=s("p",null,"List an existing revision by primary key.",-1),O=s("h3",{id:"query-parameters-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-1"},"#"),e(" Query Parameters")],-1),V=s("h3",{id:"returns-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-1"},"#"),e(" Returns")],-1),M=s("p",null,[e("Returns the requested "),s("a",{href:"#the-revision-object"},"revision object"),e(".")],-1),z=s("h3",{id:"rest-api-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-1"},"#"),e(" REST API")],-1),F=s("pre",null,[s("code",null,`GET /revisions/:id
`)],-1),W=s("h5",{id:"example",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example"},"#"),e(" Example")],-1),J=s("pre",null,[s("code",null,`GET /revisions/322
`)],-1),K=s("h3",{id:"graphql-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-1"},"#"),e(" GraphQL")],-1),U=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),X=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	revisions_by_id(id:`),s("span",{class:"hljs-literal"}," ID"),e(`!): directus_revisions
}
`)])],-1),Y=s("h5",{id:"example-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-1"},"#"),e(" Example")],-1),Z=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	revisions_by_id(id: `),s("span",{class:"hljs-number"},"322"),e(`) {
		id
		data
		delta
	}
}
`)])],-1),ns="Revisions",as=!1,ls="REST and GraphQL API documentation on the Revisions collection in Directus.",os="2 min read",rs="page-reference",is={__name:"revisions",setup($,{expose:r}){const l={title:"Revisions",modularExtension:!1,description:"REST and GraphQL API documentation on the Revisions collection in Directus.",readTime:"2 min read",pageClass:"page-reference"};return r({frontmatter:l}),(ss,es)=>{const n=o("router-link"),i=o("docs-wrapper");return c(),h(i,{frontmatter:l},{default:t(()=>[s("div",d,[s("blockquote",null,[s("p",null,[e("Revisions are individual changes to items made. Directus keeps track of changes made, so you\u2019re able to revert to a previous state at will. "),a(n,{to:"/docs/getting-started/glossary#revisions"},{default:t(()=>[e("Learn more about Revisions")]),_:1}),e(".")])]),p,u,_,s("p",null,[m,e(),v,j,e(" Related activity record. Many-to-one to "),a(n,{to:"/docs/reference/system/activity"},{default:t(()=>[e("activity")]),_:1}),e(".")]),y,g,b,f,x,q,R,k,w,E,T,s("p",null,[e("Supports all "),a(n,{to:"/docs/reference/query"},{default:t(()=>[e("global query parameters")]),_:1}),e(".")]),P,s("p",null,[e("An array of up to "),a(n,{to:"/docs/reference/query#limit"},{default:t(()=>[e("limit")]),_:1}),e(),S,e(". If no items are available, data will be an empty array.")]),L,Q,s("p",null,[a(n,{to:"/docs/reference/introduction#search-http-method"},{default:t(()=>[e("Learn more about SEARCH ->")]),_:1})]),A,C,G,D,I,H,B,N,O,s("p",null,[e("Supports all "),a(n,{to:"/docs/reference/query"},{default:t(()=>[e("global query parameters")]),_:1}),e(".")]),V,M,z,F,W,J,K,U,X,Y,Z])]),_:1})}}};export{is as default,ls as description,as as modularExtension,rs as pageClass,os as readTime,ns as title};
