import{a as o,o as p,e as u,y as n,u as s,q as t,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const i={class:"markdown-body"},h=s("blockquote",null,[s("p",null,"Settings are key-value pairs that are stored in the database, and control different aspects of the project. Only administrators have access to manage Settings.")],-1),d=s("hr",null,null,-1),_=s("h2",{id:"the-settings-object",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#the-settings-object"},"#"),t(" The Settings Object")],-1),j=s("p",null,[s("code",null,"id"),t(),s("strong",null,"uuid"),s("br"),t(" Primary key of the setting.")],-1),g=s("p",null,[s("code",null,"project_name"),t(),s("strong",null,"string"),s("br"),t(" Name of the project, shown in the Admin App.")],-1),m=s("p",null,[s("code",null,"project_descriptor"),t(),s("strong",null,"string"),s("br"),t(" Descriptor of the project, shown in the Admin App.")],-1),f=s("p",null,[s("code",null,"project_url"),t(),s("strong",null,"string"),s("br"),t(" Link to the (public) website that goes with this project.")],-1),b=s("p",null,[s("code",null,"project_color"),t(),s("strong",null,"string"),s("br"),t(" Brand color for the current project.")],-1),y=s("code",null,"project_logo",-1),x=s("strong",null,"many-to-one",-1),k=s("br",null,null,-1),w=s("code",null,"public_foreground",-1),q=s("strong",null,"many-to-one",-1),S=s("br",null,null,-1),A=s("code",null,"public_background",-1),T=s("strong",null,"many-to-one",-1),E=s("br",null,null,-1),v=s("p",null,[s("code",null,"public_note"),t(),s("strong",null,"string"),s("br"),t(" Note shown on the Admin App\u2019s public pages. Supports Markdown.")],-1),P=s("p",null,[s("code",null,"auth_login_attempts"),t(),s("strong",null,"integer"),s("br"),t(" How often a user is allowed to try to login. After which times the user will be suspended.")],-1),R=s("p",null,[s("code",null,"auth_password_policy"),t(),s("strong",null,"RegEx"),s("br"),t(" What regex passwords must pass in order to be valid.")],-1),C=s("code",null,"storage_asset_transform",-1),D=s("strong",null,"string",-1),M=s("br",null,null,-1),Q=s("code",null,"all",-1),B=s("code",null,"none",-1),G=s("code",null,"presets",-1),I=s("code",null,"storage_asset_presets",-1),L=s("strong",null,"array",-1),N=s("br",null,null,-1),O=s("p",null,[s("code",null,"custom_css"),t(),s("strong",null,"string"),s("br"),t(" CSS rules to override the App\u2019s default styling.")],-1),H=s("p",null,[s("code",null,"storage_default_folder"),t(),s("strong",null,"uuid"),s("br"),t(" Folder for uploaded files. Does not affect existing files.")],-1),V=s("p",null,[s("code",null,"basemaps"),t(),s("strong",null,"array"),s("br"),t(" Custom tiles to overriding the Mapbox defaults.")],-1),W=s("p",null,[s("code",null,"mapbox_key"),t(),s("strong",null,"string"),s("br"),s("a",{href:"https://docs.mapbox.com/help/glossary/access-token",target:"_blank",rel:"noopener noreferrer"},"Mapbox Access Token"),t(".")],-1),F=s("p",null,[s("code",null,"module_bar"),t(),s("strong",null,"array"),s("br"),t(" What modules are enabled/added globally.")],-1),U=s("p",null,[s("code",null,"translation_strings"),t(),s("strong",null,"array"),s("br"),t(" The key and translations for Translation Strings.")],-1),z=s("code",null,"custom_aspect_ratios",-1),J=s("strong",null,"array",-1),K=s("br",null,null,-1),X=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-punctuation"},"{"),t(`
	`),s("span",{class:"hljs-attr"},'"data"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"{"),t(`
		`),s("span",{class:"hljs-attr"},'"id"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"1"),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"project_name"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Directus"'),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"project_descriptor"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Application"'),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"project_url"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"project_color"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"project_logo"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"public_foreground"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"public_background"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"public_note"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"auth_login_attempts"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"25"),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"auth_password_policy"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"storage_asset_transform"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"all"'),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"storage_asset_presets"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"["),t(`
			`),s("span",{class:"hljs-punctuation"},"{"),t(`
				`),s("span",{class:"hljs-attr"},'"key"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"small"'),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"fit"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"cover"'),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"width"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"200"),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"height"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"161"),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"quality"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"80"),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"withoutEnlargement"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),t(`
			`),s("span",{class:"hljs-punctuation"},"}"),t(`
		`),s("span",{class:"hljs-punctuation"},"]"),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"custom_css"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"storage_default_folder"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"basemaps"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"mapbox_key"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"module_bar"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"translation_strings"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"["),t(`
			`),s("span",{class:"hljs-punctuation"},"{"),t(`
				`),s("span",{class:"hljs-attr"},'"key"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"draft"'),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"translations"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"{"),t(`
					`),s("span",{class:"hljs-attr"},'"de-DE"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Entwurf"'),s("span",{class:"hljs-punctuation"},","),t(`
					`),s("span",{class:"hljs-attr"},'"en-US"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Draft"'),t(`
				`),s("span",{class:"hljs-punctuation"},"}"),t(`
			`),s("span",{class:"hljs-punctuation"},"}"),t(`
		`),s("span",{class:"hljs-punctuation"},"]"),s("span",{class:"hljs-punctuation"},","),t(`
		`),s("span",{class:"hljs-attr"},'"custom_aspect_ratios"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"["),t(`
			`),s("span",{class:"hljs-punctuation"},"{"),t(`
				`),s("span",{class:"hljs-attr"},'"text"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"16:10"'),s("span",{class:"hljs-punctuation"},","),t(`
				`),s("span",{class:"hljs-attr"},'"value"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"1.6"),t(`
			`),s("span",{class:"hljs-punctuation"},"}"),t(`
		`),s("span",{class:"hljs-punctuation"},"]"),t(`
	`),s("span",{class:"hljs-punctuation"},"}"),t(`
`),s("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),Y=s("hr",null,null,-1),Z=s("h2",{id:"retrieve-settings",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#retrieve-settings"},"#"),t(" Retrieve Settings")],-1),$=s("h3",{id:"query-parameters",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters"},"#"),t(" Query Parameters")],-1),ss=s("h3",{id:"returns",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns"},"#"),t(" Returns")],-1),ts=s("p",null,[t("Returns the "),s("a",{href:"#the-settings-object"},"settings object"),t(".")],-1),ns=s("h3",{id:"rest-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api"},"#"),t(" REST API")],-1),as=s("pre",null,[s("code",null,`GET /settings
`)],-1),ls=s("h3",{id:"graphql",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql"},"#"),t(" GraphQL")],-1),es=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),os=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),t(` {
	settings: directus_settings
}
`)])],-1),cs=s("h5",{id:"example",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example"},"#"),t(" Example")],-1),rs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),t(` {
	settings {
		project_name
	}
}
`)])],-1),ps=s("hr",null,null,-1),us=s("h2",{id:"update-settings",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#update-settings"},"#"),t(" Update Settings")],-1),is=s("h3",{id:"query-parameters-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-1"},"#"),t(" Query Parameters")],-1),hs=s("h3",{id:"request-body",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body"},"#"),t(" Request Body")],-1),ds=s("p",null,[t("A partial "),s("a",{href:"#the-settings-object"},"settings object"),t(".")],-1),_s=s("h3",{id:"returns-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-1"},"#"),t(" Returns")],-1),js=s("p",null,[t("Returns the "),s("a",{href:"#the-setting-object"},"settings object"),t(".")],-1),gs=s("h3",{id:"rest-api-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-1"},"#"),t(" REST API")],-1),ms=s("pre",null,[s("code",null,`PATCH /settings
`)],-1),fs=s("h5",{id:"example-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-1"},"#"),t(" Example")],-1),bs=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// PATCH /settings"),t(`

`),s("span",{class:"hljs-punctuation"},"{"),t(`
	`),s("span",{class:"hljs-attr"},'"project_url"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"https://example.com/"'),t(`
`),s("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),ys=s("h3",{id:"graphql-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-1"},"#"),t(" GraphQL")],-1),xs=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),ks=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),t(` {
	update_settings(data: update_directus_settings_input!): directus_settings
}
`)])],-1),ws=s("h5",{id:"example-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-2"},"#"),t(" Example")],-1),qs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),t(` {
	update_settings(data: { project_url: `),s("span",{class:"hljs-string"},'"https://example.com"'),t(` }) {
		project_name
		project_url
	}
}
`)])],-1),vs="Settings",Ps=!1,Rs="REST and GraphQL API documentation on the Settings collection in Directus.",Cs="3 min read",Ds="page-reference",Ms={__name:"settings",setup(Ss,{expose:c}){const e={title:"Settings",modularExtension:!1,description:"REST and GraphQL API documentation on the Settings collection in Directus.",readTime:"3 min read",pageClass:"page-reference"};return c({frontmatter:e}),(As,Ts)=>{const a=o("router-link"),r=o("docs-wrapper");return p(),u(r,{frontmatter:e},{default:n(()=>[s("div",i,[h,d,_,j,g,m,f,b,s("p",null,[y,t(),x,k,t(" Primary logo for the current project. Many-to-one to "),l(a,{to:"/docs/reference/files"},{default:n(()=>[t("files")]),_:1}),t(".")]),s("p",null,[w,t(),q,S,t(" Foreground image for the Admin App\u2019s public pages. Many-to-one to "),l(a,{to:"/docs/reference/files"},{default:n(()=>[t("files")]),_:1}),t(".")]),s("p",null,[A,t(),T,E,t(" Background image for the Admin App\u2019s public pages. Many-to-one to "),l(a,{to:"/docs/reference/files"},{default:n(()=>[t("files")]),_:1}),t(".")]),v,P,R,s("p",null,[C,t(),D,M,t(" If the transform endpoints are allowed to be used on "),l(a,{to:"/docs/reference/files#requesting-a-thumbnail"},{default:n(()=>[t("the assets endpoint")]),_:1}),t(". One of "),Q,t(", "),B,t(" or "),G,t(".")]),s("p",null,[I,t(),L,N,t(" What preset keys exist in "),l(a,{to:"/docs/reference/files#requesting-a-thumbnail"},{default:n(()=>[t("the assets endpoint")]),_:1}),t(".")]),O,H,V,W,F,U,s("p",null,[z,t(),J,K,t(" Custom aspect ratios in the "),l(a,{to:"/docs/app/file-library#edit-an-image"},{default:n(()=>[t("image editor")]),_:1}),t(".")]),X,Y,Z,$,s("p",null,[t("Supports all "),l(a,{to:"/docs/reference/query"},{default:n(()=>[t("global query parameters")]),_:1}),t(".")]),ss,ts,ns,as,ls,es,os,cs,rs,ps,us,is,s("p",null,[t("Supports all "),l(a,{to:"/docs/reference/query"},{default:n(()=>[t("global query parameters")]),_:1}),t(".")]),hs,ds,_s,js,gs,ms,fs,bs,ys,xs,ks,ws,qs])]),_:1})}}};export{Ms as default,Rs as description,Ps as modularExtension,Ds as pageClass,Cs as readTime,vs as title};
