/**
 * Basically the same as `get` from `lodash`, but will convert nested array values to arrays, so for example:
 *
 * @example
 * ```js
 * const obj = { value: [{ example: 1 }, { example: 2 }]}
 * get(obj, 'value.example');
 * // => [1, 2]
 * ```
 */
export declare function get(object: Record<string, any> | any[], path: string, defaultValue?: unknown): any;
//# sourceMappingURL=get-with-arrays.d.ts.map