import{a as l,o as r,e as d,y as i,u as t,q as e,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const h={class:"markdown-body"},u=t("blockquote",null,[t("p",null,[e("This module provides a collective timeline of all "),t("em",null,"data-changing"),e(" actions taken within your project. These detailed records help you audit user activity and enforce accountability.")])],-1),p={class:"tip hint"},m=t("div",{class:"hint-title"},"Before You Begin",-1),v={class:"tip hint"},y=t("div",{class:"hint-title"},"Learn More",-1),f=t("h2",{id:"overview",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#overview"},"#"),e(" Overview")],-1),g=t("video",{title:"Activity Log Overview",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/activity-log/activity-log-20220816/activity-log-20220816A.mp4",type:"video/mp4"})],-1),_=t("div",{class:"warning hint"},[t("div",{class:"hint-title"},"External Changes"),t("p",null,[e("The platform can only track the events which actually pass through it. Therefore, any changes made to the database "),t("em",null,"directly"),e(" are not tracked.")])],-1),w={class:"tip hint"},b=t("em",null,"specific items",-1),T=t("strong",null,"Item Page > Sidebar > Revisions",-1),A=t("h2",{id:"view-an-activity-log-item",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#view-an-activity-log-item"},"#"),e(" View an Activity Log Item")],-1),k=t("p",null,[t("img",{src:"https://cdn.directus.io/docs/v9/configuration/activity-log/activity-log-20220816/activity-log-default-fields-20220816A.webp",alt:"Activity Log Default Fields"})],-1),C=t("p",null,"Click any item in the Activity Log and a side drawer will open, displaying its logged details. The following information is stored for each item.",-1),L=t("ul",null,[t("li",null,[t("strong",null,"User"),e(" \u2014 The user that performed the action.")]),t("li",null,[t("strong",null,"Action"),e(" \u2014 The specific action taken "),t("em",null,"(e.g., Create, Update, Delete, Comment, or Login)"),e(".")]),t("li",null,[t("strong",null,"TimeStamp"),e(" \u2014 The timestamp of when the action was performed.")]),t("li",null,[t("strong",null,"IP Address"),e(" \u2014 The IP address of the device from which the action was performed.")]),t("li",null,[t("strong",null,"User Agent"),e(" \u2014 The description of the browser that was used to perform the action.")]),t("li",null,[t("strong",null,"Collection"),e(" \u2014 The Collection affected by the action.")]),t("li",null,[t("strong",null,"Item"),e(" \u2014 The ID of the item affected.")]),t("li",null,[t("strong",null,"Comment"),e(" \u2014 The comment left by the user "),t("em",null,"(when applicable)"),e(".")])],-1),x=t("h2",{id:"filter-by-activity",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#filter-by-activity"},"#"),e(" Filter by Activity")],-1),I=t("video",{title:"Filter by Activity",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/activity-log/activity-log-20220816/filter-by-activity-20220817A.mp4",type:"video/mp4"})],-1),B=t("h2",{id:"modify-an-activity",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#modify-an-activity"},"#"),e(" Modify an Activity")],-1),P=t("video",{title:"Filter by Activity",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/activity-log/activity-log-20220816/modify-an-activity-20220817A.mp4",type:"video/mp4"})],-1),N=t("p",null,[e("To ensure proper accountability, system collections are "),t("strong",null,"read only"),e(" by design. However, users with an Admin role have the ability to reopen, view, and modify an item\u2019s values in activities from non-system collections (where the name does not begin with "),t("code",null,"directus_"),e("). To view or modify an activity, follow these steps.")],-1),D=t("ol",null,[t("li",null,"Navigate to the Activity Log page."),t("li",null,"Click the desired item. A drawer will open, displaying its activity log."),t("li",null,[e("Click "),t("span",{mi:"",btn:""},"launch"),e(" to reopen the item page and make modifications as desired.")]),t("li",null,[e("In the page header, click "),t("span",{mi:"",btn:""},"check"),e(" to confirm.")])],-1),F=t("p",null,"Once confirmed, any updates to an item will be logged as a new activity.",-1),E="Activity Log",O=!1,S="This module provides a collective timeline of all actions taken within the project. These detailed records allow for auditing user activity and enforcing accountability.",U="2 min read",R={__name:"activity-log",setup(M,{expose:s}){const a={title:"Activity Log",modularExtension:!1,description:"This module provides a collective timeline of all actions taken within the project. These detailed records allow for auditing user activity and enforcing accountability.",readTime:"2 min read"};return s({frontmatter:a}),(V,j)=>{const o=l("router-link"),c=l("docs-wrapper");return r(),d(c,{frontmatter:a},{default:i(()=>[t("div",h,[u,t("div",p,[m,t("p",null,[e("We recommend you try the "),n(o,{to:"/docs/getting-started/quickstart.md"},{default:i(()=>[e("Quickstart Guide")]),_:1}),e(" to get an overview of the platform.")])]),t("div",v,[y,t("p",null,[e("To manage the Activity Log programmatically, please see our guide on the "),n(o,{to:"/docs/reference/system/activity.md"},{default:i(()=>[e("Activity Log API")]),_:1}),e(".")])]),f,g,t("p",null,[e("The Activity Log is the only Module in Directus Core that is not found in the "),n(o,{to:"/docs/app/overview#_1-module-bar"},{default:i(()=>[e("Module Bar")]),_:1}),e(". Instead, it is accessed via the notifications tray of the "),n(o,{to:"/docs/app/overview#_4-sidebar"},{default:i(()=>[e("Sidebar")]),_:1}),e(". The Activity Log page has the same features and functionality as the "),n(o,{to:"/docs/app/content/collections"},{default:i(()=>[e("Collection Page")]),_:1}),e(".")]),_,t("div",w,[t("p",null,[e("You can also view and revert the activity of "),b,e(" under "),T,e(". To learn more, please see "),n(o,{to:"/docs/app/content/items#revert-an-item"},{default:i(()=>[e("Revert an Item")]),_:1}),e(".")])]),A,k,C,L,x,I,t("p",null,[e("In addition to the filter and display functionality inherited from the "),n(o,{to:"/docs/app/content/collections"},{default:i(()=>[e("Collection Page")]),_:1}),e(", you can also filter items by activity from the Navigation Bar.")]),B,P,N,D,F])]),_:1})}}};export{R as default,S as description,O as modularExtension,U as readTime,E as title};
