import{a as n,o,e as i,y as l,u as e,q as a}from"./runtime-core.esm-bundler.22ec0346.js";const c=e("div",{class:"markdown-body"},[e("blockquote",null,[e("p",null,[e("strong",null,"The core concepts behind Directus are simple, however the problems that must be solved to honor them can be remarkably complex."),a(" We strive to design and engineer the most elegant solutions possible, so that our codebase remains accessible.")])]),e("h2",{id:"monorepo",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#monorepo"},"#"),a(" Monorepo")]),e("p",null,[a("The primary Directus repository is located at "),e("a",{href:"https://github.com/directus/directus",target:"_blank",rel:"noopener noreferrer"},[e("code",null,"directus/directus")]),a(" and houses the Admin App (Vue.js 3 w/ Composition API), API (Node.js), API Specification (OpenAPI), and other smaller packages used internally. Directus follows a monorepo design similar to React or Babel \u2014 this page will outline our monorepo\u2019s design and structure.")]),e("h2",{id:"%2Fapi",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi"},"#"),a(),e("code",null,"/api")]),e("p",null,"Contains the Directus API (REST+GraphQL), written in Node.js."),e("h4",{id:"%2Fapi%2Fsrc%2Fcli",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fcli"},"#"),a(),e("code",null,"/api/src/cli")]),e("p",null,[a("The CLI commands and matching functions that the "),e("code",null,"directus"),a(" package ships with.")]),e("h4",{id:"%2Fapi%2Fsrc%2Fcontrollers",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fcontrollers"},"#"),a(),e("code",null,"/api/src/controllers")]),e("p",null,"Route handler controllers for the endpoints in the API."),e("h4",{id:"%2Fapi%2Fsrc%2Fdatabase",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fdatabase"},"#"),a(),e("code",null,"/api/src/database")]),e("p",null,"Database manipulation abstraction, system migrations, and system data. Also where you\u2019d find the main query runner."),e("h4",{id:"%2Fapi%2Fsrc%2Fexceptions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fexceptions"},"#"),a(),e("code",null,"/api/src/exceptions")]),e("p",null,"Classes for the different errors the API is expected to throw. Used to set the HTTP status and error codes."),e("h4",{id:"%2Fapi%2Fsrc%2Fmiddleware",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fmiddleware"},"#"),a(),e("code",null,"/api/src/middleware")]),e("p",null,"Various (express) routing middleware. Includes things like cache-checker, authenticator, etc."),e("h4",{id:"%2Fapi%2Fsrc%2Fservices",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Fservices"},"#"),a(),e("code",null,"/api/src/services")]),e("p",null,"Internal services. The main abstraction for interfacing with the data in the database. Both GraphQL and REST requests are \u201Ctranslated\u201D to use these services as the main logic in the platform."),e("h4",{id:"%2Fapi%2Fsrc%2Ftypes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Ftypes"},"#"),a(),e("code",null,"/api/src/types")]),e("p",null,"TypeScript types that are shared between the different parts of the API."),e("h4",{id:"%2Fapi%2Fsrc%2Futils",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapi%2Fsrc%2Futils"},"#"),a(),e("code",null,"/api/src/utils")]),e("p",null,"Various utility functions."),e("h2",{id:"%2Fapp",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp"},"#"),a(),e("code",null,"/app")]),e("p",null,"Contains the Directus Admin App, written in Vue.js 3 w/ the Composition API."),e("h4",{id:"%2Fapp%2Fpublic",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fpublic"},"#"),a(),e("code",null,"/app/public")]),e("p",null,"Assets that are included with the app, but not bundled."),e("h4",{id:"%2Fapp%2Fsrc%2Fassets",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fassets"},"#"),a(),e("code",null,"/app/src/assets")]),e("p",null,"Files that are included within the app. Are bundled / optimized in the build step."),e("h4",{id:"%2Fapp%2Fsrc%2Fcomponents",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fcomponents"},"#"),a(),e("code",null,"/app/src/components")]),e("p",null,"(Base) components that are used across the platform. Contains \u201Cbasic building blocks\u201D like button, input, etc."),e("h4",{id:"%2Fapp%2Fsrc%2Fcomposables",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fcomposables"},"#"),a(),e("code",null,"/app/src/composables")]),e("p",null,"Reusable parts of reactive logic that can be used between Vue components. Includes things reactively calculating time from now, fetching a single item, etc."),e("h4",{id:"%2Fapp%2Fsrc%2Fdirectives",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fdirectives"},"#"),a(),e("code",null,"/app/src/directives")]),e("p",null,[a("Custom Vue directives (e.g. "),e("code",null,"v-tooltip"),a(").")]),e("h4",{id:"%2Fapp%2Fsrc%2Fdisplays",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fdisplays"},"#"),a(),e("code",null,"/app/src/displays")]),e("p",null,"Components to display of data within the app."),e("h4",{id:"%2Fapp%2Fsrc%2Finterfaces",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Finterfaces"},"#"),a(),e("code",null,"/app/src/interfaces")]),e("p",null,"The core-included interfaces."),e("h4",{id:"%2Fapp%2Fsrc%2Flang",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Flang"},"#"),a(),e("code",null,"/app/src/lang")]),e("p",null,[a("Translations abstraction, and language files. The language yaml files are maintained through "),e("a",{href:"https://locales.directus.io",target:"_blank",rel:"noopener noreferrer"},"Crowdin"),a(".")]),e("h4",{id:"%2Fapp%2Fsrc%2Flayouts",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Flayouts"},"#"),a(),e("code",null,"/app/src/layouts")]),e("p",null,"The core-included layouts."),e("h4",{id:"%2Fapp%2Fsrc%2Fmodules",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fmodules"},"#"),a(),e("code",null,"/app/src/modules")]),e("p",null,"The core-included modules."),e("h4",{id:"%2Fapp%2Fsrc%2Froutes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Froutes"},"#"),a(),e("code",null,"/app/src/routes")]),e("p",null,"The routes in the app. Modules define their own routes, so this only includes the \u201Csystem\u201D things that don\u2019t belong to module, like login."),e("h4",{id:"%2Fapp%2Fsrc%2Fstores",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fstores"},"#"),a(),e("code",null,"/app/src/stores")]),e("p",null,[e("a",{href:"https://pinia.esm.dev",target:"_blank",rel:"noopener noreferrer"},"Pinia"),a(" based stores used for global state tracking.")]),e("h4",{id:"%2Fapp%2Fsrc%2Fstyles",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fstyles"},"#"),a(),e("code",null,"/app/src/styles")]),e("p",null,"Global styles in the app. Every component has their own component styles, these are just the global styles."),e("h4",{id:"%2Fapp%2Fsrc%2Ftypes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Ftypes"},"#"),a(),e("code",null,"/app/src/types")]),e("p",null,"TypeScript types that are shared between the different parts of the API."),e("h4",{id:"%2Fapp%2Fsrc%2Futils",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Futils"},"#"),a(),e("code",null,"/app/src/utils")]),e("p",null,"Utility functions used in various parts of the app."),e("h4",{id:"%2Fapp%2Fsrc%2Fviews",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fapp%2Fsrc%2Fviews"},"#"),a(),e("code",null,"/app/src/views")]),e("p",null,"The (two) main views used in the app: public / private. Also contains \u201Cinternal\u201D coupled components for those two views."),e("h2",{id:"%2Fpackages",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Fpackages"},"#"),a(),e("code",null,"/packages")]),e("p",null,"The various sub-packages of the platform. Including the file-storage adapters, schema, specs, etc."),e("h2",{id:"%2Ftests",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#%2Ftests"},"#"),a(),e("code",null,"/tests")]),e("p",null,"Tests are maintained on a per-package base. This folder contains the platform-wide (end-to-end) tests.")],-1),F="Codebase Overview",b=!1,m="The core concepts behind Directus are simple, however the problems that must be solved to honor them can be remarkably complex. We strive to design and engineer the most elegant solutions possible, so that our codebase remains accessible.",f="3 min read",g={__name:"codebase-overview",setup(p,{expose:t}){const s={title:"Codebase Overview",modularExtension:!1,description:"The core concepts behind Directus are simple, however the problems that must be solved to honor them can be remarkably complex. We strive to design and engineer the most elegant solutions possible, so that our codebase remains accessible.",readTime:"3 min read"};return t({frontmatter:s}),(d,h)=>{const r=n("docs-wrapper");return o(),i(r,{frontmatter:s},{default:l(()=>[c]),_:1})}}};export{g as default,m as description,b as modularExtension,f as readTime,F as title};
