import{a as s,o as d,e as r,y as o,u as t,q as e,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=t("blockquote",null,[t("p",null,"Collections are a set of items. This can be a 1-1 data table in SQL, a group of other collections, or a readonly view. They come with all the same power and functionality of data tables, despite the less technical name.")],-1),p=t("h2",{id:"overview",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#overview"},"#"),e(" Overview")],-1),f=t("video",{title:"Overview",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/data-model-20220805/collections-20220805A.mp4",type:"video/mp4"})],-1),_=t("h2",{id:"system-collections",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#system-collections"},"#"),e(" System Collections")],-1),m=t("video",{title:"System Collections",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/system-collections-20220805A.mp4",type:"video/mp4"})],-1),g=t("p",null,"System collections store the data and configuration details required to power your project.",-1),y=t("p",null,[e("Since system collections store information that powers your Directus project. You cannot reconfigure system collections or any of their default fields, as any reconfigurations would break your project. However, you "),t("em",null,"can"),e(" create and configure new fields on a system collection. This lets you safely customize your data model as desired.")],-1),v=t("p",null,"System collections are not displayed in the Content Module. The following table will go over the logic and functionality each system collection is responsible for, as well as where to find relevant App and API documentation.",-1),w=t("thead",null,[t("tr",null,[t("th",null,"System Collection"),t("th",null,"Purpose"),t("th",null,"APP"),t("th",null,"API")])],-1),b=t("td",null,"Activity",-1),S=t("td",null,"Tracks and stores all events within Directus, giving full accountability over everything.",-1),C=t("td",null,"Collections",-1),T=t("td",null,"Stores data table & configuration details each and every Collection.",-1),k=t("td",null,"Dashboards",-1),A=t("td",null,"Stores dashboard configuration details and all relationally linked panels.",-1),D=t("td",null,[t("strong",null,"N/A")],-1),F=t("td",null,"Fields",-1),I=t("td",null,"Stores configuration details for each field.",-1),x=t("td",null,"Files",-1),N=t("td",null,"This stores file location from asset storage as well as any data associated with that file.",-1),P=t("td",null,"Flows",-1),M=t("td",null,"Stores basic logic required for Flows, which enable event-triggered task automation.",-1),O=t("td",null,"Folders",-1),R=t("td",null,"Stores information required for Folders, which provide virtual file asset management.",-1),j=t("tr",null,[t("td",null,"Migrations"),t("td",null,"Used by our install/upgrade process to track when migration scripts for a specific release have been run."),t("td",null,"It has no relevant app functionality."),t("td",null,[t("strong",null,"N/A")])],-1),B=t("td",null,"Notifications",-1),L=t("td",null,"Stores details about in-app notifications.",-1),U=t("td",null,"Operations",-1),H=t("td",null,[e("Stores information required for Operations, which are a part of "),t("a",{href:"#flows"},"Flows"),e(".")],-1),V=t("td",null,"Panels",-1),q=t("td",null,[e("This stores information about individual analytics panels, which are displayed on "),t("a",{href:"#dashboards"},"Dashboards"),e(".")],-1),E=t("td",null,[t("strong",null,"N/A")],-1),W=t("td",null,"Permissions",-1),K=t("td",null,"This stores the access permissions configured for roles.",-1),Q=t("td",null,"Presets",-1),Y=t("td",null,"This stores details for presets and bookmarks.",-1),z=t("td",null,"Relations",-1),G=t("td",null,"This stores information about relationships between collections.",-1),J=t("td",null,"Revisions",-1),X=t("td",null,"Revisions are changes/edits made to Items. Directus keeps track of edits made, so you\u2019re able to revert to a previous state at will.",-1),Z=t("td",null,"Roles",-1),$=t("td",null,"Stores information about each role created.",-1),tt=t("tr",null,[t("td",null,"Sessions"),t("td",null,"Stores information about each user session, for system purposes."),t("td",null,[t("strong",null,"N/A")]),t("td",null,[t("strong",null,"N/A")])],-1),et=t("td",null,"Settings",-1),ot=t("td",null,[e("Stores all configurations made within "),t("strong",null,"Settings > Project Settings"),e(".")],-1),lt=t("td",null,"Shares",-1),nt=t("td",null,"Stores all information regarding data shares.",-1),it=t("td",null,null,-1),st=t("td",null,"Users",-1),at=t("td",null,"Stores information about each user within the platform.",-1),ct=t("td",null,"Webhooks",-1),dt=t("td",null,"Stores all information about configured webhooks.",-1),rt=t("h2",{id:"create-a-collection",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#create-a-collection"},"#"),e(" Create a Collection")],-1),ut=t("video",{title:"Create a Collection",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:`https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/create-a-collection-20220805A.mp4
`,type:"video/mp4"})],-1),ht=t("p",null,"To create a collection, follow these steps.",-1),pt=t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(", click "),t("span",{mi:"",btn:""},"add"),e(" in the page header, and a drawer will open.")],-1),ft=t("li",null,[e("Enter a unique "),t("strong",null,"Collection Name"),e(". This cannot be modified later, but can be translated."),t("br"),e(" This is used as the data table key, API collection key, and default collection name.")],-1),_t=t("li",null,[t("strong",null,"Singleton"),e(" \u2014 Toggles whether the collection is a "),t("a",{href:"#collection-setup"},"Singleton"),e(".")],-1),mt=t("li",null,[t("strong",null,"Primary Key Field"),e(" \u2014 Sets the name of the primary key field, defaults to "),t("code",null,"id"),e(".")],-1),gt=t("strong",null,"Type",-1),yt=t("li",null,[e("Click "),t("span",{mi:"",btn:""},"arrow_forward"),e(" to confirm.")],-1),vt=t("li",null,[e("Enable and rename the other Optional System Fields as desired: "),t("ul",null,[t("li",null,[t("strong",null,"Status"),e(" \u2014 Stores item status.")]),t("li",null,[t("strong",null,"Sort"),e(" \u2014 Adds a field which enables drag-and-drop sorting of items.")]),t("li",null,[t("strong",null,"Created On"),e(" \u2014 Logs the date an item was created.")]),t("li",null,[t("strong",null,"Created By"),e(" \u2014 Logs the user that created this item.")]),t("li",null,[t("strong",null,"Updated On"),e(" \u2014 Logs the date an item was last updated.")]),t("li",null,[t("strong",null,"Updated By"),e(" \u2014 Stores the last user to edit the file.")])])],-1),wt=t("li",null,[e("Click "),t("span",{mi:"",btn:""},"check"),e(" to confirm and create the collection.")],-1),bt=t("div",{class:"danger hint"},[t("div",{class:"hint-title"},"Immutable Keys"),t("p",null,[e("The collection name from step two cannot be modified after collection creation. However, you can override how it is displayed with "),t("a",{href:"#collection-setup"},"Collection Naming Translations"),e(".")])],-1),St=t("div",{class:"warning hint"},[t("div",{class:"hint-title"},"Composite Keys"),t("p",null,"Directus does not currently support composite keys. If your project uses composite keys, you will need to make an adjustment to the data model.")],-1),Ct=t("div",{class:"warning hint"},[t("div",{class:"hint-title"},"SQL Views"),t("p",null,"Directus does not currently support creation of virtual tables via SQL Views.")],-1),Tt=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Database Tables"),t("p",null,[e("Remember, a collection is simply a database table. Therefore, you can import or create a table directly in the database and it will automatically appear within your Directus project. The first time you manage that table, a "),t("code",null,"directus_collections"),e(" record will be created with default values.")])],-1),kt=t("h2",{id:"toggle-collection-visibility",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#toggle-collection-visibility"},"#"),e(" Toggle Collection Visibility")],-1),At=t("video",{title:"Hide a Collection",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/toggle-collection-visibility-20220805A.mp4",type:"video/mp4"})],-1),Dt=t("p",null,"To toggle whether a collection is hidden by default in the Content Module, follow these steps.",-1),Ft=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(".")]),t("li",null,[e("Click "),t("span",{mi:"",icon:""},"more_vert"),e(" to open the collection\u2019s Context Menu.")]),t("li",null,[e("Select "),t("strong",null,"View Content"),e(" or "),t("strong",null,"Make Collection Hidden"),e(" to adjust visibility as desired.")])],-1),It={class:"tip hint"},xt=t("span",{mi:"",icon:""},"visibility",-1),Nt=t("strong",null,"Show Hidden Collections",-1),Pt=t("h2",{id:"create-a-folder",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#create-a-folder"},"#"),e(" Create a Folder")],-1),Mt=t("video",{title:"Create a Folder",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/create-a-folder-20220805A.mp4",type:"video/mp4"})],-1),Ot=t("p",null,[e("Folders allow you to sub-nest and group how collections are displayed. This feature simply changes how the collections are displayed under "),t("strong",null,"Settings > Data Model"),e(" and in the Content Module. It has no impact on the data model. To create a folder, follow these steps.")],-1),Rt=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(".")]),t("li",null,[e("Click "),t("span",{mi:"",btn:"",muted:""},"create_new_folder"),e(" in the page header.")]),t("li",null,"Set a folder key, which will also be used as the folder\u2019s name."),t("li",null,"Optional: Set the folder icon, color, note and translations as desired."),t("li",null,[e("Click "),t("strong",null,"Save"),e(" to create your folder.")])],-1),jt=t("h2",{id:"toggle-folder-display",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#toggle-folder-display"},"#"),e(" Toggle Folder Display")],-1),Bt=t("video",{title:"Toggle Folder Display",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/toggle-folder-display-20220805A.mp4",type:"video/mp4"})],-1),Lt=t("p",null,"To toggle folder display, follow these steps.",-1),Ut=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(".")]),t("li",null,[e("Click "),t("span",{mi:"",icon:""},"folder"),e(" on the desired collection to toggle the following displays: "),t("ul",null,[t("li",null,[t("strong",null,"Start Open")]),t("li",null,[t("strong",null,"Start Collapsed")]),t("li",null,[t("strong",null,"Always Open")])])])],-1),Ht=t("h2",{id:"sort-and-nest-collections",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#sort-and-nest-collections"},"#"),e(" Sort and Nest Collections")],-1),Vt=t("video",{title:"Configure a Collection",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/sort-and-nest-collections.mp4",type:"video/mp4"})],-1),qt=t("p",null,[e("To sort and nest collections in "),t("strong",null,"Settings > Data Model"),e(" and "),t("strong",null,"Content Module"),e(", follow these steps.")],-1),Et=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(".")]),t("li",null,[e("Click and drag "),t("span",{mi:"",icon:""},"drag_handle"),e(" to position collections as desired."),t("br"),e(" To nest a collection, drag below and to the right of an intended parent folder or collection.")])],-1),Wt=t("h2",{id:"configure-a-collection",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#configure-a-collection"},"#"),e(" Configure a Collection")],-1),Kt=t("video",{title:"Configure a Collection",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/configure-a-collection-20220805A.mp4",type:"video/mp4"})],-1),Qt=t("p",null,"To configure a collection, follow these steps.",-1),Yt=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model"),e(" and click the desired collection."),t("br"),e(" The collection\u2019s configuration page will open.")]),t("li",null,[e("Make configurations as desired. Configuration options are broken into six categories. "),t("ul",null,[t("li",null,[t("a",{href:"#fields-layout"},"Fields and Layout")]),t("li",null,[t("a",{href:"#collection-setup"},"Collection Setup")]),t("li",null,[t("a",{href:"#archive"},"Archive")]),t("li",null,[t("a",{href:"#sort-field"},"Sort")]),t("li",null,[t("a",{href:"#accountability"},"Accountability")]),t("li",null,[t("a",{href:"#duplication"},"Duplication")])])]),t("li",null,[e("Click "),t("span",{mi:"",btn:""},"check"),e(" to confirm.")])],-1),zt=t("h3",{id:"fields-%26-layout",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#fields-%26-layout"},"#"),e(" Fields & Layout")],-1),Gt=t("video",{title:"Fields and Layout",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/fields-and-layout-20220805A.mp4",type:"video/mp4"})],-1),Jt=t("h3",{id:"collection-setup",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#collection-setup"},"#"),e(" Collection Setup")],-1),Xt=t("video",{title:"Collection Setup",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/collection-setup-20220805A.mp4",type:"video/mp4"})],-1),Zt=t("p",null,"These controls allow you to modify how the collection is displayed within the Content Module.",-1),$t=t("li",null,[t("strong",null,"Collection Name"),e(" \u2014 Displays the collection\u2019s name, which cannot be modified. However, you can override the displayed name with Collection Naming Translations, shown lower on this list.")],-1),te=t("li",null,[t("strong",null,"Note"),e(" \u2014 Set a helpful note that explains the collection\u2019s purpose.")],-1),ee=t("li",null,[t("strong",null,"Icon"),e(" \u2014 Set an icon used throughout the app when referencing this collection.")],-1),oe=t("li",null,[t("strong",null,"Color"),e(" \u2014 Set a color for the icon, shown in the Navigation Bar and its page header.")],-1),le=t("strong",null,"Display Template",-1),ne=t("li",null,[t("strong",null,"Hidden"),e(" \u2014 Toggle whether the collection should be globally hidden in the other app modules, even for admin users. You cannot hide collections for admins via permissions like other roles, so this comes in handy to tidy up the Content Module.")],-1),ie=t("strong",null,"Singleton",-1),se=t("strong",null,"Collection Naming Translations",-1),ae={class:"tip hint"},ce=t("div",{class:"hint-title"},"Collection Naming Translations",-1),de=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"What's a Singleton?"),t("p",null,[e("A collection that only contains one single item. For example, a website\u2019s "),t("strong",null,"About Us"),e(" page.")])],-1),re=t("h3",{id:"archive",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#archive"},"#"),e(" Archive")],-1),ue=t("video",{title:"Archive",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/archive-20220805A.mp4",type:"video/mp4"})],-1),he=t("p",null,[e("Selects a field to handle archiving items. This provides a "),t("em",null,"soft-delete"),e(" functionality for items in a collection. Archived items will still exist in the collection and database, but are filtered within the Data Studio. To configure an archive field, set the following four input fields as desired.")],-1),pe=t("li",null,[t("strong",null,"Archive Field"),e(" \u2014 Selects the archive field from a dropdown menu.")],-1),fe=t("strong",null,"Archive App Filter",-1),_e=t("strong",null,"Archive Value",-1),me=t("strong",null,"Unarchive Value",-1),ge=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Automatic Setup"),t("p",null,[e("When you "),t("a",{href:"#create-a-collection"},"create a collection"),e(", you have the option to create an optional Status Field. If you choose to include this field, the collection\u2019s archive settings will be automatically configured for you.")])],-1),ye=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Archive Field Values"),t("p",null,"The archive fields can contain any number of additional values besides the archived and unarchived values defined above.")],-1),ve=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Archived Item Management via API"),t("p",null,"Archived items are hidden in the app by default, but they are still returned normally via the API unless explicitly filtered out. This gives you the flexibility to manage archived items however you want when working with the API.")],-1),we=t("h3",{id:"sort-field",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#sort-field"},"#"),e(" Sort Field")],-1),be=t("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Batch Edit Items"},[t("source",{src:"https://cdn.directus.io/docs/v9/app-guide/content/content-collections/content-collections-20220415A/manually-sort-items-20220415A.mp4",type:"video/mp4"})],-1),Se=t("strong",null,"Content Module > Collection Page",-1),Ce=t("code",null,"INTEGER",-1),Te=t("p",null,[t("strong",null,"Sort Field"),e(" \u2014 Select a field to custom sort and order items. Click "),t("strong",null,"Deselect"),e(" to disable.")],-1),ke=t("p",null,"To configure a sort field, follow these steps.",-1),Ae=t("code",null,"INTEGER",-1),De=t("li",null,[e("Choose a field from the dropdown under "),t("strong",null,"Settings > Data Model > [Collection] > Sort"),e(".")],-1),Fe=t("li",null,[e("Click "),t("span",{mi:"",btn:""},"check"),e(" to confirm.")],-1),Ie={class:"tip hint"},xe=t("div",{class:"hint-title"},"Automatic Setup",-1),Ne=t("strong",null,"Sort",-1),Pe=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Interface Sorting"),t("p",null,[e("To configure manual sorting within a relational Interface (e.g., M2M, O2M, or M2A), configure as above, but also set the "),t("strong",null,"Sort Field"),e(" within the relationship section of the field\u2019s configuration drawer.")])],-1),Me=t("div",{class:"tip hint"},[t("div",{class:"hint-title"},"Configure to Hidden"),t("p",null,[e("You can also set this field to be "),t("strong",null,"Hidden"),e(" so it doesn\u2019t show up within the Item Details Page.")])],-1),Oe=t("h3",{id:"accountability",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#accountability"},"#"),e(" Accountability")],-1),Re=t("video",{title:"Accountability",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/acountability-20220805A.mp4",type:"video/mp4"})],-1),je=t("ul",null,[t("li",null,[t("strong",null,"Activity & Revision Tracking"),e(" \u2014 The following options are supported: "),t("ul",null,[t("li",null,[t("strong",null,"Track Activity & Revisions")]),t("li",null,[t("strong",null,"Only Track Activity")]),t("li",null,[t("strong",null,"Do Not Track Anything")])])])],-1),Be={class:"tip hint"},Le=t("div",{class:"hint-title"},"Accountability vs. Telemetry",-1),Ue=t("em",null,"who does what",-1),He=t("h3",{id:"duplication",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#duplication"},"#"),e(" Duplication")],-1),Ve=t("video",{title:"Duplication",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/duplicate-20220805A.mp4",type:"video/mp4"})],-1),qe=t("p",null,[e("The "),t("strong",null,"Save as Copy"),e(" option on the Item Details Page offers a way to effectively duplicate the current item. Since there may be unique or relational data within the item, it\u2019s important to control exactly what will be copied. Duplication lets you configure which parent & relational field values will be copied when you use "),t("strong",null,"Save as Copy"),e(" on an item.")],-1),Ee=t("ul",null,[t("li",null,[t("strong",null,"Item Duplication Fields"),e(" \u2014 Check the field(s) to copy values for when duplicating an item.")])],-1),We=t("h2",{id:"delete-a-collection",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#delete-a-collection"},"#"),e(" Delete a Collection")],-1),Ke=t("video",{title:"Delete a Collection",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[t("source",{src:"https://cdn.directus.io/docs/v9/configuration/data-model/collections/collections-20220805/delete-a-collection-20220805A.mp4",type:"video/mp4"})],-1),Qe=t("p",null,"To delete a collection, follow these steps.",-1),Ye=t("ol",null,[t("li",null,[e("Navigate to "),t("strong",null,"Settings > Data Model > [Collection Name]"),e(".")]),t("li",null,[e("Click "),t("span",{mi:"",btn:"",dngr:""},"delete"),e(" in the page header.")]),t("li",null,[e("Confirm this decision by clicking "),t("strong",null,"Delete"),e(" in the dialog.")])],-1),ze=t("div",{class:"danger hint"},[t("p",null,"This action is permanent and irreversible. Please proceed with caution.")],-1),$e="Collections",to=!1,eo={__name:"collections",setup(Ge,{expose:a}){const i={title:"Collections",modularExtension:!1};return a({frontmatter:i}),(Je,Xe)=>{const l=s("router-link"),c=s("docs-wrapper");return d(),r(c,{frontmatter:i},{default:o(()=>[t("div",u,[h,p,f,t("p",null,[e("Collections are data tables. Typically, you access items within a collection in the "),n(l,{to:"/docs/app/content"},{default:o(()=>[e("Content Module")]),_:1}),e(".")]),_,m,g,y,v,t("table",null,[w,t("tbody",null,[t("tr",null,[b,S,t("td",null,[n(l,{to:"/docs/configuration/activity-log"},{default:o(()=>[e("Activity Log")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/activity"},{default:o(()=>[e("Activity")]),_:1})])]),t("tr",null,[C,T,t("td",null,[n(l,{to:"/docs/configuration/data-model/collections"},{default:o(()=>[e("Collections")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/collections"},{default:o(()=>[e("Collections")]),_:1})])]),t("tr",null,[k,A,t("td",null,[n(l,{to:"/docs/app/insights"},{default:o(()=>[e("Insights")]),_:1})]),D]),t("tr",null,[F,I,t("td",null,[n(l,{to:"/docs/configuration/data-model/fields/"},{default:o(()=>[e("Fields")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/fields"},{default:o(()=>[e("Fields")]),_:1})])]),t("tr",null,[x,N,t("td",null,[n(l,{to:"/docs/app/file-library"},{default:o(()=>[e("File Library")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/files"},{default:o(()=>[e("Files")]),_:1})])]),t("tr",null,[P,M,t("td",null,[n(l,{to:"/docs/configuration/flows"},{default:o(()=>[e("Flows")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/flows"},{default:o(()=>[e("Flows")]),_:1})])]),t("tr",null,[O,R,t("td",null,[n(l,{to:"/docs/app/file-library#folders"},{default:o(()=>[e("Folders")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/folders"},{default:o(()=>[e("Folders")]),_:1})])]),j,t("tr",null,[B,L,t("td",null,[n(l,{to:"/docs/app/overview#_1-module-bar"},{default:o(()=>[e("Module Bar")]),_:1}),e(" and "),n(l,{to:"/docs/app/overview#_4-sidebar"},{default:o(()=>[e("Sidebar")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/notifications"},{default:o(()=>[e("Notifications")]),_:1})])]),t("tr",null,[U,H,t("td",null,[n(l,{to:"/docs/configuration/flows"},{default:o(()=>[e("Operations")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/operations.md"},{default:o(()=>[e("Operations")]),_:1})])]),t("tr",null,[V,q,t("td",null,[n(l,{to:"/docs/app/insights"},{default:o(()=>[e("Insights")]),_:1})]),E]),t("tr",null,[W,K,t("td",null,[n(l,{to:"/docs/configuration/users-roles-permissions"},{default:o(()=>[e("Users, Roles & Permissions")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/permissions"},{default:o(()=>[e("Permissions")]),_:1})])]),t("tr",null,[Q,Y,t("td",null,[n(l,{to:"/docs/configuration/presets-bookmarks"},{default:o(()=>[e("Presents & Bookmarks")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/presets"},{default:o(()=>[e("Presets")]),_:1})])]),t("tr",null,[z,G,t("td",null,[n(l,{to:"/docs/configuration/data-model/relationships"},{default:o(()=>[e("Relationships")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/relations"},{default:o(()=>[e("Relations")]),_:1})])]),t("tr",null,[J,X,t("td",null,[n(l,{to:"/docs/app/content/items#revert-an-item"},{default:o(()=>[e("Revert an Item")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/revisions"},{default:o(()=>[e("Revisions")]),_:1})])]),t("tr",null,[Z,$,t("td",null,[n(l,{to:"/docs/configuration/users-roles-permissions"},{default:o(()=>[e("Users, Roles, and Permissions")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/roles"},{default:o(()=>[e("Roles")]),_:1})])]),tt,t("tr",null,[et,ot,t("td",null,[n(l,{to:"/docs/configuration/project-settings"},{default:o(()=>[e("Project Settings")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/settings"},{default:o(()=>[e("settings")]),_:1})])]),t("tr",null,[lt,nt,t("td",null,[n(l,{to:"/docs/app/content/shares"},{default:o(()=>[e("Data Sharing")]),_:1})]),it]),t("tr",null,[st,at,t("td",null,[n(l,{to:"/docs/app/user-directory"},{default:o(()=>[e("User Directory")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/relations"},{default:o(()=>[e("Users")]),_:1})])]),t("tr",null,[ct,dt,t("td",null,[n(l,{to:"/docs/configuration/webhooks"},{default:o(()=>[e("Webhooks")]),_:1})]),t("td",null,[n(l,{to:"/docs/reference/system/relations"},{default:o(()=>[e("Webhooks")]),_:1})])])])]),rt,ut,ht,t("ol",null,[pt,ft,t("li",null,[e("Optional: Make any other configurations as desired. "),t("ul",null,[_t,mt,t("li",null,[gt,e(" \u2014 Sets the "),n(l,{to:"/docs/configuration/data-model/fields/#keys-and-ids"},{default:o(()=>[e("type of ID")]),_:1}),e(" to use for this collection.")])])]),yt,vt,wt]),bt,St,Ct,Tt,kt,At,Dt,Ft,t("div",It,[t("p",null,[e("Assuming a user has "),n(l,{to:"/docs/configuration/users-roles-permissions"},{default:o(()=>[e("access permissions")]),_:1}),e(", hidden collections can still be viewed. They must right-click on the Navigation Bar and choose "),xt,e(),Nt,e(".")])]),Pt,Mt,Ot,Rt,jt,Bt,Lt,Ut,Ht,Vt,qt,Et,Wt,Kt,Qt,Yt,zt,Gt,t("p",null,[e("This section allows you to create and configure fields, as well as configure how fields are displayed on the "),n(l,{to:"/docs/app/content/items"},{default:o(()=>[e("Item Details Page")]),_:1}),e(". To learn more, please see the documentation on "),n(l,{to:"/docs/configuration/data-model/fields/"},{default:o(()=>[e("fields")]),_:1}),e(".")]),Jt,Xt,Zt,t("ul",null,[$t,te,ee,oe,t("li",null,[le,e(" \u2014 Create a "),n(l,{to:"/docs/app/display-templates"},{default:o(()=>[e("Display Template")]),_:1}),e(" for the collection.")]),ne,t("li",null,[ie,e(" \u2014 Toggle to bypass the "),n(l,{to:"/docs/app/content/collections"},{default:o(()=>[e("Collection Page")]),_:1}),e(" and take users to the "),n(l,{to:"/docs/app/content/items"},{default:o(()=>[e("Item Details Page")]),_:1}),e(".")]),t("li",null,[se,e(" \u2014 Translate the collection name across multiple languages. When the default language is changed in "),n(l,{to:"/docs/configuration/project-settings#general"},{default:o(()=>[e("Project Settings")]),_:1}),e(" or "),n(l,{to:"/docs/app/user-directory#user-details-page"},{default:o(()=>[e("User Details Page")]),_:1}),e(", the relevant translation, if any exists, will be used throughout the app.")])]),t("div",ae,[ce,t("p",null,[e("By default, Directus uses the "),n(l,{to:"/docs/getting-started/glossary#title-formatter"},{default:o(()=>[e("Title Formatter")]),_:1}),e(" to display collection keys as human readable names, but you can also use translations to explicitly rename more technical table keys.")])]),de,re,ue,he,t("ul",null,[pe,t("li",null,[fe,e(" \u2014 Toggles whether app users can "),n(l,{to:"/docs/app/content/collections#view-archived-items"},{default:o(()=>[e("filter for archived items")]),_:1}),e(".")]),t("li",null,[_e,e(" \u2014 A value that is assigned to the field when an item is "),n(l,{to:"/docs/app/content/items#archive-an-item"},{default:o(()=>[e("archived")]),_:1}),e(".")]),t("li",null,[me,e(" \u2014 A value that is assigned to the field when an item is "),n(l,{to:"/docs/app/content/items#archive-an-item"},{default:o(()=>[e("unarchived")]),_:1}),e(".")])]),ge,ye,ve,we,be,t("p",null,[e("The sort feature enables users to "),n(l,{to:"/docs/app/content/collections#manually-sort-items"},{default:o(()=>[e("manually sort Items")]),_:1}),e(" within the Data Studio. This is typically shown on the "),Se,e(". It can also be used for sorting items within "),n(l,{to:"/docs/getting-started/glossary#junction-collections"},{default:o(()=>[e("Junction Collections")]),_:1}),e(". A standard field, configured with an "),Ce,e(" data type, is required. As shown in the video, fields which cannot serve as sort fields will be grayed out and unselectable in the Sort Field dropdown.")]),Te,ke,t("ol",null,[t("li",null,[n(l,{to:"/docs/configuration/data-model/fields/#create-a-field-standard"},{default:o(()=>[e("Create a Field")]),_:1}),e(" with an "),Ae,e(" data type.")]),De,Fe]),t("p",null,[e("Once you sort field is configured, you may want to learn how to "),n(l,{to:"/docs/app/content/collections#manually-sort-items"},{default:o(()=>[e("manually sort Items")]),_:1}),e(".")]),t("div",Ie,[xe,t("p",null,[e("When you "),n(l,{to:"/docs/configuration/data-model/collections#create-a-collection"},{default:o(()=>[e("create a Collection")]),_:1}),e(", you have the option of creating a "),Ne,e(" field. If you choose to include this field, the collection\u2019s sort settings will automatically be configured for you.")])]),Pe,Me,Oe,Re,t("p",null,[e("By default, your Directus Project tracks all "),n(l,{to:"/docs/reference/system/activity"},{default:o(()=>[e("activity")]),_:1}),e(" and "),n(l,{to:"/docs/reference/system/revisions"},{default:o(()=>[e("revisions")]),_:1}),e(" for collections. However, you can override this and choose what data is tracked.")]),je,t("div",Be,[Le,t("p",null,[e("Accountability is a log of "),Ue,e(" in your project. It is for your team\u2019s own use. This is different from "),n(l,{to:"/docs/self-hosted/config-options#telemetry"},{default:o(()=>[e("telemetry")]),_:1}),e(", which is configured under "),n(l,{to:"/docs/self-hosted/config-options#telemetry"},{default:o(()=>[e("environment variables")]),_:1}),e(".")])]),He,Ve,qe,Ee,We,Ke,Qe,Ye,ze])]),_:1})}}};export{eo as default,to as modularExtension,$e as title};
