import{a as n,o as d,e as c,y as t,u as e,q as l,z as o}from"./runtime-core.esm-bundler.22ec0346.js";const h={class:"markdown-body"},u=e("blockquote",null,[e("p",null,"The File Library Module aggregates all files within the Directus Project into one consolidated library. It is a full-featured Digital Asset Management (DAM) system for storing, organizing, browsing, and transforming your various files and assets.")],-1),p=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/file-library-20220307A.webp",alt:"File Library"})],-1),f={class:"warning hint"},m=e("div",{class:"hint-title"},"More Documents on Folder and File Management",-1),g=e("h2",{id:"how-it-works",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-it-works"},"#"),l(" How it Works")],-1),_={class:"tip hint"},y=e("div",{class:"hint-title"},"Required Knowledge",-1),b=e("a",{href:"#folders"},"Folder",-1),F=e("a",{href:"#files"},"Files",-1),v=e("em",null,"not just images",-1),w=e("a",{href:"#folders"},"File Listing Page",-1),k=e("video",{title:"How the File Library Works",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/how-it-works-20220305A.mp4",type:"video/mp4"}),e("p",null,[l(" Your browser is not displaying the video for some reason. Here's a "),e("a",{href:""},"link to the video"),l(" instead. ")])],-1),A=e("ol",null,[e("li",null,[l("Select a Folder. There are two options: "),e("ul",null,[e("li",null,"Choose desired Folder from the Navigation Bar."),e("li",null,[l("Click "),e("span",{mi:"",btn:"",sec:""},"create_new_folder"),l(" in the Page Header, name your folder, and click "),e("strong",null,"\u201CSave\u201D"),l(".")])])]),e("li",null,[l("Click "),e("span",{mi:"",btn:""},"add"),l(" in the Page Header. A popover will appear.")]),e("li",null,[l("Upload your file. You have 3 options: "),e("ul",null,[e("li",null,"Drag a file from your desktop to the popup."),e("li",null,"Click the popup area to manually select a file from your device."),e("li",null,[l("Click "),e("span",{mi:"",icon:""},"more_vert"),l(" in the popover and choose "),e("strong",null,"\u201CImport from URL\u201D"),l(".")])])]),e("li",null,"Optional: Click the File Display to open the File Details Page and fill in information as desired.")],-1),C=e("h2",{id:"files",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#files"},"#"),l(" Files")],-1),T=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/files-20220305A.webp",alt:"Files"})],-1),D=e("h3",{id:"action-buttons",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#action-buttons"},"#"),l(" Action Buttons")],-1),L=e("p",null,"Notice the following Buttons in the Header:",-1),P=e("ul",null,[e("li",null,[e("span",{mi:"",btn:""},"check"),l(" \u2013 Saves any edits made to the file.")]),e("li",null,[e("span",{mi:"",btn:"",sec:""},"tune"),l(" \u2013 Please see "),e("a",{href:"#edit-an-image"},"Edit an Image"),l(" to learn more.")]),e("li",null,[e("span",{mi:"",btn:"",sec:""},"save_alt"),l(" \u2013 Downloads the file to your current device.")]),e("li",null,[e("span",{mi:"",btn:"",sec:""},"drive_file_move"),l(" \u2013 Moves selected File(s) to another Folder.")]),e("li",null,[e("span",{mi:"",btn:"",dngr:""},"delete"),l(" \u2013 Permanently removes the File and its metadata. This action is permanent and cannot be undone.")])],-1),I=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Deleting Files Linked to Items"),e("p",null,[l("By default, Directus will not allow you to delete a File until you remove it from any and all related Items. However, this behavior can be reconfigured so that Files automatically update when the image is deleted by setting the relational constraint of your File Field to "),e("code",null,"SET NULL"),l(" or "),e("code",null,"CASCADE"),l(" when the File is deleted.")])],-1),x=e("h3",{id:"file-details",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#file-details"},"#"),l(" File Details")],-1),M=e("p",null,[l("The Files Collection comes pre-configured with the following Fields out of the box. New Fields can be created and customized as needed in "),e("strong",null,"Settings > Data Model"),l(". However the pre-configured Fields cannot be changed or deleted.")],-1),S=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/file-details-20220305A.webp",alt:"File Details"})],-1),E=e("ul",null,[e("li",null,[e("strong",null,"Preview"),l(" \u2013 A preview of the image or file.")]),e("li",null,[e("strong",null,"Title"),l(" \u2013 A title for the File.")]),e("li",null,[e("strong",null,"Description"),l(" \u2013 A description of the File.")]),e("li",null,[e("strong",null,"Tags"),l(" \u2013 Keywords used for search-ability.")]),e("li",null,[e("strong",null,"Location"),l(" \u2013 An optional location "),e("em",null,"(e.g. where a photo was taken)"),l(".")]),e("li",null,[e("strong",null,"Storage"),l(" \u2013 Which storage adapter is used to store the file asset.")]),e("li",null,[e("strong",null,"Filename (Disk)"),l(" \u2013 LOCKED. This is the actual name of the file in storage.")]),e("li",null,[e("strong",null,"Filename (Download)"),l(" \u2013 Allows you to set the name of the file when it is downloaded.")])],-1),U=e("h3",{id:"file-sidebar",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#file-sidebar"},"#"),l(" File Sidebar")],-1),H=e("p",null,"The file sidebar also includes the following details, which are not editable and serve as metadata.",-1),B=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/file-sidebar-20220305A.webp",alt:"File Sidebar"})],-1),N=e("ul",null,[e("li",null,[e("strong",null,"Type"),l(" \u2013 The MIME type of the file, displayed in the App as a formatted media type.")]),e("li",null,[e("strong",null,"Dimensions"),l(" \u2013 "),e("em",null,"Images only"),l(". The width and height of the image in pixels.")]),e("li",null,[e("strong",null,"Size"),l(" \u2013 The file-size the asset takes up in the storage adapter.")]),e("li",null,[e("strong",null,"Created"),l(" \u2013 The timestamp of when the file was uploaded to the Project.")]),e("li",null,[e("strong",null,"Owner"),l(" \u2013 The User that uploaded the file to the Project.")]),e("li",null,[e("strong",null,"Modified"),l(" \u2013 The timestamp of when the file was last modified.")]),e("li",null,[e("strong",null,"Edited By"),l(" \u2013 The User that modified the File.")]),e("li",null,[e("strong",null,"Folder"),l(" \u2013 The current parent folder that contains the File.")]),e("li",null,[e("strong",null,"Metadata"),l(" \u2013 Metadata JSON dump of the File\u2019s EXIF, IPTC, and ICC information.")])],-1),R=e("h2",{id:"edit-an-image",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#edit-an-image"},"#"),l(" Edit an Image")],-1),W=e("p",null,"Rotate, crop, flip, or adjust aspect ratios of an image.",-1),j=e("video",{alt:"Edit an Image",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220516A/edit-an-image-20220516A.mp4",type:"video/mp4"})],-1),z=e("ol",null,[e("li",null,[l("From the "),e("strong",null,"File Library"),l(", click a file to open its detail page.")]),e("li",null,[l("Click the "),e("span",{mi:"",btn:"",sec:""},"tune"),l(" button in the top right to open the image editor.")]),e("li",null,[l("Make your changes and click "),e("span",{mi:"",btn:""},"check"),l(" in the top right to save the updates.")])],-1),O=e("div",{class:"danger hint"},[e("div",{class:"hint-title"},"Irreversible Change"),e("p",null,"Edits overwrite the original file on disk. This can\u2019t be reversed.")],-1),K=e("h2",{id:"upload-a-file",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#upload-a-file"},"#"),l(" Upload a File")],-1),q=e("a",{href:"#how-it-works"},"How it Works",-1),V=e("h2",{id:"replace-a-file",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#replace-a-file"},"#"),l(" Replace a File")],-1),Y=e("p",null,"When a file is replaced, its existing info and all relationships are kept.",-1),J=e("video",{alt:"Replace a File",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220608A/replace-a-file-20220608A.mp4",type:"video/mp4"})],-1),X=e("ol",null,[e("li",null,"Click the Image Preview on the File Detail page. A popup will appear."),e("li",null,[l("Upload your file. You have 3 options: "),e("ul",null,[e("li",null,"Drag a file from your desktop to the popup."),e("li",null,"Click the popup area to manually select a file from your device."),e("li",null,[l("Click "),e("span",{mi:"",icon:""},"more_vert"),l(" in the popover and choose "),e("strong",null,"\u201CImport from URL\u201D"),l(".")])])])],-1),G=e("h2",{id:"folders",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#folders"},"#"),l(" Folders")],-1),Q=e("p",null,"Folders provide the organization system for Files.",-1),Z=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/folders-20220305A.webp",alt:"Folders"})],-1),$=e("h2",{id:"create-a-folder",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#create-a-folder"},"#"),l(" Create a Folder")],-1),ee=e("video",{alt:"Create a Folder",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/create-a-folder-20220305A.mp4",type:"video/mp4"})],-1),le=e("ol",null,[e("li",null,[l("From the "),e("strong",null,"File Library"),l(", click on the "),e("span",{mi:"",btn:"",sec:""},"create_new_folder"),l(" button located in the Header.")]),e("li",null,"Fill in a Folder name as desired."),e("li",null,[l("Click "),e("strong",null,"\u201CSave\u201D"),l(".")])],-1),te=e("h2",{id:"rename-a-folder",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#rename-a-folder"},"#"),l(" Rename a Folder")],-1),ie=e("video",{alt:"Renaming a Folder",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/rename-a-folder-20220215A.mp4",type:"video/mp4"})],-1),oe=e("ol",null,[e("li",null,[l("From the "),e("strong",null,"File Library"),l(", right-click on the Folder you wish to rename and select \u201CRename Folder\u201D.")]),e("li",null,"Update the Folder name as desired."),e("li",null,[l("Click "),e("strong",null,"\u201CSave\u201D"),l(".")])],-1),ae=e("h2",{id:"move-a-folder",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#move-a-folder"},"#"),l(" Move a Folder")],-1),ne=e("video",{alt:"Moving a Folder",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/file-library-20220305A/move-a-folder20220305A.mp4",type:"video/mp4"})],-1),se=e("ol",null,[e("li",null,[l("From the "),e("strong",null,"File Library"),l(", right-click on the folder you wish to move and select "),e("strong",null,"\u201CMove to Folder\u201D"),l(". A popup will appear.")]),e("li",null,"Select a Folder to serve as the new Parent Folder."),e("li",null,[l("Click "),e("strong",null,"\u201CSave\u201D"),l(".")])],-1),re=e("h2",{id:"delete-a-folder",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#delete-a-folder"},"#"),l(" Delete a Folder")],-1),de=e("video",{alt:"Deleting a Folder",loop:"",muted:"",controls:"",autoplay:"",playsinline:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/file-library/delete-a-folder-20220215A.mp4",type:"video/mp4"})],-1),ce=e("ol",null,[e("li",null,[l("From the "),e("strong",null,"File Library"),l(", right-click on the Folder you wish to delete and select "),e("strong",null,"\u201CDelete Folder\u201D"),l(".")]),e("li",null,[l("Click "),e("strong",null,"\u201CDelete\u201D"),l(".")])],-1),he=e("div",{class:"tip hint"},[e("p",null,"When you delete a Folder, any nested Files and Folders will be moved one level up.")],-1),ue=e("h2",{id:"more-help",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#more-help"},"#"),l(" More Help")],-1),pe=e("p",null,[l("Looking for technical support for your non-enterprise project? Chat with thousands of engineers within our growing "),e("a",{href:"https://discord.com/invite/directus",target:"_blank",rel:"noopener noreferrer"},"Community on Discord")],-1),ye="File Library",be=!1,Fe="The File Library Module aggregates all files within the Directus Project into one consolidated library.",ve="7 min read",we={__name:"file-library",setup(fe,{expose:s}){const a={title:"File Library",modularExtension:!1,description:"The File Library Module aggregates all files within the Directus Project into one consolidated library.",readTime:"7 min read"};return s({frontmatter:a}),(me,ge)=>{const i=n("router-link"),r=n("docs-wrapper");return d(),c(r,{frontmatter:a},{default:t(()=>[e("div",h,[u,p,e("div",f,[m,e("p",null,[l("This is a non-technical, no-code guide to the File Library Module. Please note there is documentation on programmatic "),o(i,{to:"/docs/reference/system/folders"},{default:t(()=>[l("Folder")]),_:1}),l(" and "),o(i,{to:"/docs/reference/files"},{default:t(()=>[l("File")]),_:1}),l(" management via the API.")])]),g,e("div",_,[y,e("p",null,[l("Familiarity with the "),o(i,{to:"/docs/app/content/collections"},{default:t(()=>[l("Collections Page")]),_:1}),l(" will be helpful but not necessary.")])]),e("p",null,[l("The File Library acts as one big "),b,l(" to store all uploaded "),F,l(". Sub-folders can be created within the File Library to help Files stay organized. Folders and File information are stored in regular Collections, which means "),o(i,{to:"/docs/configuration/users-roles-permissions.md"},{default:t(()=>[l("User and Role access permissions")]),_:1}),l(" are fully configurable and granular on both Folders and Files. Multiple files can be uploaded at once through the app and also programmatically via the API. Any type of file can be uploaded, "),v,l(". When a Folder is selected from the Navigation Bar, the "),w,l(" is presented. This page has all the same features and functionalities as the "),o(i,{to:"/docs/app/content/collections"},{default:t(()=>[l("Collections Page")]),_:1}),l(".")]),k,A,C,e("p",null,[l("When a file is clicked in the File Listing Page, the File Details Page appears. This is a custom form for viewing assets and embeds, with core Fields included out-of-the-box (see below), and the ability for Administrators to add additional custom Fields. This page has the same features and functionality as the "),o(i,{to:"/docs/getting-started/glossary#items"},{default:t(()=>[l("Item Page")]),_:1}),l(".")]),T,D,L,P,I,x,M,S,E,U,H,B,N,R,W,j,z,O,K,e("p",null,[l("We covered the File Library\u2019s three upload methods in "),q,l(". Keep in mind that files can also be added through different Interfaces as well. For example, Users can upload an Avatar image when they fill in their User Details. Similarly, Items with an Image Field will have a file upload Interface on the Item Detail page. Files can also be "),o(i,{to:"/docs/reference/files"},{default:t(()=>[l("uploaded programmatically via the API")]),_:1}),l(".")]),V,Y,J,X,G,Q,Z,e("p",null,[l("They can be named, renamed, and nested as sub-folders anywhere in the Folder hierarchy. Once a Folder is selected from the Navigation Bar, File Listing Page opens. The File Listing Page displays all Files within a Folder. It also enables all other features and functionalities from the "),o(i,{to:"/docs/app/content/collections"},{default:t(()=>[l("Collections Page")]),_:1}),l(" such as batch editing, batch deleting, sorting, filtering, searching, etc. Folders can also be managed "),o(i,{to:"/docs/reference/system/folders"},{default:t(()=>[l("programmatically via the API")]),_:1}),l(".")]),$,ee,le,te,ie,oe,ae,ne,se,re,de,ce,he,ue,pe])]),_:1})}}};export{we as default,Fe as description,be as modularExtension,ve as readTime,ye as title};
