import{a as l,o as i,e as u,y as o,u as e,q as t,z as c}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},h=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Using a fork in production is neither supported nor recommended."),e("p",null,"Only do so if:"),e("ol",null,[e("li",null,"The feature you want to implement doesn\u2019t satisfy the 80/20 principle"),e("li",null,"There is a technical limitation preventing you from implementing it as an extension")]),e("p",null,"Forks are not officially supported - please don\u2019t submit fork-specific bugs and questions on the official repo."),e("p",null,[t("If you suspect a bug to not be part of your changes please confirm this by reproducing it with the official version "),e("strong",null,"before"),t(" submitting an issue.")])],-1),p=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Minimum Requirements"),e("p",null,"If you want to publish your fork to hub.docker.com or NPM you need to have an account there."),e("p",null,"Note: to publish to NPM you probably have to change all the package names. Publishing to NPM should almost never be necessary.")],-1),f=e("h2",{id:"1.-setup-environment-variables%2Fsecrets",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#1.-setup-environment-variables%2Fsecrets"},"#"),t(" 1. Setup environment variables/secrets")],-1),m=e("h2",{id:"general",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#general"},"#"),t(" General")],-1),b=e("table",null,[e("thead",null,[e("tr",null,[e("th",null,"Variable"),e("th",null,"Description"),e("th",null,"Example")])]),e("tbody",null,[e("tr",null,[e("td",null,[e("code",null,"GHCR_IMAGE")]),e("td",null,"Image name for GitHub Container Registry. Be sure to use the full URL."),e("td",null,[e("code",null,"ghcr.io/directus/directus")])]),e("tr",null,[e("td",null,[e("code",null,"DOCKERHUB_IMAGE")]),e("td",null,"Image name for hub.docker.com, no prefix."),e("td",null,[e("code",null,"directus/directus")])])])],-1),_=e("table",null,[e("thead",null,[e("tr",null,[e("th",null,"Secret"),e("th",null,"Description"),e("th",null,"Example")])]),e("tbody",null,[e("tr",null,[e("td",null,[e("code",null,"NPM_TOKEN")]),e("td",null,"Your NPM token. Make sure to use the type \u201Cautomation\u201D."),e("td",null,[e("code",null,"12345678-...")])]),e("tr",null,[e("td",null,[e("code",null,"DOCKERHUB_USERNAME")]),e("td",null,"Dockerhub Username"),e("td",null,[e("code",null,"directus")])]),e("tr",null,[e("td",null,[e("code",null,"DOCKERHUB_PASSWORD")]),e("td",null,"Dockerhub Password"),e("td",null,[e("code",null,"hunter2")])])])],-1),g=e("h2",{id:"2.-create-a-release",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#2.-create-a-release"},"#"),t(" 2. Create a release")],-1),k=e("pre",null,[e("code",{class:"language-bash"},`npm run release
`)],-1),N="GitHub CI",C=!1,M="This guide explains how to publish a forked version of Directus on NPM, Dockerhub and GHCR. You need to first create a fork.",w="2 min read",E={__name:"github-ci",setup(y,{expose:r}){const n={title:"GitHub CI",modularExtension:!1,description:"This guide explains how to publish a forked version of Directus on NPM, Dockerhub and GHCR. You need to first create a fork.",readTime:"2 min read"};return r({frontmatter:n}),(v,x)=>{const s=l("router-link"),a=l("docs-wrapper");return i(),u(a,{frontmatter:n},{default:o(()=>[e("div",d,[e("blockquote",null,[e("p",null,[t("This guide explains how to publish a forked version of Directus on NPM, Dockerhub and GHCR. You need to first "),c(s,{to:"/docs/contributing/running-locally"},{default:o(()=>[t("create a fork")]),_:1})])]),h,p,f,m,b,_,g,k])]),_:1})}}};export{E as default,M as description,C as modularExtension,w as readTime,N as title};
