import{a as i,o as d,e as c,y as a,u as e,q as t,z as o}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"This is list of platform-specific terminology, and their meanings. Most are simply more approachable names for technical database terms.")],-1),p=e("h2",{id:"admin-%2F-administrator",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#admin-%2F-administrator"},"#"),t(" Admin / Administrator")],-1),f=e("p",null,"An \u201CAdministrator\u201D Role (with Admin access enabled) is included when you first install the platform. All admin roles bypass the permissions check, providing unrestricted access to all data within the App and API. Additionally, only roles with the admin option enabled can manage Settings within the app.",-1),m=e("h2",{id:"alias",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#alias"},"#"),t(" Alias")],-1),g=e("a",{href:"#fields"},"Fields",-1),y=e("h2",{id:"api",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#api"},"#"),t(" API")],-1),_=e("p",null,"The Application Programming Interface (API) provided by the platform is how you can programmatically connect your project\u2019s content, files, and system information to external code (like a website) or with other third-party services.",-1),b=e("h2",{id:"app",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#app"},"#"),t(" App")],-1),v=e("p",null,[t("An intuitive no-code application for managing database content. Powered by the API, the modular and highly extensible App is written in "),e("a",{href:"https://vuejs.org",target:"_blank",rel:"noopener noreferrer"},"Vue.js"),t(".")],-1),w=e("h2",{id:"activity",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#activity"},"#"),t(" Activity")],-1),x=e("p",null,"Activity is a log of all events that take place within the platform. Used for accountability, each activity record tracks the event type, user, timestamp, IP address, user-agent, and any associated revision data.",-1),A=e("h2",{id:"collections",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#collections"},"#"),t(" Collections")],-1),k=e("strong",null,"table",-1),I=e("a",{href:"#title-formatter"},"title formatter",-1),T=e("p",null,[t("Collections can be organized in any way that is appropriate for your project. You can architect them platform-specific (e.g., "),e("em",null,"pages"),t(" of a website), or in a more platform-agnostic way (e.g., raw "),e("em",null,"customers"),t(" of your business). While there\u2019s no right or wrong way to structure your data-model, we recommend keeping your data as agnostic as possible so it is easier to repurpose in the future. "),e("strong",null,"In short, learn to see your data as its own asset \u2014 not only through the lens of your immediate project needs"),t(".")],-1),C=e("p",null,[t("The only requirement of a collection is that it must contain a "),e("a",{href:"#primary-key-pk"},"Primary Key"),t(" field. This field stores a unique value that is used to reference the Collection\u2019s items throughout the database/platform.")],-1),D=e("h3",{id:"relevant-guides",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides"},"#"),t(" Relevant Guides")],-1),j=e("h2",{id:"dashboards",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#dashboards"},"#"),t(" Dashboards")],-1),S=e("p",null,[t("Dashboards within the Insights module organize different "),e("a",{href:"#panels"},"Panels"),t(" into an at-a-glance view. They can be used to group data based on department, objective, business process or anything you choose.")],-1),P=e("h2",{id:"database-abstraction",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#database-abstraction"},"#"),t(" Database Abstraction")],-1),F=e("p",null,"Directus supports mirroring all the most widely used SQL databases, including PostgreSQL, MySQL, Microsoft SQL Server, SQLite, OracleDB, MariaDB, CockroachDB, and other variants. Each vendor has subtle (and sometimes not so subtle) differences in how they function, so Directus includes an abstraction layer that helps it avoid writing different code for each type.",-1),R=e("p",null,[t("This means there is also the possibility of supporting other datastores in the future, such as NoSQL options like MongoDB, or even third-party data services like Firebase or Heroku. However these options are "),e("em",null,"fundamentally"),t(" different from the relational SQL databases we currently support, and so more research is needed.")],-1),M=e("h2",{id:"displays",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#displays"},"#"),t(" Displays")],-1),L=e("p",null,[t("Displays are the smaller, read-only counterpart to "),e("a",{href:"#interfaces"},"Interfaces"),t(", defining how a field\u2019s data will be displayed inline throughout the App.")],-1),z=e("p",null,[t("For example, you may have a \u201CStatus\u201D field that uses a "),e("em",null,"Dropdown"),t(" Interface on the Item Detail page, and a smaller "),e("em",null,"Badge"),t(" Display when the field is referenced throughout the rest of the App. Directus includes many Displays out-of-the-box, below are the some key examples:")],-1),B=e("ul",null,[e("li",null,[e("strong",null,"Raw"),t(" \u2014 The exact value, straight from the API")]),e("li",null,[e("strong",null,"Formatted Value"),t(" \u2014 Provides options for string formatting")]),e("li",null,[e("strong",null,"Boolean"),t(" \u2014 Customizable True/False icons")]),e("li",null,[e("strong",null,"Color"),t(" \u2014 A color swatch preview")]),e("li",null,[e("strong",null,"DateTime"),t(" \u2014 Formatted or relative datetimes")]),e("li",null,[e("strong",null,"Image"),t(" \u2014 Thumbnail previews")]),e("li",null,[e("strong",null,"Labels"),t(" \u2014 Small, custom colored badges")]),e("li",null,[e("strong",null,"Rating"),t(" \u2014 Customizable stars")]),e("li",null,[e("strong",null,"Related Values"),t(" \u2014 Displays relational display titles")]),e("li",null,[e("strong",null,"User"),t(" \u2014 Avatar and name of a system user")])],-1),E=e("p",null,"In addition to the included core displays, custom displays allow for creating new and/or proprietary ways to view or represent field data. For example, you could create progress indicators, tooltips for relational data, specific formatting styles, or anything else.",-1),G=e("h3",{id:"relevant-guides-1",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-1"},"#"),t(" Relevant Guides")],-1),q=e("h2",{id:"environments",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#environments"},"#"),t(" Environments")],-1),U=e("p",null,"Environments (e.g., dev, staging, prod) are tracked as separate Project instances. You can then use schema/content migrations to promote data between them.",-1),Q=e("h2",{id:"extensions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#extensions"},"#"),t(" Extensions")],-1),O=e("h2",{id:"fields",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#fields"},"#"),t(" Fields")],-1),W=e("p",null,[t("Fields are a specific type of value within a Collection, storing the data of your item\u2019s content. Each field represents a "),e("strong",null,"column"),t(" in your database. For example, an "),e("code",null,"articles"),t(),e("a",{href:"#collections"},"Collection"),t(" might have "),e("code",null,"title"),t(", "),e("code",null,"body"),t(", "),e("code",null,"author"),t(", and "),e("code",null,"date_published"),t(" field. Fields mirror the characteristics of their associated column, including its "),e("code",null,"name"),t(", "),e("code",null,"type"),t(", "),e("code",null,"default"),t(", "),e("code",null,"length"),t(", "),e("code",null,"allow_null"),t(", etc.")],-1),N=e("h3",{id:"relevant-guides-2",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-2"},"#"),t(" Relevant Guides")],-1),V=e("h2",{id:"files-%26-assets",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#files-%26-assets"},"#"),t(" Files & Assets")],-1),H=e("p",null,"As you might have guessed, files includes images, videos, PDFs, text documents, or anything else. While files can technically be stored as code in the database, it is far more common to manage them as individual assets on a \u201Cdrive\u201D. The platform supports many options for uploading, storing, transforming, and retrieving different types of files, and it is an excellent Digital Asset Management system.",-1),Y=e("h2",{id:"icons",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#icons"},"#"),t(" Icons")],-1),K=e("h3",{id:"material-icons",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#material-icons"},"#"),t(" Material Icons")],-1),J=e("p",null,[t("Full list of icons "),e("a",{href:"https://fonts.google.com/icons",target:"_blank",rel:"noopener noreferrer"},"can be found here"),t(". Directus supports both filled & outlined variants of Material icons.")],-1),X=e("h3",{id:"social-icons",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#social-icons"},"#"),t(" Social Icons")],-1),Z=e("p",null,[t("They are Font Awesome 5\u2019s brands icons. Full list of icons "),e("a",{href:"https://fontawesome.com/v5.15/icons?d=gallery&s=brands",target:"_blank",rel:"noopener noreferrer"},"can be found here"),t(". When using them as one of the auth provider icons, make sure to use underscores, such as "),e("code",null,"blogger_b"),t(" for "),e("a",{href:"https://fontawesome.com/v5.15/icons/blogger-b?style=brands",target:"_blank",rel:"noopener noreferrer"},"blogger-b"),t(" icon.")],-1),$=e("h2",{id:"interfaces",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#interfaces"},"#"),t(" Interfaces")],-1),ee=e("p",null,"Interfaces determine how you view or interact with a field. In most cases, they offer some sort of input tailored to managing data of a specific type, but can also be used exclusively for presentation. Examples include text inputs, toggles, WYSIWYG editors, dropdowns, sliders, image galleries, and more.",-1),te=e("p",null,[t("In addition to the many core interfaces included out-of-the-box, "),e("em",null,"custom"),t(" interfaces allow for creating more tailored or proprietary options, such as seating charts, QR codes, or Stripe customer info.")],-1),ae=e("h3",{id:"relevant-guides-3",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-3"},"#"),t(" Relevant Guides")],-1),se=e("h2",{id:"items",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#items"},"#"),t(" Items")],-1),oe=e("p",null,[t("Items are objects within a Collection which contain values for one or more fields. Each collection represents a "),e("strong",null,"record"),t(" in your database.")],-1),ne=e("p",null,"Items are the primary building blocks of your project content. Similar to a \u201Crow\u201D within a spreadsheet, all data within the platform is accessed via these \u201Catomic\u201D data units. Items themselves are fairly straightforward, however their real power comes from the complexity that begins to form when items are relationally connected to each other.",-1),ie=e("p",null,[t("Items are referenced (both individually and relationally) by their unique "),e("a",{href:"#primary-key-pk"},"primary key"),t(".")],-1),le=e("h4",{id:"relevant-guides-4",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-4"},"#"),t(" Relevant Guides")],-1),re=e("h2",{id:"junction-collections",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#junction-collections"},"#"),t(" Junction Collections")],-1),de=e("p",null,[t("The platform allows you to group Items within different Collections. But often times it is important to \u201Clink\u201D items across different collections (such as relating "),e("code",null,"recipes"),t(" and "),e("code",null,"ingredients"),t(") \u2014 this is called a relationship. There are several different types of relationships, but only some (M2M and M2A) require an additional collection to properly connect data. For instance, if you have a "),e("code",null,"recipes"),t(" collection and an "),e("code",null,"ingredients"),t(" collection, you would also need a "),e("code",null,"recipe_ingredients"),t(" junction collection to sit between and connect the two.")],-1),ce=e("h2",{id:"layouts",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#layouts"},"#"),t(" Layouts")],-1),ue=e("p",null,"Layouts determine how you view or interact with a Collection. In most cases, they offer a way to browse items based on a specific type of data, but can also be used to visualize or interact with data. Directus includes several Layout options out-of-the-box, each with different features and configuration options.",-1),he=e("ul",null,[e("li",null,[e("strong",null,"Table"),t(" \u2014 Works with any type of data, showing items as rows and their fields as columns.")]),e("li",null,[e("strong",null,"Cards"),t(" \u2014 Ideal for image data, this layout shows items as a grid of image cards.")]),e("li",null,[e("strong",null,"Calendar"),t(" \u2014 Ideal for \u201Ctemporal\u201D data that is sorted by date or datetime.")]),e("li",null,[e("strong",null,"Map"),t(" \u2014 Ideal for \u201Cgeospatial\u201D data that is shown on a world map.")])],-1),pe=e("p",null,"In addition to these core layouts, custom layouts allow for creating more tailored or proprietary ways to experience data within the App, such as Gantt charts, seating maps, or spreadsheets.",-1),fe=e("h3",{id:"relevant-guides-5",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-5"},"#"),t(" Relevant Guides")],-1),me=e("h2",{id:"modules",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#modules"},"#"),t(" Modules")],-1),ge=e("p",null,"Modules are the highest and broadest level of organization within the App. There are several modules included out-of-the-box, however you can also add your own.",-1),ye=e("p",null,[t("In addition to these core modules, custom modules offer a "),e("em",null,"blank canvas"),t(" for creating altogether new/different experiences within the App, such as proprietary dashboards, compound datasets, or third-party integrations (e.g., a Stripe Payments Console).")],-1),_e=e("h3",{id:"relevant-guides-6",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-6"},"#"),t(" Relevant Guides")],-1),be=e("h2",{id:"multitenancy",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#multitenancy"},"#"),t(" Multitenancy")],-1),ve=e("p",null,"Multitenancy is an architecture that allows multiple tenants (e.g., customers) to be managed by the platform. There are two main ways to achieve multitenancy:",-1),we=e("ul",null,[e("li",null,[e("strong",null,"Project Scoping"),t(" \u2014 Creating a super-admin layer that provisions new tenant projects has been made easier by the Cloud-native model of Directus 9+. This method involves developing custom code that can dynamically spin up/down projects, but is also the most flexible, supporting scoped extensions and differentiated project settings.")]),e("li",null,[e("strong",null,"Role Scoping"),t(" \u2014 In this method, you create one Role per tenant, and configure their permissions to properly scope them within a single project. This direction allows for tenants to share a single schema using "),e("em",null,"item"),t(" scoped permissions, or different schemas by using "),e("em",null,"collection"),t(" scoped permissions.")])],-1),xe=e("h2",{id:"panels",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#panels"},"#"),t(" Panels")],-1),Ae=e("a",{href:"#dashboards"},"Dashboard",-1),ke=e("h3",{id:"relevant-guides-7",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-7"},"#"),t(" Relevant Guides")],-1),Ie=e("h2",{id:"permissions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#permissions"},"#"),t(" Permissions")],-1),Te=e("p",null,"Permissions are attached directly to a Role, defining what a user can create, read, update, and delete within the platform. Extremely granular, these filter-based permissions control access for the entire system.",-1),Ce=e("h2",{id:"presets",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#presets"},"#"),t(" Presets")],-1),De=e("p",null,[t("Presets store the exact state of a "),e("a",{href:"#collections"},"collection page"),t(". They are used to set layout defaults for a user, or to define bookmarks that can be used to quickly recall specific datasets.")],-1),je=e("h4",{id:"relevant-guides-8",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-8"},"#"),t(" Relevant Guides")],-1),Se=e("h2",{id:"primary-key-(pk)",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#primary-key-(pk)"},"#"),t(" Primary Key (PK)")],-1),Pe=e("p",null,[t("When we\u2019re trying to view or reference a specific "),e("a",{href:"#items"},"Item"),t(" within a "),e("a",{href:"#collections"},"Collection"),t(", you need some sort of unique identifier to know exactly where to look. Much like an address for a house, the primary key field provides the location of an item within its collection. For that reason, every collection must have a primary key field, and so they are configured when you create the collection. There are different types of identifiers you can use, but the field is often called "),e("code",null,"id"),t(".")],-1),Fe=e("h2",{id:"projects",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#projects"},"#"),t(" Projects")],-1),Re=e("p",null,[t("A Project is a complete instance of the platform. Each project represents a "),e("strong",null,"Database"),t(", but also encapsulates a config file, asset storage, and any custom extensions. Projects are the highest level of organization in Directus.")],-1),Me=e("h2",{id:"relationships",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relationships"},"#"),t(" Relationships")],-1),Le=e("code",null,"recipes",-1),ze=e("code",null,"ingredients",-1),Be=e("em",null,"relational",-1),Ee=e("h2",{id:"revisions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#revisions"},"#"),t(" Revisions")],-1),Ge=e("p",null,"Revisions are created whenever an Item is updated. These alternate versions are tracked so that previous states can be recovered. Every change made to items in Directus is stored as a complete versioned snapshot and a set of specific changes made (the delta). The revisions system is tightly coupled to the activity logs system, with each revision linked to the activity event where it was created.",-1),qe=e("h2",{id:"roles",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#roles"},"#"),t(" Roles")],-1),Ue=e("p",null,"Roles define a specific set of access permissions, and are the primary organizational structure for Users within the platform. You can create an unlimited number of roles, so organize your users in whatever way feels most appropriate.",-1),Qe=e("p",null,[t("During the installation process, Directus automatically creates an \u201CAdministrators\u201D Role, which is used to provide the initial admin user with full platform access. However this is just a "),e("em",null,"normal"),t(" role, and so it can still be updated, renamed, or even deleted. Keep in mind that your project must maintain at least one role with Admin Access at all times.")],-1),Oe=e("p",null,"There is also a \u201CPublic\u201D role that determines access for unauthenticated access.",-1),We=e("h3",{id:"relevant-guides-9",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relevant-guides-9"},"#"),t(" Relevant Guides")],-1),Ne=e("h2",{id:"singleton",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#singleton"},"#"),t(" Singleton")],-1),Ve=e("ul",null,[e("li",null,[e("strong",null,"Directus"),t(" - A collection that only contains one single item")]),e("li",null,[e("a",{href:"https://www.patterns.dev/posts/singleton-pattern/",target:"_blank",rel:"noopener noreferrer"},[e("strong",null,"Design pattern")]),t(" - Classes which can be instantiated once and can be accessed globally. This single instance can be shared throughout our application, which makes singletons great for managing global state in an application.")])],-1),He=e("h2",{id:"storage-adapters",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#storage-adapters"},"#"),t(" Storage Adapters")],-1),Ye=e("p",null,"Storage adapters allow project files to be stored in different locations or services. By default, Directus includes the following drivers:",-1),Ke=e("ul",null,[e("li",null,[e("strong",null,"Local Filesystem"),t(" \u2014 The default, any file system location or network-attached storage")]),e("li",null,[e("strong",null,"S3 or Equivalent"),t(" \u2014 Including AWS S3, DigitalOcean Spaces, Alibaba OSS, and others")]),e("li",null,[e("strong",null,"Google Cloud Storage"),t(" \u2014 A RESTful web service on the Google Cloud Platform")]),e("li",null,[e("strong",null,"Azure Blob Storage"),t(" \u2014 Azure storage account containers")])],-1),Je=e("h2",{id:"title-formatter",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#title-formatter"},"#"),t(" Title Formatter")],-1),Xe=e("p",null,[t("Special Casing \u2014 If you are trying to update the specific casing (uppercase/lowercase) for a word (e.g., "),e("code",null,"Dna"),t(" to "),e("code",null,"DNA"),t(") you will want to add the edge-case to the "),e("a",{href:"https://github.com/directus/format-title",target:"_blank",rel:"noopener noreferrer"},"Format Title package"),t(". If you feel the case passes our "),e("a",{href:"https://docs.directus.io/contributing/introduction#feature-requests",target:"_blank",rel:"noopener noreferrer"},"80/20 rule"),t(" you should submit a Pull Request to the codebase, otherwise you can update this in your instance.")],-1),Ze=e("h2",{id:"translations",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#translations"},"#"),t(" Translations")],-1),$e=e("p",null,[t("The platform supports internationalization across its entire Admin App. Many languages are currently supported, with more being added all the time. Anyone can add or refine any languages through the integration with "),e("a",{href:"https://locales.directus.io",target:"_blank",rel:"noopener noreferrer"},"CrowdIn"),t(".")],-1),et=e("p",null,"In addition to the App itself being multilingual, the platform allows translating your schema too. By default, collections and field names come from the database\u2019s naming, but you can override this in different languages.",-1),tt=e("p",null,"The platform also includes different ways to manage multilingual content. The built-in translation interface supports authoring content in any number of languages, side-by-side reference editing, and mixing in language agnostic content (such as dates or toggles).",-1),at=e("h2",{id:"types",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#types"},"#"),t(" Types")],-1),st=e("p",null,"The \u201Ctype\u201D defines how field content is stored in the database and how it is returned by the API. Often called a data-type, these are important in ensuring field values are saved in a standardized format. Changing a field\u2019s type can cause data loss, so types are locked within the platform after a field is created.",-1),ot=e("h3",{id:"data-type-superset",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#data-type-superset"},"#"),t(" Data Type Superset")],-1),nt=e("p",null,[t("Directus uses its built-in database abstraction to properly support all the different SQL vendors. However, these vendors do not share support for the same data types, instead, each SQL vendor maintains their own list. To standardize all of these differences, Directus has a single "),e("em",null,"superset"),t(" of types that map to the vendor-specific ones.")],-1),it=e("ul",null,[e("li",null,[e("strong",null,"String"),t(" \u2014 A shorter set of characters with a configurable max length")]),e("li",null,[e("strong",null,"Text"),t(" \u2014 A longer set of characters with no real-world max length")]),e("li",null,[e("strong",null,"Boolean"),t(" \u2014 A True or False value")]),e("li",null,[e("strong",null,"Binary"),t(" \u2014 The data of a binary file")]),e("li",null,[e("strong",null,"Integer"),t(" \u2014 A number without a decimal point")]),e("li",null,[e("strong",null,"Big Integer"),t(" \u2014 A larger number without a decimal point")]),e("li",null,[e("strong",null,"Float"),t(" \u2014 A less exact number with a floating decimal point")]),e("li",null,[e("strong",null,"Decimal"),t(" \u2014 A higher precision, exact decimal number often used in finances")]),e("li",null,[e("strong",null,"Timestamp"),t(" \u2014 A date, time, and timezone saved in ISO 8601 format")]),e("li",null,[e("strong",null,"DateTime"),t(" \u2014 A date and time saved in the database vendor\u2019s format")]),e("li",null,[e("strong",null,"Date"),t(" \u2014 A date saved in the database vendor\u2019s format")]),e("li",null,[e("strong",null,"Time"),t(" \u2014 A time saved in the database vendor\u2019s format")]),e("li",null,[e("strong",null,"JSON"),t(" \u2014 A value nested in JavaScript Object Notation")]),e("li",null,[e("strong",null,"CSV"),t(" \u2014 A comma-separated value, returned as an array of strings")]),e("li",null,[e("strong",null,"UUID"),t(" \u2014 A universally unique identifier saved in UUIDv4 format")]),e("li",null,[e("strong",null,"Hash"),t(" \u2014 A string hashed using argon2 cryptographic hash algorithm")]),e("li",null,[e("strong",null,"Alias"),t(" \u2014 For fields that do not have a database column "),e("a",{href:"#"},"Learn More")])],-1),lt=e("div",{class:"warning hint"},[e("p",null,[t("For "),e("strong",null,"SQLite"),t(", the "),e("strong",null,"Timestamp"),t(" type is stored as a "),e("strong",null,"DateTime"),t(".")])],-1),rt=e("h2",{id:"users",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#users"},"#"),t(" Users")],-1),dt=e("p",null,[t("An active User is required to access a project. Each user is assigned to a "),e("a",{href:"#roles"},"Role"),t(" that determines what they have access to see and do. This means that the experience of users may vary significantly depending on their role\u2019s permissions.")],-1),ft="Glossary",mt=!1,gt="A glossary of key Directus terminology.",yt="15 min read",_t={__name:"glossary",setup(ct,{expose:l}){const n={title:"Glossary",modularExtension:!1,description:"A glossary of key Directus terminology.",readTime:"15 min read"};return l({frontmatter:n}),(ut,ht)=>{const s=i("router-link"),r=i("docs-wrapper");return d(),c(r,{frontmatter:n},{default:a(()=>[e("div",u,[h,p,f,m,e("p",null,[g,t(" that do not map directly to an actual database column are called \u201Calias\u201D fields. For example, presentation fields (such as dividers and groups) and certain relational types that display data stored elsewhere (such as "),o(s,{to:"/docs/configuration/data-model/relationships#one-to-many-o2m"},{default:a(()=>[t("One-to-Many (O2M)")]),_:1}),t(" and "),o(s,{to:"/docs/configuration/data-model/relationships#many-to-many-m2m"},{default:a(()=>[t("Many-to-Many (M2M)")]),_:1}),t(").")]),y,_,b,v,w,x,A,e("p",null,[t("Collections are containers for specific types of Items and contain any number of fields. Each collection represents a "),k,t(" in your database. By default, the "),I,t(" is used to display any existing database table names as human-readable collection titles. There are also \u201Cfolder\u201D collections that are "),o(s,{to:"/docs/configuration/data-model#sorting-grouping"},{default:a(()=>[t("exclusively used for organizational purposes")]),_:1}),t(", and don\u2019t hold any data themselves.")]),T,C,D,e("ul",null,[e("li",null,[o(s,{to:"/docs/configuration/data-model#creating-a-collection"},{default:a(()=>[t("Creating a Collection")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/data-model#configuring-a-collection"},{default:a(()=>[t("Configuring a Collection")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/data-model#deleting-a-collection"},{default:a(()=>[t("Deleting a Collection")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/data-model#adjusting-a-collection-layout"},{default:a(()=>[t("Adjusting a Collection Layout")]),_:1})])]),j,S,P,F,R,M,L,z,B,E,G,e("ul",null,[e("li",null,[o(s,{to:"/docs/extensions/displays"},{default:a(()=>[t("Creating a Custom Display")]),_:1})])]),q,U,Q,e("p",null,[t("The platform has been built to be modular and extensible. This helps keep the core codebase simple and clean (see the "),o(s,{to:"/docs/contributing/introduction#feature-requests"},{default:a(()=>[t("80/20 Rule")]),_:1}),t("), while allowing the flexibility needed to satisfy all use-cases\u2026 no matter how complex. There are many different types of supported extensions, each offering a way to deeply customize, override, or extend the core platform. "),o(s,{to:"/docs/extensions/introduction"},{default:a(()=>[t("Learn more about Extensions")]),_:1}),t(".")]),O,W,N,e("ul",null,[e("li",null,[o(s,{to:"/docs/reference/system/fields#creating-a-field"},{default:a(()=>[t("Creating a Field")]),_:1})]),e("li",null,[o(s,{to:"/docs/reference/system/fields#duplicating-a-field"},{default:a(()=>[t("Duplicating Fields")]),_:1})]),e("li",null,[o(s,{to:"/docs/reference/system/fields#adjusting-field-layout"},{default:a(()=>[t("Adjusting Field Layout")]),_:1})]),e("li",null,[o(s,{to:"/docs/reference/system/fields#deleting-a-field"},{default:a(()=>[t("Deleting Fields")]),_:1})])]),V,H,Y,K,J,X,Z,$,ee,te,ae,e("ul",null,[e("li",null,[o(s,{to:"/docs/extensions/interfaces"},{default:a(()=>[t("Creating a Custom Interface")]),_:1})])]),se,oe,ne,ie,le,e("ul",null,[e("li",null,[o(s,{to:"/docs/app/content/items#create-an-item"},{default:a(()=>[t("Creating an Item")]),_:1})]),e("li",null,[o(s,{to:"/docs/app/content/items#archive-an-item"},{default:a(()=>[t("Archiving an Item")]),_:1})]),e("li",null,[o(s,{to:"/docs/app/content/collections#manually-sort-items"},{default:a(()=>[t("Manually Sorting Items")]),_:1})]),e("li",null,[o(s,{to:"/docs/app/content/items#delete-an-item"},{default:a(()=>[t("Deleting an Item")]),_:1})])]),re,de,ce,ue,he,pe,fe,e("ul",null,[e("li",null,[o(s,{to:"/docs/extensions/layouts"},{default:a(()=>[t("Creating a Custom Layout")]),_:1})])]),me,ge,e("p",null,[t("The "),o(s,{to:"/docs/app/overview#_1-module-bar"},{default:a(()=>[t("Module Bar")]),_:1}),t(" lists all available Modules and allows you to switch between them. Each module also controls its own navigation bar to provide tailored access to sub-pages. All core functionality within the App can be bucketed into one of the following modules:")]),e("ul",null,[e("li",null,[o(s,{to:"/docs/app/content/collections"},{default:a(()=>[t("Content")]),_:1}),t(" \u2014 The primary way to view and interact with database content")]),e("li",null,[o(s,{to:"/docs/app/user-directory"},{default:a(()=>[t("User Directory")]),_:1}),t(" \u2014 A dedicated section for the platform\u2019s system Users")]),e("li",null,[o(s,{to:"/docs/app/file-library"},{default:a(()=>[t("File Library")]),_:1}),t(" \u2014 An aggregate of all files uploaded and managed within the platform")]),e("li",null,[o(s,{to:"/docs/app/insights"},{default:a(()=>[t("Insights")]),_:1}),t(" \u2014 Access to infinitely customizable data dashboards")]),e("li",null,[o(s,{to:"/docs/app/overview"},{default:a(()=>[t("App Guide")]),_:1}),t(" \u2014 A tailored, in-app portal for the platform\u2019s concepts, guides, and reference")]),e("li",null,[o(s,{to:"/docs/app/settings"},{default:a(()=>[t("Settings")]),_:1}),t(" \u2014 An admin-only section for configuring the project and system settings")])]),ye,_e,e("ul",null,[e("li",null,[o(s,{to:"/docs/extensions/modules"},{default:a(()=>[t("Creating a Custom Module")]),_:1})])]),be,ve,we,xe,e("p",null,[t("Panels are modular units of data visualization that exist within the "),o(s,{to:"/docs/app/insights"},{default:a(()=>[t("Insights module")]),_:1}),t(". Each panel exists within a "),Ae,t(" and can be positioned and resized as needed.")]),ke,e("ul",null,[e("li",null,[o(s,{to:"/docs/extensions/panels"},{default:a(()=>[t("Creating a Custom Panel")]),_:1})])]),Ie,Te,Ce,De,je,e("ul",null,[e("li",null,[o(s,{to:"/docs/reference/system/presets#create-a-preset"},{default:a(()=>[t("Creating a Preset")]),_:1})]),e("li",null,[o(s,{to:"/docs/reference/system/presets#delete-a-preset"},{default:a(()=>[t("Deleting a Preset")]),_:1})])]),Se,Pe,Fe,Re,e("ul",null,[e("li",null,[o(s,{to:"/docs/self-hosted/installation"},{default:a(()=>[t("Creating a Project")]),_:1})]),e("li",null,[o(s,{to:"/docs/self-hosted/config-options"},{default:a(()=>[t("Configuring a Project")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/project-settings"},{default:a(()=>[t("Adjusting Project Settings")]),_:1})]),e("li",null,[o(s,{to:"/docs/self-hosted/upgrades-migrations"},{default:a(()=>[t("Upgrading a Project")]),_:1})]),e("li",null,[o(s,{to:"/docs/self-hosted/upgrades-migrations#backing-up-a-project"},{default:a(()=>[t("Backing-up a Project")]),_:1})]),e("li",null,[o(s,{to:"/docs/self-hosted/upgrades-migrations#migrating-a-project"},{default:a(()=>[t("Migrating a Project")]),_:1})]),e("li",null,[o(s,{to:"/docs/self-hosted/upgrades-migrations#deleting-a-project"},{default:a(()=>[t("Deleting a Project")]),_:1})])]),Me,e("p",null,[t("The platform allows you to group Items within different Collections. But often times it is important to \u201Clink\u201D items across different collections (such as relating "),Le,t(" and "),ze,t(") \u2014 this is called a relationship, a crucial concept within any "),Be,t(" database. There are several different types of relationships, each serving a specific purpose. "),o(s,{to:"/docs/configuration/data-model/relationships"},{default:a(()=>[t("Learn more about Relationships")]),_:1}),t(".")]),Ee,Ge,qe,Ue,Qe,Oe,We,e("ul",null,[e("li",null,[o(s,{to:"/docs/configuration/users-roles-permissions#creating-a-role"},{default:a(()=>[t("Creating a Role")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/users-roles-permissions#configure-a-role"},{default:a(()=>[t("Configuring a Role")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/users-roles-permissions#configure-permissions"},{default:a(()=>[t("Configuring Role Permissions")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/users-roles-permissions#configure-system-permissions"},{default:a(()=>[t("Configuring System Permissions")]),_:1})]),e("li",null,[o(s,{to:"/docs/configuration/users-roles-permissions#deleting-a-role"},{default:a(()=>[t("Deleting a Role")]),_:1})])]),Ne,Ve,He,Ye,Ke,Je,Xe,Ze,$e,et,tt,at,st,ot,nt,it,lt,rt,dt])]),_:1})}}};export{_t as default,gt as description,mt as modularExtension,yt as readTime,ft as title};
