import{a,o as d,e as c,y as o,u as e,z as n,q as t}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"Directus can be installed in many different ways and on several different stacks. You can choose between local, self-hosted on-premises, or our managed Cloud solution.")],-1),p=e("p",null,"While our CLI is the recommended method for self-hosting, you can use whichever of these self-hosted options best suits your needs. These methods offer a high level of customization and are ideal for intermediate developers.",-1),f={class:"tip hint"},m=e("div",{class:"hint-title"},"Development Environment",-1),_=e("h2",{id:"deployment-guides",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#deployment-guides"},"#"),t(" Deployment Guides")],-1),y=e("p",null,"The following guides will walk you through the self-hosted installation process for specific third-party platforms. These options are only recommended for developers familiar with these services and comfortable with more advanced setup. While Directus is always completely free, you will likely need to pay for these services.",-1),g=e("li",null,[e("a",{href:"https://docs.cleavr.io/guides/directus",target:"_blank",rel:"noopener noreferrer"},"Cleavr.io")],-1),b=e("h2",{id:"one-click-installs",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#one-click-installs"},"#"),t(" One-Click Installs")],-1),k=e("p",null,"If you would like to completely avoid the manual installation process, the following self-hosted one-click apps will handle the heavy-lifting for you. While Directus is always completely free, you will likely need to pay for these services.",-1),D=e("li",null,[e("a",{href:"https://marketplace.digitalocean.com/apps/directus?action=deploy&refcode=4c0b6062c16e",target:"_blank",rel:"noopener noreferrer"},"DigitalOcean")],-1),w=e("li",null,[e("a",{href:"https://heroku.com/deploy?template=https://github.com/directus-community/heroku-template",target:"_blank",rel:"noopener noreferrer"},"Heroku")],-1),v=e("li",null,[e("a",{href:"https://console.platform.sh/projects/create-project?template=https%3A%2F%2Fraw.githubusercontent.com%2Fplatformsh%2Ftemplate-builder%2Fmaster%2Ftemplates%2Fdirectus%2F.platform.template.yaml",target:"_blank",rel:"noopener noreferrer"},"Platform.sh")],-1),B=e("li",null,[e("a",{href:"https://deploy.zeet.co/?url=https://github.com/directus-community/heroku-template",target:"_blank",rel:"noopener noreferrer"},"Zeet")],-1),C=e("li",null,[e("a",{href:"https://app.koyeb.com/deploy?type=docker&name=directus&ports=8055;http;/&env%5BPORT%5D=8055&env%5BKEY%5D=A%20random%20string&env%5BSECRET%5D=A%20random%20string&env%5BPUBLIC_URL%5D=https://myURL.com/&env%5BDB_CLIENT%5D=DB%20client&env%5BDB_HOST%5D=DB%20host&env%5BDB_PORT%5D=DB%20Port&env%5BDB_DATABASE%5D=Database%20name&env%5BDB_USER%5D=DB%20user&env%5BDB_PASSWORD%5D=DB%20Password&image=directus/directus",target:"_blank",rel:"noopener noreferrer"},"Koyeb")],-1),I=e("li",null,[e("a",{href:"https://www.alwaysdata.com/en/marketplace/directus",target:"_blank",rel:"noopener noreferrer"},"alwaysdata")],-1),T=e("li",null,[e("a",{href:"https://elest.io/open-source/directus",target:"_blank",rel:"noopener noreferrer"},"Elestio")],-1),E=e("h2",{id:"directus-cloud",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#directus-cloud"},"#"),t(" Directus Cloud")],-1),S=e("p",null,"In addition to the self-hosted options above, you can also choose to create Directus projects using our official Managed Cloud Service. This is the easiest way to get up-and-running with Directus \u2014 even for non-technical users. Unique features include dedicated hardware, automatic updates, automatic backups, usage-based pricing, and more.",-1),A=e("ul",null,[e("li",null,[e("a",{href:"http://directus.cloud",target:"_blank",rel:"noopener noreferrer"},"Directus Cloud Dashboard")]),e("li",null,[e("a",{href:"https://directus.io/on-demand-cloud",target:"_blank",rel:"noopener noreferrer"},"Learn more about On-Demand Cloud")]),e("li",null,[e("a",{href:"https://directus.io/enterprise-cloud",target:"_blank",rel:"noopener noreferrer"},"Learn more about Enterprise Cloud")])],-1),O="Installation",R=!1,U="Directus can be installed in many different ways and on several different stacks. You can choose between local, self-hosted on-premises, or our managed Cloud solution.",W="2 min read",z={__name:"installation",setup(P,{expose:r}){const s={title:"Installation",modularExtension:!1,description:"Directus can be installed in many different ways and on several different stacks. You can choose between local, self-hosted on-premises, or our managed Cloud solution.",readTime:"2 min read"};return r({frontmatter:s}),(x,L)=>{const l=a("router-link"),i=a("docs-wrapper");return d(),c(i,{frontmatter:s},{default:o(()=>[e("div",u,[h,p,e("ul",null,[e("li",null,[n(l,{to:"/docs/self-hosted/installation/cli"},{default:o(()=>[t("Command Line Interface (CLI)")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/docker"},{default:o(()=>[t("Docker")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/manual"},{default:o(()=>[t("Manually")]),_:1})])]),e("div",f,[m,e("p",null,[t("To work on the Directus Core source code, please follow our "),n(l,{to:"/docs/contributing/introduction"},{default:o(()=>[t("Contributing Guide")]),_:1}),t(".")])]),_,y,e("ul",null,[e("li",null,[n(l,{to:"/docs/self-hosted/installation/ubuntu"},{default:o(()=>[t("Generic Ubuntu")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/iis"},{default:o(()=>[t("Internet Information Services (IIS)")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/aws"},{default:o(()=>[t("Amazon AWS")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/gcp"},{default:o(()=>[t("Google Cloud Platform")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/digitalocean-app-platform"},{default:o(()=>[t("DigitalOcean App Platform")]),_:1})]),e("li",null,[n(l,{to:"/docs/self-hosted/installation/plesk"},{default:o(()=>[t("Shared Hosting with Plesk")]),_:1})]),g]),b,k,e("ul",null,[e("li",null,[n(l,{to:"/docs/self-hosted/installation/cloudron"},{default:o(()=>[t("Cloudron")]),_:1})]),D,w,v,B,C,I,T]),E,S,A])]),_:1})}}};export{z as default,U as description,R as modularExtension,W as readTime,O as title};
