import{a as i,o as d,e as c,y as o,u as e,q as t,z as s}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"These Docs will help you get Directus up-and-running quickly, guide you through advanced features, and explain the core concepts that make Directus so unique.")],-1),p=e("h2",{id:"what-is-directus%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#what-is-directus%3F"},"#"),t(" What is Directus?")],-1),m=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Directus"),e("p",null,[t("Directus ("),e("a",{href:"http://audio.pronouncekiwi.com/Salli/Directus",target:"_blank",rel:"noopener noreferrer"},"duh REKT iss"),t(") is Latin for: "),e("em",null,"laid straight, arranged in lines"),t("."),e("br"),t(" The broadest goal of our platform is to present data in a simple, orderly, and intuitive way.")])],-1),g=e("p",null,[e("strong",null,"Directus is an Open Data Platform built to democratize the database."),e("br"),t(" This platform provides everyone on your team, "),e("em",null,"regardless of technical skill"),t(", equal access to data and digital file asset management, for any data model or project. First, link Directus to your desired SQL database and file storage adapter. After that, Directus enables you to perform CRUD operations, create users, assign roles with fully configurable permissions, build complex and granular queries, configure event-driven webhooks and task automation\u2026 "),e("em",null,"the list goes on!")],-1),f=e("p",null,[e("strong",null,"Database Introspection & Abstraction"),e("br"),t(" SQL flavors all come with slightly different data types and idiosyncrasies. Directus uses "),e("a",{href:"#how-it-works"},"Database Introspection"),t(" to read your database structure and create an abstraction layer to handle all the nitty-gritty details behind the scenes. This technique works seamlessly with any major SQL database. It also lets you link Directus to your new or pre-existing database or remove it anytime, with no impact on your existing data model. That means you\u2019ll never encounter vendor lock-in.")],-1),y=e("p",null,[e("strong",null,"The App and APIs"),e("br"),t(" Once your database is introspected and abstracted, Directus dynamically generates REST and GraphQL API endpoints to manage your data with granular control. You also get CLI tools for file management and a complete JavaScript SDK.")],-1),_=e("p",null,[t("The API and CLI power the no-code App. In other words, the App is just a GUI that provides no-code access to the API. This architecture is how Directus democratizes the database and provides control to "),e("a",{href:"#who-s-it-for"},"the whole team"),t(".")],-1),b=e("p",null,[e("strong",null,"Open-Source, Modular, Extensible, Scalable"),e("br"),t(" At the highest level, Directus organizes its features and functionality into Modules. Each Module allows you to interact with data in some specific way, such as data and content management, digital file asset management, drag and drop analytics dashboard creation, or whatever. If you find Directus is missing something that your project needs, no problem!")],-1),w=e("p",null,[t("Built entirely in Typescript, primarily on "),e("a",{href:"https://nodejs.dev",target:"_blank",rel:"noopener noreferrer"},"Node.js"),t(" and "),e("a",{href:"https://vuejs.org",target:"_blank",rel:"noopener noreferrer"},"Vue.js"),t(", Directus is 100% open-source, modular and extensible, ensuring your project never hits a hard feature ceiling. The platform scales without issue, "),e("em",null,"and some Projects have hundreds of millions of users.")],-1),v=e("p",null,[t("You can use it with any "),e("em",null,"(or many)"),t(" stacks or frontend frameworks.")],-1),D=e("p",null,[e("strong",null,"Custom Configuration Options"),e("br"),t(" Extensive configuration options are also available as global variables in the codebase. Developers can custom configure SSO authentication method, caching details, default file storage location (local, S3, google, etc.) for digital assets, emails, "),e("em",null,"and much more.")],-1),k={class:"tip hint"},x=e("div",{class:"hint-title"},"Ready to dive in?",-1),T=e("h2",{id:"how-it-works",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-it-works"},"#"),t(" How It Works")],-1),I=e("p",null,[e("strong",null,[t("Directus is installed as a "),e("em",null,"layer"),t(" on top of your new or existing SQL database.")])],-1),S=e("p",null,[t("The App and API dynamically "),e("em",null,"\u201Cmirror\u201D"),t(" your actual schema and content in real-time. This is similar to how technical database clients (like "),e("em",null,"phpMyAdmin"),t(") work. However, Database Introspection has many unique advantages:")],-1),C=e("ul",null,[e("li",null,"Absolute control over your pure SQL database schema."),e("li",null,"Complete transparency, portability, and security for your data."),e("li",null,"Allows importing existing databases, unaltered and without migrations."),e("li",null,"Direct database access and the full power of raw, complex SQL queries."),e("li",null,"Significant performance improvements through optimizations and indexing.")],-1),A=e("p",null,[t("In contrast, other platforms typically use a predefined or proprietary "),e("em",null,"one-size-fits-all"),t(" data model to store content . That is not the case with Directus. Directus gives you direct access to your pure and unaltered data. That means you have the option to bypass the Directus middleware (API, SDK, App) and connect to your data with proper SQL queries. This effectively removes all bottlenecks, latency overhead, and proprietary access limitations.")],-1),j=e("h2",{id:"who%E2%80%99s-it-for%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#who%E2%80%99s-it-for%3F"},"#"),t(" Who\u2019s It For?")],-1),P=e("p",null,[e("strong",null,"Directus lets the whole team work together and access data in one place.")],-1),E=e("p",null,[e("strong",null,"Developers"),e("br"),t(" Developers get a complete data connection toolkit with REST and GraphQL APIs, a JavaScript SDK, access to global variables to customize configuration options, and direct command-line access to digital assets.")],-1),q=e("p",null,[e("strong",null,"Power Users"),e("br"),t(" Data analysts and data scientists have in-app tools to query data, build out in-app analytics dashboards, and extract or upload data in file format. Additionally, these users are still free to link other services and run raw SQL queries directly on the database.")],-1),L=e("p",null,[e("strong",null,"Business Users"),e("br"),t(" The no-code app is safe and intuitive enough to make data accessible to everyone, even the most non-technical users. Administrators can create fully granular permissions for roles as well as individual users.")],-1),Q={class:"tip hint"},z=e("div",{class:"hint-title"},"Directus Vocabulary",-1),B=e("em",null,"especially for the no-code users",-1),F=e("h2",{id:"when-to-use-it",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#when-to-use-it"},"#"),t(" When to Use It")],-1),M=e("p",null,[e("strong",null,"Directus can power any data-driven project and can be linked or removed at any time.")],-1),N=e("p",null,[t("Build, monitor or manage any data model or app you desire: IoT fleets, e-commerce, SaaS, business data analytics, multi-channel content, "),e("em",null,"or anything else!"),t(" If it involves SQL and digital files, you can link up Directus. With this in mind, four broad use cases do emerge:")],-1),R=e("p",null,[e("strong",null,"Backend as a Service"),e("br"),t(" An end-to-end data solution. Efficiently connects data, auto-generates exhaustive APIs for projects that scale, and provides webhooks and task automation. Completely detached from the database, you\u2019re free to link and remove Directus anytime or use any other service in tandem.")],-1),U=e("p",null,[e("strong",null,"Headless CMS"),e("br"),t(" Remember, "),e("em",null,"content"),t(" is just data from a database! Manage any omnichannel digital experience. Deliver file assets and data across websites, apps, kiosks, digital signage\u2026 "),e("em",null,"the sky\u2019s the limit!")],-1),W=e("p",null,[e("strong",null,"Internal Tool Builder"),e("br"),t(" The whole team can build custom apps! Ditch the spreadsheet and quickly build back-office apps and admin panels for customers, inventory, projects, marketing, "),e("em",null,"or anything else.")],-1),G=e("p",null,[e("strong",null,"Data Management and Analytics"),e("br"),t(" Establish "),e("em",null,"a single source of truth"),t(" for all data. Build no-code analytics dashboards to gain insights into company KPIs and other metrics. Coalesce previously siloed department data.")],-1),O=e("h2",{id:"why-use-it%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#why-use-it%3F"},"#"),t(" Why Use It?")],-1),Y=e("p",null,[e("strong",null,"Directus is a simple, data-first solution to complex problems with no downsides.")],-1),K=e("p",null,[t("Directus was created in 2004 and has been slowly, iteratively improved on for a long time. The core team has carefully thought through the app, beginning to end, and strives to make this platform is an all-benefit and no downside experience. It is also plug-and-play, so you\u2019re free to link or remove it anytime, with zero impact on your data. You have no vendor lock-in whatsoever, "),e("em",null,"your data is yours"),t(". There are no artificial data limits "),e("em",null,"(e.g. limits on users or roles)"),t(".")],-1),V=e("p",null,[t("Consider competing platforms in the four general use cases "),e("a",{href:"#when-to-use-it"},"mentioned above"),t(". Due diligence to select a viable solution from one of these categories can easily take six months to ensure the feature list, pricing, scalability, migration options, etc\u2026 all match the project in question. However, with Directus, that\u2019s not the case! You can test it immediately on an existing database or build a new data model from scratch, "),e("em",null,"with no impact on your data and no long-term commitments.")],-1),H=e("p",null,"The following core principles guide this platform:",-1),J=e("ul",null,[e("li",null,[e("strong",null,"Pure"),t(" \u2014 No predefined or proprietary schema. All system metadata is stored separately.")]),e("li",null,[e("strong",null,"Open"),t(" \u2014 Directus Core is open source, with no obfuscated or cloud-only code.")]),e("li",null,[e("strong",null,"Portable"),t(" \u2014 No vendor lock-in. Your database can be exported or migrated anytime.")]),e("li",null,[e("strong",null,"Limitless"),t(" \u2014 No arbitrary limits or paywalls on users, roles, translations, and data.")]),e("li",null,[e("strong",null,"Extensible"),t(" \u2014 Every aspect of this platform is modular to avoid any hard feature ceiling.")]),e("li",null,[e("strong",null,"Unopinionated"),t(" \u2014 Choose the stack, database, and architecture as you wish.")])],-1),X=e("h2",{id:"directus-cloud",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#directus-cloud"},"#"),t(" Directus Cloud")],-1),Z=e("p",null,[e("strong",null,"Directus Cloud is the fastest and easiest way to get your Directus Projects going.")],-1),$=e("p",null,"With free Directus Cloud account, you can set up Teams to organize Projects, Project billing, and other Team Members however you need. You\u2019ll be able to get a Project running in about 90 seconds. Then as Project growth changes over time, scale service up or down as needed at the click of a button. The cloud dashboard also provides simple, straightforward analytics to help understand traffic and inform scaling decisions.",-1),ee={class:"tip hint"},te=e("div",{class:"hint-title"},"Ready to try Directus Cloud?",-1),oe=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Enterprise Cloud"),e("p",null,[t("Need advanced configuration, unlimited scalability, and dedicated support? "),e("a",{href:"https://directus.io/contact",target:"_blank",rel:"noopener noreferrer"},"Contact us")])],-1),re="Introduction",le=!1,de="An introduction to what Directus is, how it works, who it is for, and when to use it.",ce="8 min read",ue={__name:"introduction",setup(ae,{expose:r}){const n={title:"Introduction",modularExtension:!1,description:"An introduction to what Directus is, how it works, who it is for, and when to use it.",readTime:"8 min read"};return r({frontmatter:n}),(se,ne)=>{const a=i("router-link"),l=i("docs-wrapper");return d(),c(l,{frontmatter:n},{default:o(()=>[e("div",u,[h,p,m,g,f,y,_,b,w,v,D,e("div",k,[x,e("p",null,[t("Get a free project running in minutes. Learn Directus hands-on in the "),s(a,{to:"/docs/getting-started/quickstart"},{default:o(()=>[t("Quickstart Guide")]),_:1}),t(".")])]),T,I,S,C,A,j,P,E,q,L,e("div",Q,[z,e("p",null,[t("In order keep things simpler, "),B,t(", Directus uses friendlier names for many database terms and technical concepts, including "),s(a,{to:"/docs/getting-started/glossary#projects"},{default:o(()=>[t("Project")]),_:1}),t(" (database), "),s(a,{to:"/docs/getting-started/glossary#collections"},{default:o(()=>[t("Collection")]),_:1}),t(" (table), "),s(a,{to:"/docs/getting-started/glossary#fields"},{default:o(()=>[t("Field")]),_:1}),t(" (column), "),s(a,{to:"/docs/getting-started/glossary#items"},{default:o(()=>[t("Item")]),_:1}),t(" (record), and "),s(a,{to:"/docs/getting-started/glossary#types"},{default:o(()=>[t("Type")]),_:1}),t(" (datatype).")])]),F,M,N,R,U,W,G,O,Y,K,V,H,J,X,Z,e("p",null,[t("Cloud architecture can be complicated and resource-intensive. Directus Cloud provides scalable, optimized storage and infrastructure, and automatic updates so developers can focus on the app\u2019s core business logic. Directus Cloud also offers "),s(a,{to:"/docs/cloud/glossary#cloud-exclusives"},{default:o(()=>[t("Cloud Exclusive Extensions")]),_:1}),t(", enhancing Directus Core with even more features.")]),$,e("div",ee,[te,e("p",null,[t("Setup your free Cloud account and learn Directus hands-on in the "),s(a,{to:"/docs/getting-started/quickstart"},{default:o(()=>[t("Quickstart Guide")]),_:1}),t(".")])]),oe])]),_:1})}}};export{ue as default,de as description,le as modularExtension,ce as readTime,re as title};
