import{a as s,o as r,e as d,y as l,u as e,q as t,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const c={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"Layouts are customized displays for viewing and interacting with the Items in a Collection. This makes working with some general category of data model, such as map locations or calendar events, a more human-friendly experience.")],-1),p=e("h2",{id:"what%E2%80%99s-a-layout%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#what%E2%80%99s-a-layout%3F"},"#"),t(" What\u2019s a Layout?")],-1),g=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Layouts Montage"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/layouts-montage-20220419A.mp4",type:"video/mp4"})],-1),m=e("p",null,[t("Data models vary drastically in shape and purpose, from eCommerce platforms to IoT fleets and everything in between. While your Directus Project data may be stored in Collections "),e("em",null,"(i.e. SQL data tables)"),t(", this table representation is not always the most human-friendly way to interact with information. Layouts provide more human-friendly, intuitive displays to view and interact with Items in a Collection.")],-1),y=e("a",{href:"https://discord.com/invite/directus",target:"_blank",rel:"noopener noreferrer"},"Discord",-1),_=e("a",{href:"https://github.com/directus/directus/discussions",target:"_blank",rel:"noopener noreferrer"},"GitHub",-1),f=e("h2",{id:"how-it-works",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-it-works"},"#"),t(" How it Works")],-1),b=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Adjust Item Layouts"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/adjust-page-layout-20220415A.mp4",type:"video/mp4"})],-1),C=e("p",null,"To adjust an Item\u2019s Layout, follow the steps below.",-1),w=e("ol",null,[e("li",null,"Navigate to the Content Module and select the desired Collection."),e("li",null,[t("In the page Sidebar, click "),e("strong",null,"\u201CLayout Options\u201D"),t(".")]),e("li",null,"Choose the desired Layout you want to use."),e("li",null,"Customize the Layout as desired.")],-1),L=e("h3",{id:"customization-controls",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#customization-controls"},"#"),t(" Customization Controls")],-1),v=e("p",null,"Customization controls can be found in the following three locations.",-1),I=e("ul",null,[e("li",null,[e("strong",null,"Layout Options"),t(" \u2014 Located in the Sidebar.")]),e("li",null,[e("strong",null,"Subheader"),t(" \u2014 Located just below the Page Header and above the Page Area.")]),e("li",null,[e("strong",null,"Page Area"),t(" \u2014 The center of the webpage, which displays all Items.")])],-1),k=e("p",null,"These controls typically fall into three general categories.",-1),S=e("ul",null,[e("li",null,[e("p",null,[e("strong",null,"Styling and Formatting"),e("br"),t(" These are additional customizations to the way a Layout displays such as the size of each Item, how images are cropped, etc.")])]),e("li",null,[e("p",null,[e("strong",null,"Field Values Displayed"),e("br"),t(" Most Layouts allow you to choose which Field Value(s) are used to represent each Item on the Collection Page. For example, with blog posts, it may be ideal to have the hero image, blog title, date, author, etc.")])]),e("li",null,[e("p",null,[e("strong",null,"Manual and Automatic Sorting"),e("br"),t(" Certain Layouts may allow sorting Items by value in ascending and descending order, drag-and-drop repositioning of Items, etc.")])])],-1),T=e("h3",{id:"key-takeaways",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#key-takeaways"},"#"),t(" Key Takeaways")],-1),F=e("p",null,"As you go through Layouts, it may be helpful to keep the following points in mind.",-1),A=e("ul",null,[e("li",null,[e("p",null,[e("strong",null,"Layouts will not be universally usable for all Collections."),e("br"),t(" Layouts are tailored to work with specific data-models. For example, in order to work properly, the Map Layout requires the Collection have a Map Field configured and the Calendar Layout requires the Collection have a datetime Field configured.")])]),e("li",null,[e("p",null,[e("strong",null,"Controls are different for each Layout."),e("br"),t(" Each Layout presents data differently, so certain customizations may not be functional with certain Layouts. For example, the Map Layout displays each Item as a pin on a map, so this Layout has no controls for sorting.")])]),e("li",null,[e("p",null,[e("strong",null,"Controls for a Layout may be in different locations."),e("br"),t(" Depending on the Layout, the same control may be under Layout Options in the sidebar, the subheader, or on the Page Area "),e("em",null,"(and Items themselves)"),t(". For example, the Table Layout lets you set the Field Values displayed in the subheader while the Card Layout lets you set Field Values displayed in the Layout Options menu.")])])],-1),x=e("h2",{id:"table-layout",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#table-layout"},"#"),t(" Table Layout")],-1),D=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/table-layout.webp",alt:"Table Layout"})],-1),P=e("p",null,"This Layout supports all forms of data, as it directly reflects how data is stored in a Collection. This is the default Layout used in the Content Module. It includes the following controls.",-1),z=e("p",null,[e("strong",null,"Layout Options")],-1),M=e("ul",null,[e("li",null,[e("strong",null,"Spacing"),t(" \u2014 Adjust the vertical space a row takes up.")])],-1),j=e("p",null,[e("strong",null,"Subheader")],-1),O=e("ul",null,[e("li",null,[e("strong",null,"Adjust Column Width"),t(" \u2014 Click and drag the column divider to resize as desired.")]),e("li",null,[e("strong",null,"Add Field"),t(" \u2014 Select "),e("span",{mi:"",icon:""},"add"),t(" in the page subheader and select the desired Field(s).")]),e("li",null,[e("strong",null,"Remove Field"),t(" \u2014 Select "),e("span",{mi:"",icon:""},"arrow_drop_down"),t(" in the column title and click "),e("strong",null,"\u201CHide Field\u201D"),t(".")]),e("li",null,[e("strong",null,"Sort Items by Column"),t(" \u2014 Select "),e("span",{mi:"",icon:""},"arrow_drop_down"),t(" in the column title and sort ascending or descending.")]),e("li",null,[e("strong",null,"Set Text Alignment"),t(" \u2014 Select "),e("span",{mi:"",icon:""},"arrow_drop_down"),t(" in the column title and set left, right, or center.")]),e("li",null,[e("strong",null,"Toggle & Reorder Columns"),t(" \u2014 Click the column header, then drag-and-drop as desired.")]),e("li",null,[e("strong",null,"Select All"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"check_box_outline_blank"),t(" in the selection column header.")])],-1),E=e("p",null,[e("strong",null,"Page Area")],-1),q=e("ul",null,[e("li",null,[e("strong",null,"Select Item(s)"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"check_box_outline_blank"),t(" in the selection column for the desired Item(s).")]),e("li",null,[e("strong",null,"Manually Sort Items"),t(" \u2014 Toggle "),e("span",{mi:"",icon:""},"sort"),t(" in the configured Sort column to drag and drop "),e("span",{mi:"",icon:""},"drag_handle"),t(" Items.")])],-1),B={class:"warning hint"},R=e("div",{class:"hint-title"},"Manual Sorting Requires Configuration",-1),N=e("h2",{id:"card-layout",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#card-layout"},"#"),t(" Card Layout")],-1),V=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/card-layout-20220416A.webp",alt:"Card Layout"})],-1),G=e("em",null,"(e.g. a user or blog post)",-1),K=e("p",null,[e("strong",null,"Layout Options")],-1),U=e("ul",null,[e("li",null,[e("strong",null,"Image Source"),t(" \u2014 Set the Field used as the display image.")]),e("li",null,[e("strong",null,"Title"),t(" \u2014 Set a mix of Field values and text to use as a title.")]),e("li",null,[e("strong",null,"Subtitle"),t(" \u2014 Set a mix of Field values and text to use as a subtitle.")]),e("li",null,[e("strong",null,"Image Fit"),t(" \u2014 Set how an image fits inside the Card.")]),e("li",null,[e("strong",null,"Fallback Icon"),t(" \u2014 Set a default icon to display when an Item has no image.")])],-1),W=e("p",null,[e("strong",null,"Subheader")],-1),H=e("ul",null,[e("li",null,[e("strong",null,"Card Size"),t(" \u2014 Toggle the Card size as it appears in the Page Area.")]),e("li",null,[e("strong",null,"Sort Field"),t(" \u2014 Click to select the Field you wish to sort by from the dropdown menu.")]),e("li",null,[e("strong",null,"Sort Direction"),t(" \u2014 Toggle ascending and descending sort directions.")]),e("li",null,[e("strong",null,"Select All"),t(" \u2014 Click "),e("strong",null,[t("\u201C"),e("span",{mi:"",icon:""},"check_circle"),t(" Select All\u201D")]),t(" in the selection column header.")])],-1),Y=e("p",null,[e("strong",null,"Page Area")],-1),Z=e("ul",null,[e("li",null,[e("strong",null,"Select Item(s)"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"radio_button_unchecked"),t(" in the selection column for the desired Item(s).")]),e("li",null,[e("strong",null,"Adjust Time"),t(" \u2014 Click and drag an Item to change its time.")])],-1),J=e("h2",{id:"calendar-layout",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#calendar-layout"},"#"),t(" Calendar Layout")],-1),Q=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/calendar-layout-20220416A.webp",alt:"Calendar Layout"})],-1),X=e("p",null,[t("This Layout is ideal for Collections with time-oriented data "),e("em",null,"(e.g. events and appointments)"),t(". It includes the following controls.")],-1),$=e("p",null,[e("strong",null,"Layout Options")],-1),ee=e("ul",null,[e("li",null,[e("strong",null,"Display Template"),t(" \u2014 Set a mix of Field values and text to represent Items on the calendar.")]),e("li",null,[e("strong",null,"Start Date Field"),t(" \u2014 Choose Field to determine each Item\u2019s beginning time on the calendar.")]),e("li",null,[e("strong",null,"End Date Field"),t(" \u2014 Choose Field to determine each Item\u2019s ending time on the calendar.")])],-1),te=e("p",null,[e("strong",null,"Subheader")],-1),le=e("ul",null,[e("li",null,[e("strong",null,"Toggle Month and Year"),t(" \u2014 Move across time using the chevrons in the subheader.")]),e("li",null,[e("strong",null,"Today"),t(" \u2014 Click to jump to the current date on the calendar.")]),e("li",null,[e("strong",null,"Month Week Day List"),t(" \u2014 Adjust the time interval used to display Items in the Page Area.")])],-1),oe=e("p",null,[e("strong",null,"Page Area")],-1),ne=e("ul",null,[e("li",null,[e("strong",null,"Select Item"),t(" \u2014 Click an Item on the calendar to open its Item Page.")])],-1),ae=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Configuration Requirements"),e("p",null,[t("To use this Layout, the Collection will need at least one datetime Field to set a start time, but ideally two "),e("em",null,"(to set a start and end time)"),t(".")])],-1),se=e("h2",{id:"map-layout",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#map-layout"},"#"),t(" Map Layout")],-1),ie=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/map-layout-20220416A.webp",alt:"Map Layout"})],-1),ue=e("p",null,"This Layout is ideal for Collections that emphasize geospatial data. It provides a world map, with Items displayed as points, lines, and other geometry. The following options are available:",-1),re=e("p",null,[e("strong",null,"Layout Options")],-1),de=e("ul",null,[e("li",null,[e("strong",null,"Basemap"),t(" \u2014 Choose the map provider used for the Collection.")]),e("li",null,[e("strong",null,"Geospatial Field"),t(" \u2014 Select the geospatial field type to display on screen: "),e("ul",null,[e("li",null,[e("strong",null,"Map JSON Point"),t(" \u2014 Supports latitude-longitude based, single-point locations.")]),e("li",null,[e("strong",null,"Map Geometry"),t(" \u2014 Supports geometric areas such as lines and polygons.")])])]),e("li",null,[e("strong",null,"Display Template"),t(" \u2014 Choose the Fields displayed when hovering over an Item on the map.")]),e("li",null,[e("strong",null,"Cluster Nearby Data"),t(" \u2014 Toggle whether or not nearby Items get clustered into a single pin.")])],-1),ce=e("p",null,[e("strong",null,"Subheader"),e("br"),e("em",null,"There is no Subheader on the Map Layout.")],-1),he=e("p",null,[e("strong",null,"Page Area")],-1),pe=e("ul",null,[e("li",null,[e("strong",null,"Zoom"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"add"),t(" and "),e("span",{mi:"",icon:""},"remove"),t(" in the upper left hand corner of the Page Area to zoom in and out.")]),e("li",null,[e("strong",null,"Zoom to my Location"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"my_location"),t(" to zoom into your current location on the map.")]),e("li",null,[e("strong",null,"Reframe"),t(" \u2014 Click the square in the upper left-hand corner to resize and reframe the map area.")]),e("li",null,[e("strong",null,"Select Item"),t(" \u2014 Click a single Item to enter its Item Page.")]),e("li",null,[e("strong",null,"Select Items"),t(" \u2014 Click and drag to select multiple Items at once, opening the Item Page.")])],-1),ge=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Configuration Requirements"),e("p",null,"To use this Layout, the Collection must have a Map Field configured.")],-1),me=e("h2",{id:"kanban-layout-%5Bcloud-exclusive%5D",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#kanban-layout-%5Bcloud-exclusive%5D"},"#"),t(" Kanban Layout [Cloud Exclusive]")],-1),ye=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/layouts/layouts-20220415A/kanban-layout-20220416A.webp",alt:"Kanban Layout"})],-1),_e=e("p",null,[t("This Layout is ideal for Collections that serve as project management tools or to-do lists, where each Item represents a task, because it groups Items onto columns according to their status "),e("em",null,"(e.g. \u201CNot Started\u201D, \u201CIn Progress\u201D, \u201CUnder Review\u201D, \u201CComplete\u201D, or any other status defined)"),t(". The following controls are available.")],-1),fe=e("p",null,[e("strong",null,"Layout Options")],-1),be=e("ul",null,[e("li",null,[e("strong",null,"Group By"),t(" \u2014 Select the Field used to define Item status. See below for details.")]),e("li",null,[e("strong",null,"Card Title"),t(" \u2014 Choose a Field to serve as a title on each Item.")]),e("li",null,[e("strong",null,"Card Text"),t(" \u2014 Choose a Field to display additional text on each Item.")])],-1),Ce=e("p",null,[e("strong",null,"Layout Options > Advanced")],-1),we=e("ul",null,[e("li",null,[e("strong",null,"Card Tags"),t(" \u2014 Choose a Tag Field to be displayed on the Item.")]),e("li",null,[e("strong",null,"Card Date"),t(" \u2014 Choose a Datetime Field to be displayed on each Item.")]),e("li",null,[e("strong",null,"Card Image"),t(" \u2014 Choose an Image Field to be displayed on each Item.")]),e("li",null,[e("strong",null,"Card Image Fit"),t(" \u2014 Toggle whether the image fit is cropped.")]),e("li",null,[e("strong",null,"Card User"),t(" \u2014 Choose the User Created Field to display their avatar in the bottom right corner.")]),e("li",null,[e("strong",null,"Show Ungrouped"),t(" \u2014 Toggle display of a column containing Items with no assigned status.")])],-1),Le=e("p",null,[e("strong",null,"Subheader"),e("br"),e("em",null,"There is no Subheader for the Kanban Layout.")],-1),ve=e("p",null,[e("strong",null,"Page Area")],-1),Ie=e("ul",null,[e("li",null,[e("strong",null,"Create Task and Assign Status"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"add"),t(" in a status column and the Item Page will open.")]),e("li",null,[e("strong",null,"Sort Panels"),t(" \u2014 Drag and drop Items to reposition or change task status.")]),e("li",null,[e("strong",null,"Add Status Panel"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"add_box"),t(" and add a group name (i.e. new status column).")]),e("li",null,[e("strong",null,"Edit or Delete Status Column"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"more_horiz"),t(" and then click "),e("span",{mi:"",icon:""},"edit"),t(" to edit or "),e("span",{mi:"",icon:""},"delete"),t(" to delete.")])],-1),ke=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Configuration Requirements"),e("p",null,[t("To make this Layout work, you will need to configure an appropriate status Field on the Collection, then identify this Field under "),e("strong",null,"\u201CGroup By\u201D"),t(" in the Layout Options menu.")])],-1),xe="Layouts",De=!1,Pe="Layouts are customized displays for viewing and interacting with the Items in a Collection.",ze="9 min read",Me={__name:"layouts",setup(Se,{expose:i}){const a={title:"Layouts",modularExtension:!1,description:"Layouts are customized displays for viewing and interacting with the Items in a Collection.",readTime:"9 min read"};return i({frontmatter:a}),(Te,Fe)=>{const o=s("router-link"),u=s("docs-wrapper");return r(),d(u,{frontmatter:a},{default:l(()=>[e("div",c,[h,p,g,m,e("p",null,[t("The following sections detail the Layouts managed and supported by the Directus Team. Keep in mind that Directus is open-source, modular and extensible. You are free to create any Layout you need on self-hosted and Enterprise Cloud Projects. Additionally, Directus Cloud is always adding more Layouts to its "),n(o,{to:"/docs/cloud/glossary#extensions"},{default:l(()=>[t("Cloud Exclusive Extensions")]),_:1}),t(", so check back often to stay up-to-date with the latest and greatest. Additionally, you can join the community on "),y,t(" and "),_,t(" to find thousands of engineers guiding development of the Directus platform.")]),f,b,C,w,L,v,I,k,S,T,F,A,x,D,P,z,M,j,O,E,q,e("div",B,[R,e("p",null,[t("Only available if you "),n(o,{to:"/docs/configuration/data-model/collections#sort-field"},{default:l(()=>[t("configure a sort field")]),_:1}),t(" in the Collection\u2019s Data Model Settings.")])]),N,V,e("p",null,[t("This tiled Layout is ideal for Collections that prioritize an image "),G,t(". This is the default for both the "),n(o,{to:"/docs/app/user-directory"},{default:l(()=>[t("User Directory")]),_:1}),t(" and "),n(o,{to:"/docs/app/file-library"},{default:l(()=>[t("File Library")]),_:1}),t(". It includes the following controls.")]),K,U,W,H,Y,Z,J,Q,X,$,ee,te,le,oe,ne,ae,se,ie,ue,re,de,ce,he,pe,ge,me,ye,_e,fe,be,Ce,we,Le,ve,Ie,ke])]),_:1})}}};export{Me as default,Pe as description,De as modularExtension,ze as readTime,xe as title};
