import{a as i,o as u,e as d,y as o,u as e,q as t,z as s}from"./runtime-core.esm-bundler.22ec0346.js";const c={class:"markdown-body"},h=e("blockquote",null,[e("p",null,[t("Operations are the individual actions in a flow. They enable you to do things like manage data within Directus, transform the flow\u2019s data, send information off to outside services, set conditional logic, trigger other flows, "),e("em",null,"and beyond!")])],-1),p={class:"tip hint"},g=e("div",{class:"hint-title"},"Before You Begin",-1),_=e("h2",{id:"condition",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#condition"},"#"),t(" Condition")],-1),f=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/condition-20220603A.webp",alt:"Condition"})],-1),m=e("strong",null,"Condition",-1),w=e("strong",null,"success path",-1),y=e("strong",null,"failure path",-1),v=e("p",null,[e("strong",null,"Options")],-1),b=e("strong",null,"Condition Rules",-1),T=e("p",null,[e("strong",null,"Payload")],-1),k=e("p",null,[t("This operation does not generate data. If the filter rule is configured properly, it will append a "),e("code",null,"null"),t(" value on its "),e("code",null,"operationKey"),t(", regardless of if the condition was met or not. However, if the filter rule is misconfigured, it will append an array containing an object you can use to help debug the misconfiguration.")],-1),D=e("p",null,[e("strong",null,"More Details")],-1),I={class:"warning hint"},S=e("strong",null,"Action (Blocking)",-1),j=e("code",null,"reject",-1),A=e("h2",{id:"run-script",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#run-script"},"#"),t(" Run Script")],-1),E=e("p",null,"This operation lets you add a custom script using vanilla JavaScript or TypeScript.",-1),x=e("p",null,[e("strong",null,"Options")],-1),O=e("p",null,[t("The operation provides a default function template. The "),e("em",null,"optional"),t(),e("code",null,"data"),t(" parameter lets you pass in the data chain as an argument.")],-1),P=e("p",null,[e("strong",null,"Payload")],-1),C=e("p",null,[t("The function\u2019s "),e("code",null,"return"),t(" value will be appended under its "),e("code",null,"<operationKey>"),t(".")],-1),R=e("p",null,[e("strong",null,"More Details")],-1),q=e("p",null,[t("As an example, let\u2019s say you have this function in a script operation, named "),e("code",null,"myScript"),t(".")],-1),F=e("pre",null,[e("code",{class:"language-JSON"},[e("span",{class:"hljs-comment"},"// A key from the data chain"),t(`
`),e("span",{class:"hljs-punctuation"},"{"),t(`
  `),e("span",{class:"hljs-attr"},'"previousOperation"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-punctuation"},"{"),t(`
    `),e("span",{class:"hljs-attr"},'"value"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-number"},"5"),t(`
  `),e("span",{class:"hljs-punctuation"},"}"),t(`
`),e("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),M=e("p",null,"Then you add the following logic via Run Script.",-1),U=e("pre",null,[e("code",{class:"language-TypeScript"},[e("span",{class:"hljs-comment"},"// Your function in the myScript operation"),t(`
`),e("span",{class:"hljs-variable language_"},"module"),t("."),e("span",{class:"hljs-property"},"exports"),t(" = "),e("span",{class:"hljs-keyword"},"function"),t("("),e("span",{class:"hljs-params"},"data"),t(`) {
  `),e("span",{class:"hljs-keyword"},"return"),t(` {
    `),e("span",{class:"hljs-attr"},"timesTwo"),t(": data."),e("span",{class:"hljs-property"},"previousOperation"),t("."),e("span",{class:"hljs-property"},"value"),t(" * "),e("span",{class:"hljs-number"},"2"),t(`
  }
}

`)])],-1),K=e("p",null,[t("The returned value will be appended under the "),e("code",null,"myScript"),t(" operation key.")],-1),N=e("pre",null,[e("code",{class:"language-JSON"},[e("span",{class:"hljs-punctuation"},"{"),t(`
  `),e("span",{class:"hljs-attr"},'"previousOperation"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-punctuation"},"{"),t(`
    `),e("span",{class:"hljs-attr"},'"value"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-number"},"5"),t(`
  `),e("span",{class:"hljs-punctuation"},"}"),e("span",{class:"hljs-punctuation"},","),t(`
  `),e("span",{class:"hljs-attr"},'"myScript"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-punctuation"},"{"),t(`
    `),e("span",{class:"hljs-attr"},'"timesTwo"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-number"},"10"),t(`
  `),e("span",{class:"hljs-punctuation"},"}"),t(`
`),e("span",{class:"hljs-punctuation"},"}"),t(`

`)])],-1),B=e("div",{class:"tip hint"},[e("p",null,[t("Make sure your "),e("code",null,"return"),t(" value is valid JSON.")])],-1),L={class:"tip hint"},H=e("div",{class:"hint-title"},"Throwing Errors",-1),J=e("strong",null,"Run Script",-1),W=e("h2",{id:"create-data",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#create-data"},"#"),t(" Create Data")],-1),Y=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/create-data-20220603A.webp",alt:"Create Data"})],-1),V=e("p",null,"This operation creates item(s) in a collection.",-1),Q=e("p",null,[e("strong",null,"Options")],-1),G=e("ul",null,[e("li",null,[e("strong",null,"Collection"),t(" \u2014 Select the collection you\u2019d like to create items in.")]),e("li",null,[e("strong",null,"Permissions"),t(" \u2014 Select the scope of permissions used for this operation.")]),e("li",null,[e("strong",null,"Emit Events"),t(" \u2014 Toggle whether the event is emitted.")]),e("li",null,[e("strong",null,"Payload"),t(" \u2014 Defines the payload to create item(s) in a collection.")])],-1),z=e("p",null,[e("strong",null,"Payload")],-1),$=e("p",null,[t("An array with the ID(s) of all items created will be appended under its "),e("code",null,"<operationKey>"),t(".")],-1),X=e("p",null,[e("strong",null,"More Details")],-1),Z=e("div",{class:"warning hint"},[e("p",null,[e("strong",null,"Emit Events"),t(" toggles the event\u2019s "),e("em",null,"visibility"),t(" throughout Directus. For example, if togged on, this operation will trigger relevant event hooks in other flows or custom extensions. If toggled off, the operation will not trigger other event hooks. Imagine a situation where you have a flow being triggered by "),e("code",null,"<collection>.items.create"),t(" which contains an operation that then tries to create another item in that "),e("code",null,"<collection>"),t(". This would throw an infinite loop where the operation triggers its own flow, endlessly. However, if you toggle "),e("strong",null,"Emit Events"),t(" off, then this operation no longer triggers other event hooks.")])],-1),ee={class:"tip hint"},te=e("h2",{id:"delete-data",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#delete-data"},"#"),t(" Delete Data")],-1),oe=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/delete-data-20220603A.webp",alt:"Delete Data"})],-1),ne=e("p",null,"This operation deletes item(s) from a collection.",-1),se=e("p",null,[e("strong",null,"Options")],-1),le=e("li",null,[e("strong",null,"Collection"),t(" \u2014 Select the collection you\u2019d like to delete items from.")],-1),ie=e("li",null,[e("strong",null,"Permissions"),t(" \u2014 Set the scope of permissions used for this operation.")],-1),ae=e("li",null,[e("strong",null,"Emit Events"),t(" \u2014 Toggle whether the event is emitted.")],-1),re=e("li",null,[e("strong",null,"IDs"),t(" \u2014 Set Item IDs and press enter to confirm. Click the ID to remove.")],-1),ue=e("strong",null,"Query",-1),de=e("p",null,[e("strong",null,"Payload")],-1),ce=e("p",null,[t("An array with the ID(s) of all items deleted will be appended under its "),e("code",null,"<operationKey>"),t(".")],-1),he=e("p",null,[e("strong",null,"More Details")],-1),pe=e("div",{class:"warning hint"},[e("p",null,[e("strong",null,"Emit Events"),t(" toggles the event\u2019s "),e("em",null,"visibility"),t(" throughout Directus. For example, if togged on, this operation will trigger relevant event hooks in other flows or custom extensions. If toggled off, the operation will not trigger other event hooks. Imagine a situation where you have a flow being triggered by "),e("code",null,"<collection>.items.delete"),t(" which contains an operation that then tries to delete another item in that "),e("code",null,"<collection>"),t(". This would throw an infinite loop where the operation triggers its own flow, endlessly. However, if you toggle "),e("strong",null,"Emit Events"),t(" off, then this operation no longer triggers other event hooks.")])],-1),ge=e("h2",{id:"read-data",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#read-data"},"#"),t(" Read Data")],-1),_e=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/read-data-20220603A.webp",alt:"Read Data"})],-1),fe=e("p",null,"This operation reads item(s) from a collection and adds them onto the data chain. You may select Items by their ID or by running a query.",-1),me=e("p",null,[e("strong",null,"Options")],-1),we=e("li",null,[e("strong",null,"Permissions"),t(" \u2014 Set the scope of permissions used for this operation.")],-1),ye=e("li",null,[e("strong",null,"Collections"),t(" \u2014 Select the collection you\u2019d like to read items from.")],-1),ve=e("li",null,[e("strong",null,"IDs"),t(" \u2014 Input the ID for items you wish to read and press enter. Click the ID to remove.")],-1),be=e("strong",null,"Query",-1),Te=e("li",null,[e("strong",null,"Emit Events"),t(" \u2014 Toggle whether the event is emitted.")],-1),ke=e("p",null,[e("strong",null,"Payload")],-1),De=e("p",null,[t("An array containing all items read will be appended under its "),e("code",null,"<operationKey>"),t(".")],-1),Ie=e("p",null,[e("strong",null,"More Details")],-1),Se=e("div",{class:"warning hint"},[e("p",null,[e("strong",null,"Emit Events"),t(" toggles the event\u2019s "),e("em",null,"visibility"),t(" throughout Directus. For example, if togged on, this operation will trigger relevant event hooks in other flows or custom extensions. If toggled off, the operation will not trigger other event hooks. Imagine a situation where you have a flow being triggered by "),e("code",null,"<collection>.items.read"),t(" which contains an operation that then tries to read another item in that "),e("code",null,"<collection>"),t(". This would throw an infinite loop where the operation triggers its own flow, endlessly. However, if you toggle "),e("strong",null,"Emit Events"),t(" off, then this operation no longer triggers other event hooks.")])],-1),je=e("h2",{id:"update-data",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#update-data"},"#"),t(" Update Data")],-1),Ae=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/update-data-20220603A.webp",alt:"Update Data"})],-1),Ee=e("p",null,"This operation updates item(s) in a collection. You may select item(s) to update by their ID or by running a query.",-1),xe=e("p",null,[e("strong",null,"Options")],-1),Oe=e("li",null,[e("strong",null,"Collection"),t(" \u2014 Select the collection on which you\u2019d like to update items in.")],-1),Pe=e("li",null,[e("strong",null,"Permissions"),t(" \u2014 Set the role that this operation will inherit permissions from.")],-1),Ce=e("li",null,[e("strong",null,"Emit Events"),t(" \u2014 Toggle whether the event is emitted.")],-1),Re=e("li",null,[e("strong",null,"IDs"),t(" \u2014 Input the ID for Item(s) you wish to read and press enter. Click the ID to remove.")],-1),qe=e("strong",null,"Payload",-1),Fe=e("strong",null,"Query",-1),Me=e("p",null,[e("strong",null,"Payload")],-1),Ue=e("p",null,[t("An array containing all items updated will be appended under its "),e("code",null,"<operationKey>"),t(".")],-1),Ke=e("p",null,[e("strong",null,"More Details")],-1),Ne=e("div",{class:"warning hint"},[e("p",null,[e("strong",null,"Emit Events"),t(" toggles the event\u2019s "),e("em",null,"visibility"),t(" throughout Directus. For example, if togged on, this operation will trigger relevant event hooks in other flows or custom extensions. If toggled off, the operation will not trigger other event hooks. Imagine a situation where you have a flow being triggered by "),e("code",null,"<collection>.items.update"),t(" which contains an operation that then tries to update another item in that "),e("code",null,"<collection>"),t(". This would throw an infinite loop where the operation triggers its own flow, endlessly updating items. However, if you toggle "),e("strong",null,"Emit Events"),t(" off, then this operation no longer triggers other event hooks.")])],-1),Be={class:"tip hint"},Le=e("code",null,"payload",-1),He=e("h2",{id:"log-to-console",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#log-to-console"},"#"),t(" Log to Console")],-1),Je=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/log-to-console-20220603A.webp",alt:"Log to Console"})],-1),We=e("p",null,[e("strong",null,"Options")],-1),Ye=e("strong",null,"Message",-1),Ve=e("p",null,[e("strong",null,"Payload")],-1),Qe=e("p",null,[t("This operation does not generate data for the data chain as its messages are for debugging and troubleshooting. It will append a "),e("code",null,"null"),t(" value on the "),e("code",null,"operationKey"),t(".")],-1),Ge=e("p",null,[e("strong",null,"More Details")],-1),ze=e("h2",{id:"send-email",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#send-email"},"#"),t(" Send Email")],-1),$e=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/send-email-20220603A.webp",alt:"Send Email"})],-1),Xe=e("p",null,"This operation sends off emails.",-1),Ze=e("p",null,[e("strong",null,"Options")],-1),et=e("ul",null,[e("li",null,[e("strong",null,"To"),t(" \u2014 Sets the email addresses. Hit "),e("code",null,"\u21B5"),t(),e("code",null,"Enter"),t(" (PC) or "),e("code",null,"return"),t(" (Mac) to save the email. Click on a pill to remove it.")]),e("li",null,[e("strong",null,"Subject"),t(" \u2014 Set the subject line.")]),e("li",null,[e("strong",null,"Body"),t(" \u2014 Use a Markdown or WYSIWYG editor to create the email body.")])],-1),tt=e("p",null,[e("strong",null,"Payload")],-1),ot=e("p",null,[t("This operation does not generate data for the data chain. It will append a "),e("code",null,"null"),t(" value on the "),e("code",null,"operationKey"),t(".")],-1),nt=e("p",null,[e("strong",null,"More Details")],-1),st=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Batch Emails"),e("p",null,[t("You can input an array of emails in the "),e("code",null,"To"),t(" input option to send off multiple emails.")])],-1),lt=e("div",{class:"tip hint"},[e("p",null,[t("If you are testing out this operation from "),e("code",null,"localhost:8080"),t(", be sure to check your spam box, because your email provider may send it there automatically.")])],-1),it=e("h2",{id:"send-notification",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#send-notification"},"#"),t(" Send Notification")],-1),at=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/send-notification-20220603A.webp",alt:"Send Notification"})],-1),rt=e("p",null,"This operation pushes notifications to Directus Users. If the operation executes successfully, a list containing the IDs of all sent notifications generated is appended under this operation\u2019s key.",-1),ut=e("p",null,[e("strong",null,"Options")],-1),dt=e("ul",null,[e("li",null,[e("strong",null,"Users"),t(" \u2014 Define a user by their UUID. Hit "),e("code",null,"\u21B5"),t(),e("code",null,"Enter"),t(" (PC) or "),e("code",null,"return"),t(" (Mac) to save it. Click on a pill to remove it.")]),e("li",null,[e("strong",null,"Permissions"),t(" \u2014 Define the role that this operation will inherit permissions from.")]),e("li",null,[e("strong",null,"Title"),t(" \u2014 Set the title of the notification.")]),e("li",null,[e("strong",null,"Message"),t(" \u2014 Set the main body of the notification.")])],-1),ct=e("p",null,[e("strong",null,"Payload")],-1),ht=e("p",null,[t("This operation does not generate data. It will append a "),e("code",null,"null"),t(" value on its "),e("code",null,"operationKey"),t(".")],-1),pt=e("p",null,[e("strong",null,"More Details")],-1),gt=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Batch Notifications"),e("p",null,[t("You can input an array of UUIDs in the "),e("code",null,"To"),t(" input option to send off multiple emails.")])],-1),_t=e("h2",{id:"webhook-%2F-request-url",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#webhook-%2F-request-url"},"#"),t(" Webhook / Request URL")],-1),ft=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/webhook-20220603A.webp",alt:"Webhook / Request URL"})],-1),mt=e("p",null,"This operation makes a request to another URL.",-1),wt=e("p",null,[e("strong",null,"Options")],-1),yt=e("ul",null,[e("li",null,[e("strong",null,"Method"),t(" \u2014 Choose to make a GET, POST, PATCH, DELETE, or other type of request.")]),e("li",null,[e("strong",null,"URL"),t(" \u2014 Define the URL to send the request to.")]),e("li",null,[e("strong",null,"Headers"),t(" \u2014 Create a new "),e("code",null,"header:value"),t(" to pass along with the request.")]),e("li",null,[e("strong",null,"Request Body"),t(" \u2014 Set the request body\u2019s data.")])],-1),vt=e("p",null,[e("strong",null,"Payload")],-1),bt=e("p",null,[t("When an operation completes successfully, the "),e("code",null,"response"),t(" is appended under its "),e("code",null,"<operationKey"),t(".")],-1),Tt=e("h2",{id:"sleep",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#sleep"},"#"),t(" Sleep")],-1),kt=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/sleep-20220603A.webp",alt:"Sleep"})],-1),Dt=e("p",null,"This operation creates a delay in the Flow for a given amount of milliseconds, then continues to the next operation.",-1),It=e("p",null,[e("strong",null,"Options")],-1),St=e("ul",null,[e("li",null,[e("strong",null,"Milliseconds"),t(" \u2014 Define the number of milliseconds to sleep.")])],-1),jt=e("p",null,[e("strong",null,"Payload")],-1),At=e("p",null,[t("This operation does not generate data. It will append a "),e("code",null,"null"),t(" value on its "),e("code",null,"operationKey"),t(".")],-1),Et=e("h2",{id:"transform-payload",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#transform-payload"},"#"),t(" Transform Payload")],-1),xt=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/transform-payload-20220603A.webp",alt:"Transform Payload"})],-1),Ot=e("p",null,"This operation lets you custom define your own JSON payload for use in subsequent operations. This enables you to take multiple sources of data and \u201Ctidy them up\u201D into a single payload.",-1),Pt=e("p",null,[e("strong",null,"Options")],-1),Ct=e("ul",null,[e("li",null,[e("strong",null,"JSON"),t(" \u2014 Define JSON to insert into the data chain.")])],-1),Rt=e("p",null,[e("strong",null,"Payload")],-1),qt=e("p",null,[t("When an operation completes successfully, the value you defined under the "),e("strong",null,"JSON"),t(" configuration operation is appended onto its "),e("code",null,"operationKey"),t(".")],-1),Ft=e("p",null,[e("strong",null,"More Details")],-1),Mt=e("p",null,[t("When does the Transform Payload operation come in handy? Let\u2019s say you need to create a payload with data from a "),e("code",null,"users_collection"),t(", "),e("code",null,"widgets_collection"),t(" and some 3rd party resource which processes the data. You can add a "),e("a",{href:"#read-data"},"Read Data"),t(" operation for "),e("code",null,"collection_a"),t(", another Read Data operation for "),e("code",null,"collection_b"),t(", and a "),e("a",{href:"#webhook--request-url"},"Webhook"),t(" operation for the third party resource.")],-1),Ut=e("p",null,"Then you could stitch together all this data to create a new JSON object, like so:",-1),Kt=e("pre",null,[e("code",null,`{
	"note": "You can add a hard-coded value!",
	"name": "{{users_collection.username}}",
	"widget_id": "{{widgets_collection.id}}",
	"results": "{{webhookKey.subnestedValue}}"
}
`)],-1),Nt=e("h2",{id:"trigger-flow",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#trigger-flow"},"#"),t(" Trigger Flow")],-1),Bt=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/operations/operations-20220603A/trigger-flow-20220603A.webp",alt:"Trigger Flow"})],-1),Lt=e("em",null,"(optionally)",-1),Ht=e("p",null,[e("strong",null,"Options")],-1),Jt=e("ul",null,[e("li",null,[e("strong",null,"Flow"),t(" \u2014 Define a flow by its primary key UUID.")]),e("li",null,[e("strong",null,"Payload"),t(" \u2014 Defines a JSON "),e("code",null,"payload"),t(" to pass into "),e("code",null,"$trigger"),t(" on the flow it triggered.")])],-1),Wt=e("p",null,[e("strong",null,"Payload")],-1),Yt=e("p",null,[t("If you\u2019ve configured a "),e("strong",null,"Response Body"),t(" in the trigger of the other flow, this will be appended under this "),e("code",null,"operationKey"),t(". If no "),e("strong",null,"Response Body"),t(" is configured, "),e("code",null,"null"),t(" is appended under this "),e("code",null,"operationKey"),t(".")],-1),Vt=e("p",null,[e("strong",null,"More Details")],-1),Qt=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Flows for-loops"),e("p",null,"If you pass an array to the other flow, the other flow will run once for each item in the array.")],-1),Zt="Operations",eo=!1,to="Operations are the individual actions in a flow. They enable you to do things like manage data within Directus, transform the flow's data, send information off to outside services, set conditional logic, trigger other flows, and beyond!",oo="5 min read",no={__name:"operations",setup(Gt,{expose:a}){const l={title:"Operations",modularExtension:!1,description:"Operations are the individual actions in a flow. They enable you to do things like manage data within Directus, transform the flow's data, send information off to outside services, set conditional logic, trigger other flows, and beyond!",readTime:"5 min read"};return a({frontmatter:l}),(zt,$t)=>{const n=i("router-link"),r=i("docs-wrapper");return u(),d(r,{frontmatter:l},{default:o(()=>[e("div",c,[h,e("div",p,[g,e("p",null,[t("On this page, we\u2019ll explain what each operation does, the value it appends to the data chain, how to make use of its configuration options, as well as any well as other relevant details. We will assume you have read the documentation on "),s(n,{to:"/docs/configuration/flows"},{default:o(()=>[t("Flows")]),_:1}),t(" and "),s(n,{to:"/docs/configuration/flows/triggers"},{default:o(()=>[t("Triggers")]),_:1}),t(".")])]),_,f,e("p",null,[t("A "),m,t(" operation lets you choose a "),w,t(" or "),y,t(" by validating data passed into it with "),s(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")]),v,e("ul",null,[e("li",null,[b,t(" \u2014 Create conditions with "),s(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")])]),T,k,D,e("div",I,[e("p",null,[t("When using an "),s(n,{to:"/docs/configuration/flows/triggers.md#event-hook"},{default:o(()=>[t("Event Hook")]),_:1}),t(" configured to be "),S,t(", if your flow ends with a condition that executes with a "),j,t(" path, it will cancel your database transaction.")])]),A,E,x,O,P,C,R,q,F,M,U,K,N,B,e("div",L,[H,e("p",null,[t("If you throw an error in a "),J,t(" operation, it will immediately break your flow chain and stop execution of subsequent flows. If you used a "),s(n,{to:"/docs/configuration/flows/triggers.md#event-hook"},{default:o(()=>[t("\u201CBlocking\u201D Event hook")]),_:1}),t(", throwing an error will cancel the original event transaction to the database.")])]),W,Y,V,Q,G,z,$,X,Z,e("div",ee,[e("p",null,[t("To learn about payload requirements when creating an item, see "),s(n,{to:"/docs/reference/items"},{default:o(()=>[t("API Reference > Items")]),_:1}),t(".")])]),te,oe,ne,se,e("ul",null,[le,ie,ae,re,e("li",null,[ue,t(" \u2014 Select items to delete with a query. To learn more, see "),s(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")])]),de,ce,he,pe,ge,_e,fe,me,e("ul",null,[we,ye,ve,e("li",null,[be,t(" \u2014 Select the items with a query. To learn more, see "),s(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")]),Te]),ke,De,Ie,Se,je,Ae,Ee,xe,e("ul",null,[Oe,Pe,Ce,Re,e("li",null,[qe,t(" \u2014 Update Items in a collection. To learn more, see "),s(n,{to:"/docs/reference/items"},{default:o(()=>[t("API > Items")]),_:1}),t(".")]),e("li",null,[Fe,t(" \u2014 Select items to update with a query. To learn more, see "),s(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")])]),Me,Ue,Ke,Ne,e("div",Be,[e("p",null,[t("To learn about "),Le,t(" requirements when updating an item, see "),s(n,{to:"/docs/reference/items"},{default:o(()=>[t("API Reference > Items")]),_:1}),t(".")])]),He,Je,e("p",null,[t("This operation outputs information to the server-side console as well as the "),s(n,{to:"/docs/configuration/flows#logs"},{default:o(()=>[t("Logs")]),_:1}),t(" within the Data Studio. This is a key tool for troubleshooting flow configuration. A Log operation\u2019s key will have a null value on the data chain.")]),We,e("ul",null,[e("li",null,[Ye,t(" \u2014 Sets a "),s(n,{to:"/docs/configuration/flows#logs"},{default:o(()=>[t("log message")]),_:1}),t(".")])]),Ve,Qe,Ge,e("p",null,[t("For more details, see the section on "),s(n,{to:"/docs/configuration/flows#logs"},{default:o(()=>[t("Logs")]),_:1}),t(".")]),ze,$e,Xe,Ze,et,tt,ot,nt,st,lt,it,at,rt,ut,dt,ct,ht,pt,gt,_t,ft,mt,wt,yt,vt,bt,Tt,kt,Dt,It,St,jt,At,Et,xt,Ot,Pt,Ct,Rt,qt,Ft,Mt,Ut,Kt,Nt,Bt,e("p",null,[t("This operation starts another flow and "),Lt,t(" passes data into it. It should be used in combination with the "),s(n,{to:"/docs/configuration/flows/triggers#another-flow"},{default:o(()=>[t("Another Flow")]),_:1}),t(" trigger.")]),Ht,Jt,Wt,Yt,Vt,Qt])]),_:1})}}};export{no as default,to as description,eo as modularExtension,oo as readTime,Zt as title};
