import{a as s,o as c,e as d,y as o,u as e,q as t,z as a}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},p=e("blockquote",null,[e("p",null,"The App is a no-code presentation layer for your data, content, and assets. It uses an intuitive left-to-right visual hierarchy for general organization and navigation.")],-1),h=e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/overview/app-overview-20220810A.svg",alt:"Directus Application Overview",class:"no-shadow"},null,-1),g=e("h2",{id:"1.-module-bar",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#1.-module-bar"},"#"),t(" 1. Module Bar")],-1),f=e("p",null,"The leftmost section of the App is the module bar, which includes the:",-1),_=e("li",null,[e("strong",null,"Project Logo"),t(" \u2014 Displays your configured project logo and project color (defaults to the Directus logo and color). If configured, clicking this component will navigate to the Project URL. During platform activity, an indeterminate progress indicator will also be shown here.")],-1),m=e("strong",null,"Module Navigation",-1),v=e("strong",null,"Notifications",-1),y=e("li",null,[e("strong",null,"Current User Menu"),t(" \u2014 This component displays the authenticated user\u2019s name and avatar. "),e("ul",null,[e("li",null,"Sign Out \u2014 Hovering over the User Menu exposes the button to log out of the platform.")])],-1),b=e("h2",{id:"2.-navigation-bar",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#2.-navigation-bar"},"#"),t(" 2. Navigation Bar")],-1),w=e("p",null,"The navigation bar is based on the current module, and includes:",-1),A=e("strong",null,"Project Name",-1),T=e("strong",null,"Navigation",-1),x=e("h2",{id:"3.-page",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#3.-page"},"#"),t(" 3. Page")],-1),k=e("p",null,"This is where the current page\u2019s content is shown, including:",-1),P=e("ul",null,[e("li",null,[e("strong",null,"Header"),t(" \u2014 A fixed section at the top of each page, the header includes: "),e("ul",null,[e("li",null,"Page Icon \u2014 Clicking this navigates back to the previous page."),e("li",null,"Module Name \u2014 Clicking this navigates to the parent module/section."),e("li",null,"Page Title \u2014 Displays dynamic title of the current page."),e("li",null,"Action Buttons \u2014 Right-aligned contextual buttons for specific page actions.")])]),e("li",null,[e("strong",null,"Page Content"),t(" \u2014 This displays the content of the page you navigated to.")])],-1),N=e("h2",{id:"4.-sidebar",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#4.-sidebar"},"#"),t(" 4. Sidebar")],-1),C=e("p",null,"The sidebar provides additional context and options for the current page, including:",-1),j=e("ul",null,[e("li",null,[e("strong",null,"Page Components"),t(" \u2014 Lists any contextual page components available. The \u201CInfo\u201D component is available on every page, explaining the page\u2019s general purpose and relevant details. Clicking any sidebar component will accordion it open. If the App window is large enough, the sidebar will automatically open, and can be closed by clicking the \u201CX\u201D in the top-right.")]),e("li",null,[e("strong",null,"Notifications Tray"),t(" \u2014 Fixed to the bottom of the page sidebar, this button opens a tray of recent user notifications, and provides a link to your Activity Log page.")])],-1),M="The Application",z=!1,L="The App is a no-code presentation layer for your data, content, and assets.",U="3 min read",O={__name:"overview",setup(B,{expose:l}){const i={title:"The Application",modularExtension:!1,description:"The App is a no-code presentation layer for your data, content, and assets.",readTime:"3 min read"};return l({frontmatter:i}),(I,S)=>{const n=s("router-link"),r=s("docs-wrapper");return c(),d(r,{frontmatter:i},{default:o(()=>[e("div",u,[p,h,g,f,e("ul",null,[_,e("li",null,[m,t(" \u2014 Allows navigating between the different modules your user has access to. Customizing the Module Navigation is done within the "),a(n,{to:"/docs/app/settings"},{default:o(()=>[t("Project Settings")]),_:1}),t(", but the default module list includes: "),e("ul",null,[e("li",null,[a(n,{to:"/docs/app/content/collections"},{default:o(()=>[t("Content")]),_:1}),t(" \u2014 The primary way to view and interact with database content")]),e("li",null,[a(n,{to:"/docs/app/user-directory"},{default:o(()=>[t("User Directory")]),_:1}),t(" \u2014 A dedicated section for the platform\u2019s system Users")]),e("li",null,[a(n,{to:"/docs/app/file-library"},{default:o(()=>[t("File Library")]),_:1}),t(" \u2014 An aggregate of all files uploaded and managed within the platform")]),e("li",null,[a(n,{to:"/docs/app/insights"},{default:o(()=>[t("Insights")]),_:1}),t(" \u2014 Access to infinitely customizable data dashboards")]),e("li",null,[a(n,{to:"/docs/app/overview"},{default:o(()=>[t("App Guide")]),_:1}),t(" \u2014 A tailored, in-app portal for the platform\u2019s concepts, guides, and reference")]),e("li",null,[a(n,{to:"/docs/app/settings"},{default:o(()=>[t("Settings")]),_:1}),t(" \u2014 An admin-only section for configuring the project and system settings")])])]),e("li",null,[v,t(" - Opens a drawer of notifications, such as from "),a(n,{to:"/docs/app/content/items#mentions"},{default:o(()=>[t("mentions")]),_:1}),t(".")]),y]),b,w,e("ul",null,[e("li",null,[A,t(" \u2014 Shows an icon and tooltip indicating the API\u2019s connection strength, and the name of your current project, which can be configured under "),a(n,{to:"/docs/app/settings"},{default:o(()=>[t("Project Settings")]),_:1}),t(".")]),e("li",null,[T,t(" \u2014 This is a dynamic navigation based on your current module. Some modules also support "),a(n,{to:"/docs/getting-started/glossary#presets"},{default:o(()=>[t("Bookmark Presets")]),_:1}),t(", which are a customizable links to specific data-sets.")])]),x,k,P,N,C,j])]),_:1})}}};export{O as default,L as description,z as modularExtension,U as readTime,M as title};
