import{a as i,o as u,e as c,y as o,u as e,q as t,z as s}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},h=e("blockquote",null,[e("p",null,[t("This is where you can adjust all of the "),e("strong",null,"global"),t(" settings for your project, such as project name, default language, custom CSS, password policies, "),e("em",null,"and more!"),t(" Changes saved here are instantly reflected throughout your project.")])],-1),p={class:"tip hint"},g=e("div",{class:"hint-title"},"Learn More",-1),m=e("h2",{id:"configure-project-settings",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#configure-project-settings"},"#"),t(" Configure Project Settings")],-1),f=e("video",{title:"How to Configure Project Settings",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/configure-a-project-20220815A.mp4",type:"video/mp4"})],-1),_=e("p",null,"To configure Project Settings, follow these steps.",-1),y=e("ol",null,[e("li",null,[t("Navigate to "),e("strong",null,"Settings > Project Settings"),t(".")]),e("li",null,"Configure settings as desired."),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"check"),t(" to confirm.")])],-1),b=e("p",null,"All configuration options are described in detail below.",-1),w=e("h2",{id:"general",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#general"},"#"),t(" General")],-1),v=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/general-project-settings-20220811A.webp",alt:"How to Configure General Project Settings"})],-1),S=e("strong",null,"Project Name",-1),j=e("li",null,[e("strong",null,"Project Descriptor"),t(" \u2014 Sets the descriptor shown below the Project Name.")],-1),k=e("strong",null,"Project URL",-1),x=e("li",null,[e("strong",null,"Default Language"),t(" \u2014 Sets the default language used within the app.")],-1),P=e("h2",{id:"branding-%26-style",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#branding-%26-style"},"#"),t(" Branding & Style")],-1),A=e("video",{title:"How to Configure Branding and Style in Project Settings",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/branding-and-style-20220811A.mp4",type:"video/mp4"})],-1),T=e("li",null,[e("strong",null,"Project Color"),t(" \u2014 Sets color on the project logo, FavIcon and login/public pages.")],-1),C=e("strong",null,"Project Logo",-1),N=e("li",null,[e("strong",null,"Public Foreground"),t(" \u2014 Adds image on the public page\u2019s right-pane "),e("em",null,"(max-width 400px)"),t(".")],-1),B=e("li",null,[e("strong",null,"Public Background"),t(" \u2014 Adds image displayed behind the public foreground image, shown full-bleed within the public page\u2019s right-pane. When a public background image is not set, the project color is used instead.")],-1),M=e("li",null,[e("strong",null,"Public Note"),t(" \u2014 A helpful note displayed at the bottom of the public page\u2019s right-pane, supports markdown for rich-text formatting.")],-1),F=e("li",null,[e("strong",null,"Custom CSS"),t(" \u2014 Applies custom CSS rules to override the Data Studio\u2019s default styling. Be aware that the Data Studio\u2019s core code, and therefore its DOM selectors, can change at any time. These updates are not considered a breaking change.")],-1),q=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Browser FavIcon & Title"),e("p",null,"The Project Color is also used to set a dynamic FavIcon and the Project Name is used in the browser\u2019s page title, making it easier to identify different Directus projects.")],-1),D=e("h2",{id:"modules",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#modules"},"#"),t(" Modules")],-1),I=e("video",{title:"How to Configure the Module Bar in Project Settings",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/module-bar-20220811A.mp4",type:"video/mp4"})],-1),L=e("strong",null,"Module Bar",-1),H=e("li",null,[e("strong",null,"Toggle Visibility"),t(" \u2014 Toggle "),e("span",{mi:"",icon:""},"check_box_outline_blank"),t(" to set module link visibility in the Navigation Bar.")],-1),R=e("li",null,[e("strong",null,"Manually Sort Modules"),t(" \u2014 Click "),e("span",{mi:"",icon:""},"drag_handle"),t(" and drag to reorder module links as desired.")],-1),U=e("strong",null,"Add Link",-1),z=e("strong",null,"Add Link",-1),W=e("li",null,[e("strong",null,"Name"),t(" \u2014 Sets the title of the module link, also shown in a tooltip on hover.")],-1),G=e("li",null,[e("strong",null,"Icon"),t(" \u2014 Selects an icon for the module button.")],-1),O=e("strong",null,"URL",-1),V=e("code",null,"/",-1),E=e("h2",{id:"security",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#security"},"#"),t(" Security")],-1),J=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/security-project-settings-20220811A.webp",alt:"How to Configure Security in Project Settings"})],-1),K=e("ul",null,[e("li",null,[e("strong",null,"Auth Password Policy"),t(" \u2014 Sets a policy requirement for all user\u2019s passwords via a JavaScript regex. Supports the following options: "),e("ul",null,[e("li",null,[e("strong",null,"None"),t(" \u2014 Not recommended.")]),e("li",null,[e("strong",null,"Weak"),t(" \u2014 Minimum of 8 characters.")]),e("li",null,[e("strong",null,"Strong"),t(" \u2014 Uppercase, lowercase, numbers, and special characters.")]),e("li",null,[e("strong",null,"Other"),t(" \u2014 Set custom policy with JavaScript regex.")])])]),e("li",null,[e("strong",null,"Auth Login Attempts"),t(" \u2014 Sets the number of failed login attempts allowed before a user\u2019s account is locked. Once locked, an Admin user is required to unlock the account.")])],-1),Q=e("h2",{id:"files-%26-storage",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#files-%26-storage"},"#"),t(" Files & Storage")],-1),X=e("video",{title:"How to configure Files and Storage in Project Settings",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/transformation-presets-20220815A.mp4",type:"video/mp4"})],-1),Y=e("p",null,"The platform\u2019s file middleware allows for cropping and transforming image assets on the fly. This means you can simply request an original image, include any desired parameters, and you\u2019ll be served the new asset as a response.",-1),Z=e("p",null,"To help stop malicious users from using up your storage by requesting a large number of random sizes, you can use the following options to limit what transformations are possible.",-1),$=e("ul",null,[e("li",null,[e("strong",null,"Allowed Transformations"),t(" \u2014 For enabling, disabling, or limiting image transformations.")]),e("li",null,[e("strong",null,"Default Folder"),t(" \u2014 Sets the default folder where new assets are added. This does not affect existing files. Be aware that fields may override this value.")]),e("li",null,[e("strong",null,"Transformation Presets"),t(" \u2014 Sets a specific image transformation configuration to simplify requests or limit usage. "),e("ul",null,[e("li",null,[e("strong",null,"Key"),t(" \u2014 Sets unique identifier allowing faster and easier image transformation requests.")]),e("li",null,[e("strong",null,"Fit"),t(" \u2014 Contain "),e("em",null,"(keeps aspect ratio)"),t(", Cover "),e("em",null,"(exact size)"),t(", Fit Inside, or Fit Outside.")]),e("li",null,[e("strong",null,"Width"),t(" \u2014 Sets the width of the image.")]),e("li",null,[e("strong",null,"Height"),t(" \u2014 Sets the height of the image.")]),e("li",null,[e("strong",null,"Quality"),t(" \u2014 Adjusts the compression or quality of the image.")]),e("li",null,[e("strong",null,"Upscaling"),t(" \u2014 When enabled, images won\u2019t be upscaled.")]),e("li",null,[e("strong",null,"Format"),t(" \u2014 Changes the output format to JPG, PNG, WebP, or TIFF.")]),e("li",null,[e("strong",null,"Additional Transformations"),t(" \u2014 Adds additional transformations using "),e("a",{href:"https://sharp.pixelplumbing.com/api-constructor",target:"_blank",rel:"noopener noreferrer"},"Sharp"),t(".")])])])],-1),ee={class:"tip hint"},te=e("div",{class:"hint-title"},"How to Use Transformation Presets",-1),oe=e("h2",{id:"mapping",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#mapping"},"#"),t(" Mapping")],-1),ne=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/mapping-project-settings-20220815A.webp",alt:"How to Configure Mapping in Directus"})],-1),se=e("ul",null,[e("li",null,[e("strong",null,"Mapbox Access Token"),t(" \u2014 Create a "),e("a",{href:"https://docs.mapbox.com/help/glossary/access-token",target:"_blank",rel:"noopener noreferrer"},"Mapbox Access Token"),t(" and enter it here to improve the platform\u2019s mapping experience.")]),e("li",null,[e("strong",null,"Basemaps"),t(" \u2014 Click "),e("strong",null,"Create New"),t(" to set a custom tile configuration that overrides the Mapbox defaults. "),e("ul",null,[e("li",null,[e("strong",null,"Name"),t(" \u2014 Sets a custom name to identify the basemap preset.")]),e("li",null,[e("strong",null,"Type"),t(" \u2014 Sets tile type. Choose from Raster, Raster TileJSON, or Mapbox Style.")]),e("li",null,[e("strong",null,"Tile Size"),t(" \u2014 Sets a tile size (in pixels).")]),e("li",null,[e("strong",null,"URL"),t(" \u2014 Sets the URL to request your tiles from.")]),e("li",null,[e("strong",null,"Attribution"),t(" \u2014 Sets attribution information.")])])])],-1),le=e("h2",{id:"image-editor",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#image-editor"},"#"),t(" Image Editor")],-1),ie=e("video",{title:"How to configure Image Editor Project Settings in Directus",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/project-settings/project-settings-20220815/image-editor-20220815A.mp4",type:"video/mp4"})],-1),re=e("strong",null,"Custom Aspect Ratios",-1),ae=e("ul",null,[e("li",null,[e("strong",null,"Text"),t(" \u2014 Sets a name to identify the aspect ratio.")]),e("li",null,[e("strong",null,"Value"),t(" \u2014 Sets the aspect ratio with a fraction.")])],-1),ue=e("p",null,[t("For example, if you want a 16:10 aspect ratio, you would type in "),e("code",null,"1.6"),t(", which is derived from 16/10, which equals 1.6. If the intended aspect ratio is 16:9, the value would be 16 divided by 9, rounded to 1.7778.")],-1),ge="Project Settings",me=!1,fe="This is where you can adjust all of the **global** settings for your project. Changes saved here are instantly reflected throughout the platform.",_e="4 min read",ye={__name:"project-settings",setup(ce,{expose:r}){const l={title:"Project Settings",modularExtension:!1,description:"This is where you can adjust all of the **global** settings for your project. Changes saved here are instantly reflected throughout the platform.",readTime:"4 min read"};return r({frontmatter:l}),(de,he)=>{const n=i("router-link"),a=i("docs-wrapper");return u(),c(a,{frontmatter:l},{default:o(()=>[e("div",d,[h,e("div",p,[g,e("p",null,[t("To manage your project settings programmatically, see our API documentation on "),s(n,{to:"/docs/reference/system/settings"},{default:o(()=>[t("settings")]),_:1}),t(".")])]),m,f,_,y,b,w,v,e("ul",null,[e("li",null,[S,t(" \u2014 Sets the name on the "),s(n,{to:"/docs/app/overview.html#_2-navigation-bar"},{default:o(()=>[t("Navigation Bar")]),_:1}),t(", as well as login and public pages.")]),j,e("li",null,[k,t(" \u2014 Sets URL when clicking the logo at the top of the "),s(n,{to:"/docs/app/overview.html#_1-module-bar"},{default:o(()=>[t("Module Bar")]),_:1}),t(".")]),x]),P,A,e("ul",null,[T,e("li",null,[C,t(" \u2014 Adds a 40x40px logo at the top of the "),s(n,{to:"/docs/app/overview.html#_1-module-bar"},{default:o(()=>[t("Module Bar")]),_:1}),t(" and on the login/public pages. The image is inset within a 64x64px square filled with the project color. We recommend using a PNG file for optimal compatibility.")]),N,B,M,F]),q,D,I,e("ul",null,[e("li",null,[L,t(" \u2014 Allows the following customization of links displayed in the "),s(n,{to:"/docs/app/overview.html#_1-module-bar"},{default:o(()=>[t("Module Bar")]),_:1}),t(". "),e("ul",null,[H,R,e("li",null,[U,t(" \u2014 To add a new custom link, click "),z,t(" and fill in the details below. "),e("ul",null,[W,G,e("li",null,[O,t(" \u2014 Should start with a "),V,t(" for links within the "),s(n,{to:"/docs/app/overview"},{default:o(()=>[t("Directus Data Studio")]),_:1}),t(".")])])])])])]),E,J,K,Q,X,Y,Z,$,e("div",ee,[te,e("p",null,[t("To learn more, please see the API guide on "),s(n,{to:"/docs/reference/files.html#preset-transformations"},{default:o(()=>[t("transformation presets")]),_:1}),t(".")])]),oe,ne,se,le,ie,e("ul",null,[e("li",null,[re,t(" \u2014 Adds custom aspect ratios in the "),s(n,{to:"/docs/app/file-library#edit-an-image"},{default:o(()=>[t("image editor")]),_:1}),t(". "),ae])]),ue])]),_:1})}}};export{ye as default,fe as description,me as modularExtension,_e as readTime,ge as title};
