import{a as i,o as r,e as d,y as o,u as e,q as t,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,[t("This quickstart guide is designed to get you up and running with a Directus Cloud Project in a snap. Along the way, you will better understand what Directus is, setup your free Directus Cloud Account, get a "),e("em",null,"hands-on introduction"),t(" to the App and API, and find more resources to deep-dive into.")])],-1),p=e("h2",{id:"1.-create-cloud-account-and-login",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#1.-create-cloud-account-and-login"},"#"),t(" 1. Create Cloud Account and Login")],-1),m=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/create-account-and-login-20220427.mp4",type:"video/mp4"})],-1),_=e("a",{href:"https://directus.cloud/login",target:"_blank",rel:"noopener noreferrer"},"Directus Cloud",-1),g=e("p",null,"Your Directus Cloud Account allows you to create and manage any number of Community and Standard Projects. We\u2019ve made life easier by giving you the option to create and log in to your free Cloud Account automatically with GitHub. If you don\u2019t have a GitHub account or prefer not to use this login method, email-and-password login is available as well.",-1),f=e("p",null,"The very first time you log in to your cloud account, you will be prompted to create a Team. Teams are totally free to create. Each Directus Cloud Project exists within the scope of one Team. They allow you to organize Team Members, Projects and Project Billing as desired.",-1),y=e("p",null,"Once your Team is created, it\u2019s time to create your free Community Cloud Project!",-1),b={class:"tip hint"},w=e("div",{class:"hint-title"},"Learn More About Cloud",-1),v=e("h2",{id:"2.-create-and-access-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#2.-create-and-access-project"},"#"),t(" 2. Create and Access Project")],-1),C=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/create-and-access-project-20220427A.mp4",type:"video/mp4"})],-1),A=e("p",null,"To create a Community Project, follow the steps below:",-1),k=e("li",null,[t("Navigate to "),e("strong",null,"\u201CProjects\u201D"),t(" and click "),e("strong",null,"\u201CCreate Project\u201D"),t(".")],-1),P=e("li",null,"Set the Project Name.",-1),j=e("li",null,"Select the Community tier.",-1),I=e("li",null,[t("Scroll to the bottom of the screen and choose the "),e("strong",null,"\u201CEmpty Project\u201D"),t(" Starting Template."),e("br"),t(" Note: The "),e("strong",null,"\u201CDemo Project\u201D"),t(" adds in dummy data for in-depth feature demonstrations.")],-1),T=e("li",null,[t("Click "),e("strong",null,"\u201CCreate Project\u201D"),t(".")],-1),x=e("p",null,[e("em",null,"It should take around 90 seconds for the Cloud Project to build out. During this time, a link will be sent to the email associated with your Cloud Account. The email will contain your Project URL as well as an email and password to login. If you used GitHub to create your account, this will be your GitHub email. Once the build is complete, it\u2019s time log in!")],-1),D={start:"7"},S=e("li",null,"Log in with your username and password from the email.",-1),F=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Check All Inbox Folders"),e("p",null,"Due to the algorithms used by some email providers, it is possible the email containing your Project login information will end up in another folder like \u201CSocial\u201D or \u201CPromotions\u201D.")],-1),M={class:"tip hint"},q=e("div",{class:"hint-title"},"Learn More About Cloud Projects",-1),L=e("h2",{id:"3.-create-a-collection",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#3.-create-a-collection"},"#"),t(" 3. Create a Collection")],-1),N=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/create-a-collection-20220427A.mp4",type:"video/mp4"})],-1),R=e("ol",null,[e("li",null,"Navigate into the Content Module."),e("li",null,[t("Click "),e("strong",null,"\u201CCreate Collection\u201D"),t(" and a side menu will appear.")]),e("li",null,[t("Fill in a "),e("strong",null,"Name"),t("."),e("br"),t(" For the sake of this demo, we\u2019ll call ours "),e("code",null,"articles"),t(", but feel free to make it your own!")]),e("li",null,[t("Leave the other options at default. Click "),e("span",{mi:"",btn:""},"arrow_forward"),t(" and the "),e("strong",null,"\u201COptional System Fields\u201D"),t(" menu will open."),e("br"),t(" Keep the values in this menu at the default, toggled off, for now. You can adjust them later.")]),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"check"),t(" in the menu header.")])],-1),G={class:"tip hint"},O=e("div",{class:"hint-title"},"Learn More About Collections",-1),B=e("h2",{id:"4.-create-a-field",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#4.-create-a-field"},"#"),t(" 4. Create a Field")],-1),E=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/create-a-field-20220427A.mp4",type:"video/mp4"})],-1),H=e("ol",null,[e("li",null,[t("Navigate to "),e("strong",null,[t("Settings Module > Data Model > "),e("code",null,"Collection-Name")]),t(".")]),e("li",null,[t("Click the "),e("strong",null,"\u201CCreate Field\u201D"),t(" button and select the "),e("strong",null,"\u201CInput\u201D"),t(" Field type.")]),e("li",null,[t("Fill in a Field name under "),e("strong",null,"Key"),t(". We\u2019ll be calling our Field "),e("code",null,"title"),t("."),e("br"),t(" Directus offers powerful Field customization options, but let\u2019s stick to the defaults for now.")]),e("li",null,[t("Select "),e("strong",null,"\u201CSave\u201D"),t(".")])],-1),U={class:"tip hint"},z=e("div",{class:"hint-title"},"Learn More About Fields",-1),Q=e("h2",{id:"5.-create-an-item",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#5.-create-an-item"},"#"),t(" 5. Create an Item")],-1),V=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/create-an-item-20220427B.mp4",type:"video/mp4"})],-1),W=e("ol",null,[e("li",null,"Navigate to the Content Module."),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"add"),t(" in the page header to open the Item Page.")]),e("li",null,"Fill in the Field Value(s) as desired."),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"check"),t(" in the top-right to save your Item.")])],-1),Y={class:"tip hint"},K=e("div",{class:"hint-title"},"Learn More About Items",-1),J=e("h2",{id:"6.-set-roles-%26-permissions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#6.-set-roles-%26-permissions"},"#"),t(" 6. Set Roles & Permissions")],-1),X=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/getting-started/quickstart/quickstart-20220427A/set-read-permissions-20220427A.mp4",type:"video/mp4"})],-1),Z=e("p",null,"Directus comes with two built-in roles: Public and Admin. The Public Role determines what data is returned to non-authenticated users. Public comes with all permissions turned off and can be reconfigured with fully granular control to expose exactly what you want unauthenticated Users to see. The Admin role has full permissions and this cannot be changed. Aside from these built-in Roles, any number of new Roles can be created, all with fully customized, granular permissions.",-1),$=e("p",null,[t("By Default, content entered into Directus will be considered private. So permissions always start off set to the default of "),e("span",{mi:"",icon:"",dngr:""},"block"),t(),e("strong",null,"No Access"),t(", with full ability to reconfigure as desired. So, in order to have the API return our Items, let\u2019s add some read permissions. For simplicity\u2019s sake, we\u2019ll do this on the Public Role, instead of creating a new Role.")],-1),ee=e("ol",null,[e("li",null,[t("Navigate to "),e("strong",null,"Settings Module > Roles & Permissions > Public"),t(".")]),e("li",null,[t("Click "),e("span",{mi:"",icon:"",dngr:""},"block"),t(" under the "),e("span",{mi:"",icon:""},"visibility"),t(" icon on the desired Collection."),e("br"),t(" In our case, the Collection name is "),e("code",null,"article"),t(".")]),e("li",null,[t("Click "),e("strong",null,"\u201CAll Access\u201D"),t(" to give the Public Role full read permissions to the Items in this Collection.")])],-1),te={class:"tip hint"},oe=e("div",{class:"hint-title"},"Learn More About Roles & Permissions",-1),ne=e("h2",{id:"7.-connect-to-the-api",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#7.-connect-to-the-api"},"#"),t(" 7. Connect to the API")],-1),le=e("code",null,"/items/",-1),se=e("ol",null,[e("li",null,[t("Open "),e("code",null,"http://your-project-url.directus.app/items/articles"),t("."),e("br"),t(" You can use the browser or an API tool like "),e("a",{href:"http://postman.com",target:"_blank",rel:"noopener noreferrer"},"Postman"),t(" or "),e("a",{href:"https://paw.cloud",target:"_blank",rel:"noopener noreferrer"},"Paw")])],-1),ie=e("p",null,[e("em",null,"And there it is! The Article Item you just created is being served in beautiful JSON, ready to be used anywhere and everywhere!")],-1),ae=e("pre",null,[e("code",{class:"language-json"},[e("span",{class:"hljs-punctuation"},"{"),t(`
	`),e("span",{class:"hljs-attr"},'"data"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-punctuation"},"["),t(`
		`),e("span",{class:"hljs-punctuation"},"{"),t(`
			`),e("span",{class:"hljs-attr"},'"id"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-number"},"1"),e("span",{class:"hljs-punctuation"},","),t(`
			`),e("span",{class:"hljs-attr"},'"title"'),e("span",{class:"hljs-punctuation"},":"),t(),e("span",{class:"hljs-string"},'"Hello World!"'),t(`
		`),e("span",{class:"hljs-punctuation"},"}"),t(`
	`),e("span",{class:"hljs-punctuation"},"]"),t(`
`),e("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),ce=e("p",null,[e("em",null,"In this example, we made a super-simple read request with the API, but there\u2019s more! The REST and GraphQL APIs provide exhaustive endpoints for the data model and every single action that you can do in the App can be done via the API. In fact, the App is just a GUI powered by the API.")],-1),re={class:"tip hint"},de=e("div",{class:"hint-title"},"Learn More About The API",-1),_e="Quickstart Guide",ge=!1,fe="Get up and running with Directus Cloud in minutes. Learn the basics of building your data model and managing permissions.",ye="7 min read",be={__name:"quickstart",setup(ue,{expose:a}){const s={title:"Quickstart Guide",modularExtension:!1,description:"Get up and running with Directus Cloud in minutes. Learn the basics of building your data model and managing permissions.",readTime:"7 min read"};return a({frontmatter:s}),(he,pe)=>{const n=i("router-link"),c=i("docs-wrapper");return r(),d(c,{frontmatter:s},{default:o(()=>[e("div",u,[h,p,m,e("p",null,[t("First, you\u2019ll need to "),l(n,{to:"/docs/cloud/accounts#create-account-and-login"},{default:o(()=>[t("create an Account and log in")]),_:1}),t(" on "),_]),g,f,y,e("div",b,[w,e("ul",null,[e("li",null,[l(n,{to:"/docs/cloud/overview"},{default:o(()=>[t("Overview")]),_:1})]),e("li",null,[l(n,{to:"/docs/cloud/accounts"},{default:o(()=>[t("Cloud Accounts")]),_:1})]),e("li",null,[l(n,{to:"/docs/cloud/teams"},{default:o(()=>[t("Cloud Teams")]),_:1})])])]),v,C,A,e("ol",null,[e("li",null,[t("Open the Team Menu in the Dashboard Header and select or "),l(n,{to:"/docs/cloud/teams#create-a-team"},{default:o(()=>[t("create")]),_:1}),t(" the desired Team.")]),k,P,j,I,T]),x,e("ol",D,[e("li",null,[t("You can "),l(n,{to:"/docs/cloud/projects#access-a-project"},{default:o(()=>[t("access a Project")]),_:1}),t(" from within the Cloud Dashboard or type the URL into your browser.")]),S]),F,e("div",M,[q,e("ul",null,[e("li",null,[l(n,{to:"/docs/cloud/overview"},{default:o(()=>[t("Overview")]),_:1})]),e("li",null,[l(n,{to:"/docs/cloud/projects"},{default:o(()=>[t("Cloud Projects")]),_:1})])])]),L,N,e("p",null,[t("Once logged in, you\u2019re greeted with the option to create your first "),l(n,{to:"/docs/getting-started/glossary#collections"},{default:o(()=>[t("Collection")]),_:1}),t(".")]),R,e("div",G,[O,e("ul",null,[e("li",null,[l(n,{to:"/docs/app/content"},{default:o(()=>[t("The Content Module")]),_:1})]),e("li",null,[l(n,{to:"/docs/configuration/data-model/collections.md"},{default:o(()=>[t("Create and Manage a Collection")]),_:1})]),e("li",null,[l(n,{to:"/docs/configuration/data-model/relationships"},{default:o(()=>[t("Build Relationships Between Collections")]),_:1})])])]),B,E,e("p",null,[t("With your first Collection created, it\u2019s time to start adding some "),l(n,{to:"/docs/getting-started/glossary#fields"},{default:o(()=>[t("Fields")]),_:1}),t(".")]),H,e("div",U,[z,e("ul",null,[e("li",null,[l(n,{to:"/docs/configuration/data-model"},{default:o(()=>[t("Create and Manage Fields in the App")]),_:1})])])]),Q,V,e("p",null,[t("Now that we have a Collection with a Field configured, it\u2019s time to add an "),l(n,{to:"/docs/getting-started/glossary#"},{default:o(()=>[t("Item")]),_:1}),t(".")]),W,e("div",Y,[K,e("ul",null,[e("li",null,[l(n,{to:"/docs/app/content"},{default:o(()=>[t("The Content Module")]),_:1})]),e("li",null,[l(n,{to:"/docs/app/content/items"},{default:o(()=>[t("The Item Page")]),_:1})])])]),J,X,Z,$,ee,e("div",te,[oe,e("ul",null,[e("li",null,[l(n,{to:"/docs/configuration/users-roles-permissions"},{default:o(()=>[t("Users, Roles and Permissions")]),_:1}),t(".")])])]),ne,e("p",null,[t("Now that your Project has some content in it which is exposed to the Public, it\u2019s time to start using this content externally! Data can be accessed in a number of ways, including the REST and GraphQL API endpoints. In this case, we\u2019ll use the "),le,t(),l(n,{to:"/docs/reference/items"},{default:o(()=>[t("REST API endpoint")]),_:1}),t(" to retrieve the Item we just created.")]),se,ie,ae,ce,e("div",re,[de,e("ul",null,[e("li",null,[l(n,{to:"/docs/reference/introduction"},{default:o(()=>[t("Intro to the API")]),_:1})]),e("li",null,[l(n,{to:"/docs/reference/sdk"},{default:o(()=>[t("JS SDK")]),_:1})])])])])]),_:1})}}};export{be as default,fe as description,ge as modularExtension,ye as readTime,_e as title};
