import{a as n,o as d,e as c,y as o,u as e,q as t,z as r}from"./runtime-core.esm-bundler.22ec0346.js";const l={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"Directus is offered completely free and open-source for anyone wishing to self-host the platform. If you have questions along the way, there are many resources, both free and paid, to help you get up-and-running smoothly.")],-1),p=e("h2",{id:"troubleshooting-steps",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#troubleshooting-steps"},"#"),t(" Troubleshooting Steps")],-1),m=e("li",null,[t("Ensure you\u2019re on the "),e("a",{href:"https://github.com/directus/directus/releases/latest",target:"_blank",rel:"noopener noreferrer"},"latest version"),t(" of Directus.")],-1),f=e("li",null,[t("Stop "),e("code",null,"CTRL+C"),t(" and restart the server "),e("code",null,"npx directus start"),t(".")],-1),_=e("li",null,[t("Run the database migration script: "),e("code",null,"directus database migrate:latest"),e("br"),e("em",null,"Note: backup your database first.")],-1),b=e("li",null,"Disable any data-caching within your project.",-1),y=e("li",null,[t("Test any app issues with both browser extensions and caching disabled "),e("em",null,"(i.e. Incognito Mode)"),t(".")],-1),g=e("li",null,"Confirm the issue is not related to your own custom code.",-1),w=e("li",null,[t("Check for "),e("a",{href:"https://github.com/directus/directus/issues?q=is%3Aissue",target:"_blank",rel:"noopener noreferrer"},"existing Issues"),t(" (and "),e("a",{href:"https://github.com/directus/directus/discussions",target:"_blank",rel:"noopener noreferrer"},"Discussions"),t(") that match your problem.")],-1),x=e("a",{href:"#community-support"},"community support",-1),k=e("h2",{id:"support-tiers",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#support-tiers"},"#"),t(" Support Tiers")],-1),v=e("h3",{id:"community-support",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#community-support"},"#"),t(" Community Support")],-1),q=e("p",null,[e("a",{href:"https://github.com/directus/directus/discussions",target:"_blank",rel:"noopener noreferrer"},"GitHub Discussions"),t(" is a great first place to reach out for help. Our community and core developers often check this platform and answer posts. It has the added benefit of being an archival resource for others developers with similar questions.")],-1),C=e("p",null,[t("Our "),e("a",{href:"https://directus.chat",target:"_blank",rel:"noopener noreferrer"},"Discord Community"),t(" is another great way to get assistance. Please keep all questions on the "),e("code",null,"#help"),t(" channel, be considerate, and remember that you are getting free help from the community for a free product.")],-1),D=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"No Guaranteed Response Time"),e("p",null,"While the Directus Core Team plays an active and engaged role in community discussions, there is no guaranteed response time for Community Support.")],-1),F=e("h3",{id:"basic-and-premium-support",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#basic-and-premium-support"},"#"),t(" Basic and Premium Support")],-1),S=e("p",null,"Basic and Premium Support offer direct communication with the Directus Core Team. Basic support is included on all Enterprise Projects, and Premium Support adds 24/7 response times for critical software issues only.",-1),T=e("h2",{id:"sponsored-work",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#sponsored-work"},"#"),t(" Sponsored Work")],-1),I=e("h3",{id:"commissioned-features",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#commissioned-features"},"#"),t(" Commissioned Features")],-1),j=e("a",{href:"https://directus.io/contact",target:"_blank",rel:"noopener noreferrer"},"reach out to us",-1),E=e("h3",{id:"expedited-fixes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#expedited-fixes"},"#"),t(" Expedited Fixes")],-1),B=e("p",null,[t("We triage all reported bugs based on priority and how long the fix is estimated to take. If you need a specific issue resolved sooner, "),e("a",{href:"https://directus.io/contact",target:"_blank",rel:"noopener noreferrer"},"reach out to us"),t(" for a quote.")],-1),N=e("h2",{id:"frequently-asked-questions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#frequently-asked-questions"},"#"),t(" Frequently Asked Questions")],-1),W=e("h3",{id:"does-directus-support-mongo%2Fnosql%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#does-directus-support-mongo%2Fnosql%3F"},"#"),t(" Does Directus support Mongo/NoSQL?")],-1),z=e("p",null,[t("Not currently. Directus has been built specifically for wrapping "),e("em",null,"relational"),t(" databases. While we could force Mongo to use tables, columns, and rows via Mongoose object modeling, that approach of \u201Cfaking\u201D a relational structure in a non-structured environment like Mongo doesn\u2019t make a lot of sense. We do realize many users are interested in this feature, and will continue to explore its possibility.")],-1),H=e("h3",{id:"why-haven%E2%80%99t-you-added-this-feature%2C-or-fixed-that-issue-yet%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#why-haven%E2%80%99t-you-added-this-feature%2C-or-fixed-that-issue-yet%3F"},"#"),t(" Why haven\u2019t you added this feature, or fixed that issue yet?")],-1),O=e("p",null,"Directus is primarily a free and open-source project, maintained by a small core team and community contributors who donate their time and resources.",-1),R=e("p",null,[t("If you need, you can contact us about "),e("a",{href:"#expedited-fixes"},"sponsoring expedited fixes"),t(" or "),e("a",{href:"#commissioned-features"},"commissioning new features"),t(". You can also "),e("a",{href:"https://github.com/directus/directus/pulls",target:"_blank",rel:"noopener noreferrer"},"submit a pull request"),t(" \u2014 after all, it is open-source!")],-1),M=e("h3",{id:"can-you-give-an-eta-for-this-feature%2Ffix%3F",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#can-you-give-an-eta-for-this-feature%2Ffix%3F"},"#"),t(" Can you give an ETA for this feature/fix?")],-1),P=e("p",null,"If it is sponsored work, then yes, delivery dates are part of our statement of work agreements. Otherwise, most likely not. This is open-source software, work is prioritized internally, and all timelines are subject to change.",-1),A=e("h3",{id:"but-this-is-an-emergency%2C-my-very-important-project-requires-it-now!",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#but-this-is-an-emergency%2C-my-very-important-project-requires-it-now!"},"#"),t(" But this is an emergency, my very important project requires it now!")],-1),V=e("p",null,[t("We understand, and are here to help. If you need something prioritized, you can reach out to us to discuss "),e("a",{href:"#basic-and-premium-support"},"premium support"),t(", "),e("a",{href:"#expedited-fixes"},"sponsoring expedited fixes"),t(" or "),e("a",{href:"#commissioned-features"},"commissioning new features"),t(".")],-1),J="Help & Support",K=!1,U="How to get support for your Directus project.",X="4 min read",Z={__name:"support",setup(G,{expose:a}){const i={title:"Help & Support",modularExtension:!1,description:"How to get support for your Directus project.",readTime:"4 min read"};return a({frontmatter:i}),(L,Q)=>{const s=n("router-link"),u=n("docs-wrapper");return d(),c(u,{frontmatter:i},{default:o(()=>[e("div",l,[h,p,e("p",null,[t("If you\u2019re experiencing issues or think you have found a problem in Directus, be sure to follow these steps before "),r(s,{to:"/docs/contributing/introduction#bug-reporting"},{default:o(()=>[t("Reporting a Bug")]),_:1}),t(":")]),e("ol",null,[e("li",null,[t("Ensure your server and database meet the "),r(s,{to:"/docs/self-hosted/installation/cli#_1-confirm-minimum-requirements"},{default:o(()=>[t("minimum requirements")]),_:1}),t(".")]),m,f,_,b,y,g,w]),e("p",null,[t("If you\u2019re still experiencing a problem after completing the above steps, you can chat through things on our "),x,t(" or "),r(s,{to:"/docs/contributing/introduction#bug-reporting"},{default:o(()=>[t("report a bug")]),_:1}),t(".")]),k,v,q,C,D,F,S,e("p",null,[t("Cloud customers and Self-Hosted users interested in learning more about our monthly retainer agreements should contact us at "),r(s,{to:"/docsmailto:support@directus.io"},{default:o(()=>[t("support@directus.io")]),_:1}),t(".")]),T,I,e("p",null,[t("If you need a specific feature added to Directus faster than the normal development timeline, "),j,t(" for a quote. Our parent agency will often help subsidize the cost of developing new features if they pass our "),r(s,{to:"/docs/contributing/introduction#feature-requests"},{default:o(()=>[t("80/20 Rule")]),_:1}),t(" and can be merged into the core codebase. Other custom/proprietary development will be built bespoke within our robust extension system.")]),E,B,N,W,z,H,O,e("p",null,[t("Our platform is feature-rich, however we strictly adhere to our "),r(s,{to:"/docs/contributing/introduction#feature-requests"},{default:o(()=>[t("80/20 Rule")]),_:1}),t(" to avoid a messy/bloated codebase. Directus is also quite stable, however new issues still arise, some of which may be triaged with a lower prioritization.")]),R,M,P,A,V])]),_:1})}}};export{Z as default,U as description,K as modularExtension,X as readTime,J as title};
