import{a as i,o as c,e as h,y as o,u as e,q as t,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},d=e("blockquote",null,[e("p",null,"A trigger defines the event that starts your flow. This could be from an internal or external activity, such as changes to data, logins, errors, incoming webhooks, cron jobs, operations from other flows, or even the click of a button within the Data Studio.")],-1),p={class:"tip hint"},g=e("div",{class:"hint-title"},"Before You Begin",-1),f=e("h2",{id:"event-hook",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#event-hook"},"#"),t(" Event Hook")],-1),w=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/triggers/triggers-20220603A/event-hook-20220602A.webp",alt:"Event Hooks"})],-1),m=e("code",null,"$trigger",-1),_=e("ul",null,[e("li",null,[e("strong",null,"Type"),t(" \u2014 Choose the type of event hook: "),e("ul",null,[e("li",null,[e("a",{href:"#filters"},"Filter (Blocking)"),t(" \u2014 This pauses the transaction and passes the "),e("code",null,"payload"),t(" to your flow, allowing you to validate or transform "),e("code",null,"payload"),t(" or even prevent the event transaction.")]),e("li",null,[e("a",{href:"#actions"},"Action (Non-Blocking)"),t(" \u2014 Actions do not block the event. A non-blocking action is mostly useful for completing tasks in response to an event, without modifying the event or slowing the API.")])])]),e("li",null,[e("strong",null,"Scope"),t(" \u2014 Set the types of events that trip this trigger.")]),e("li",null,[e("strong",null,"Collections"),t(" \u2014 Set the collections "),e("em",null,"whose events"),t(" trip this trigger.")]),e("li",null,[e("strong",null,"Response Body"),t(" \u2014 This is optional. Its also only for "),e("strong",null,"Filter (Blocking)"),t(" events. Defines data to replace the event\u2019s original "),e("code",null,"payload"),t(". Choose to return: "),e("ul",null,[e("li",null,[e("strong",null,"Data of Last Operation"),t(" \u2014 Replaces event "),e("code",null,"payload"),t(" with value from "),e("code",null,"$last"),t(".")]),e("li",null,[e("strong",null,"All Data"),t(" \u2014 Replaces event "),e("code",null,"payload"),t(" with the entire data chain.")]),e("li",null,[e("strong",null,"Other"),t(" \u2014 Replaces event "),e("code",null,"payload"),t(" with value from an "),e("code",null,"<operationKey>"),t(".")])])])],-1),y=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Events with Multiple Items"),e("p",null,"If you create items in a single request, the Flow will trigger once for each and every item. If you create three items, the flow runs three separate times. On each run, just one item will be in the payload.")],-1),v=e("h3",{id:"filters",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#filters"},"#"),t(" Filters")],-1),b=e("p",null,[t("A Filter will halt the event transaction, copy the event "),e("code",null,"payload"),t(" into the flow, let the whole flow run, "),e("strong",null,[e("em",null,"optionally")]),t(" replace the original "),e("code",null,"payload"),t(" by configuring "),e("strong",null,"Response Body"),t(", then resume the event\u2019s transaction to the database.")],-1),A=e("p",null,[t("For example, let\u2019s say you configure the scope to be "),e("code",null,"item.create"),t(".")],-1),T=e("ul",null,[e("li",null,"A request to create an item is sent to Directus."),e("li",null,"The create item event halts."),e("li",null,[t("The event\u2019s "),e("code",null,"payload"),t(" is copied into the "),e("code",null,"$trigger"),t(" of the flow.")]),e("li",null,"The flow runs."),e("li",null,[e("em",null,"Optional:"),t(" If you defined a "),e("strong",null,"Response Body"),t(", this replaces the event\u2019s "),e("code",null,"payload"),t(".")]),e("li",null,"The event transaction is committed or cancelled, based on your flow\u2019s logic.")],-1),k=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Response Body"),e("p",null,[t("If no "),e("strong",null,"Response Body"),t(" is configured, the original payload will not be modified, but you\u2019d still have the ability to cancel the transaction.")])],-1),x={class:"tip hint"},I=e("div",{class:"hint-title"},"Cancelling Transactions",-1),R=e("h3",{id:"actions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#actions"},"#"),t(" Actions")],-1),B=e("p",null,[t("An Action lets the event commit its transaction to the database without waiting for the flow to finish. Therefore, Actions give you a more performant API, but you have no ability to validate or transform the payload before the transaction is committed to the database. However, a copy of the "),e("code",null,"payload"),t(" is still added into "),e("code",null,"$trigger"),t(" to use as desired.")],-1),F=e("p",null,[t("For example, let\u2019s imagine once more that you configure the scope to be "),e("code",null,"item.create"),t(".")],-1),C=e("ul",null,[e("li",null,"A request to create an item is sent to Directus."),e("li",null,"The create item event is transacted."),e("li",null,[t("The event\u2019s "),e("code",null,"payload"),t(" is copied into the "),e("code",null,"$trigger"),t(" of the flow.")]),e("li",null,"The flow runs.")],-1),D=e("p",null,[t("To recap, Filters let you modify the original "),e("code",null,"payload"),t(" of an event but block the API until the flow finishes. Actions still provide the "),e("code",null,"payload"),t(" to the flow, but don\u2019t let you modify it before transaction; so you get a faster API but no control over the event transaction.")],-1),P=e("h2",{id:"webhook",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#webhook"},"#"),t(" Webhook")],-1),O=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/triggers/triggers-20220603A/webhook-20220602A.webp",alt:"Webhook"})],-1),q=e("p",null,[t("Triggers on an incoming HTTP request to: "),e("code",null,"/flows/trigger/:this-webhook-trigger-id"),t(" which you can copy from the webhook trigger panel.")],-1),S=e("ul",null,[e("li",null,[e("strong",null,"Method"),t(" \u2014 Choose whether the flow will be triggered by a "),e("code",null,"GET"),t(" or "),e("code",null,"POST"),t(" request from the dropdown.")]),e("li",null,[e("strong",null,"Asynchronous"),t(" \u2014 Toggle whether or not the trigger responds asynchronously.")]),e("li",null,[e("strong",null,"Response Body"),t(" \u2014 Optional. Defines data to return as a response. Choose to return: "),e("ul",null,[e("li",null,[e("strong",null,"Data of Last Operation"),t(" \u2014 Responds with value from "),e("code",null,"$last"),t(".")]),e("li",null,[e("strong",null,"All Data"),t(" \u2014 Responds with the entire data chain.")]),e("li",null,[e("strong",null,"Other"),t(" \u2014 Responds with value from an "),e("code",null,"<operationKey>"),t(".")])])])],-1),$=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Response Body"),e("p",null,[t("If no data is defined in "),e("strong",null,"Response Body"),t(", the response is empty.")])],-1),E=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Asynchronous"),e("p",null,[t("If "),e("strong",null,"Asynchronous"),t(" is enabled, the flows system will immediately resolve/respond to the request without returning a "),e("strong",null,"Response Body"),t(", which frees up the API immediately. If it is disabled, the flows system will wait for the flow to finish and return whatever value is in "),e("strong",null,"Response Body"),t(". This slows the API, but lets you send data.")])],-1),j=e("h2",{id:"schedule",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#schedule"},"#"),t(" Schedule")],-1),H=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/triggers/triggers-20220603A/cron-20220602A.webp",alt:"Schedule a Cron Job"})],-1),K=e("p",null,[t("This trigger enables you to create data at scheduled intervals, via "),e("a",{href:"https://github.com/node-cron/node-cron#cron-syntax",target:"_blank",rel:"noopener noreferrer"},"6-point cron job syntax"),t(".")],-1),L=e("ul",null,[e("li",null,[e("strong",null,"Interval"),t(" \u2014 Set the cron job interval to schedule when the flow triggers.")])],-1),M=e("h2",{id:"another-flow",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#another-flow"},"#"),t(" Another Flow")],-1),N=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/triggers/triggers-20220603A/another-flow-20220602A.webp",alt:"Another Flow"})],-1),V=e("strong",null,"Response Body",-1),W=e("code",null,"<operationKey>",-1),z=e("ul",null,[e("li",null,[e("strong",null,"Data of Last Operation"),t(" \u2014 Responds with value from "),e("code",null,"$last"),t(".")]),e("li",null,[e("strong",null,"All Data"),t(" \u2014 Responds with the entire data chain.")]),e("li",null,[e("strong",null,"Other"),t(" \u2014 Responds with value from an "),e("code",null,"<operationKey>"),t(".")])],-1),G=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Flows for-loops"),e("p",null,"If you pass an array to this trigger, it will run once for each item in the array.")],-1),J=e("h2",{id:"manual",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#manual"},"#"),t(" Manual")],-1),Y=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/configuration/flows/triggers/triggers-20220603A/manual-20220602A.webp",alt:"Manual"})],-1),Q=e("p",null,[t("This Trigger starts your flow on a manual click of a button within the Data Studio. When you use this trigger, a "),e("strong",null,"Flows"),t(" menu containing a button will appear in the sidebar of the specified collection page(s) and/or its item pages.")],-1),U=e("p",null,[t("The manual trigger must take in item ID(s) before you can click it. So on the collection page, the button will be "),e("em",null,"grayed out"),t(" until you select some number of items. From the item page, the current item\u2019s ID is passed in automatically. These item IDs are passed in to "),e("code",null,"$trigger"),t(".")],-1),X=e("li",null,[e("strong",null,"Collections"),t(" \u2014 Choose the Collection(s) to add the button to.")],-1),Z=e("strong",null,"Location",-1),ee=e("li",null,[e("strong",null,"Asynchronous"),t(" \u2014 Toggle whether or not the Flow executes asynchronously.")],-1),te=e("li",null,[e("strong",null,"Collection Page (Requires Selection)"),t(" \u2014 Toggle whether a selection is required in the Collection Page to trigger.")],-1),oe=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Asynchronous"),e("p",null,[t("If "),e("strong",null,"Asynchronous"),t(" is enabled, the flows system will immediately allow you to use the manual trigger button again to send more requests. If it is disabled, you will have to wait until the flow completes to use it again.")])],-1),ae="Triggers",re=!1,ce="A Trigger initiates a Flow on some internal or external event, such as an in-app activity, incoming webhook, cron job, execution of Operation(s) from other Flows, and beyond!",he="3 min read",ue={__name:"triggers",setup(ne,{expose:a}){const s={title:"Triggers",modularExtension:!1,description:"A Trigger initiates a Flow on some internal or external event, such as an in-app activity, incoming webhook, cron job, execution of Operation(s) from other Flows, and beyond!",readTime:"3 min read"};return a({frontmatter:s}),(le,se)=>{const n=i("router-link"),r=i("docs-wrapper");return c(),h(r,{frontmatter:s},{default:o(()=>[e("div",u,[d,e("div",p,[g,e("p",null,[t("Please be sure to read the overview documentation on "),l(n,{to:"/docs/configuration/flows"},{default:o(()=>[t("Flows")]),_:1}),t(".")])]),f,w,e("p",null,[t("Event Hooks are triggered by events within the platform. The logic is based on "),l(n,{to:"/docs/extensions/hooks"},{default:o(()=>[t("Custom API Hooks")]),_:1}),t(". Any data generated by the event will be nested in the "),m,t(".")]),_,y,v,b,A,T,k,e("div",x,[I,e("p",null,[t("To completely cancel a transaction, you\u2019ll need to throw an error within a "),l(n,{to:"/docs/configuration/flows/operations.md#script"},{default:o(()=>[t("script operation")]),_:1}),t(" or end the flow on a "),l(n,{to:"/docs/configuration/flows#control-flow"},{default:o(()=>[t("failure path")]),_:1}),t(".")])]),R,B,F,C,D,P,O,q,S,$,E,j,H,K,L,M,N,e("p",null,[t("This trigger executes by the "),l(n,{to:"/docs/configuration/flows/operations#another-flow"},{default:o(()=>[t("trigger flow")]),_:1}),t(" operation, allowing you to chain flows.")]),e("ul",null,[e("li",null,[V,t(" \u2014 Optional. Defines data to return and append under the "),W,t(" of "),l(n,{to:"/docs/configuration/flows/operations#another-flow"},{default:o(()=>[t("trigger flow")]),_:1}),t(" operation that tripped the trigger. Choose to return: "),z])]),G,J,Y,Q,U,e("ul",null,[X,e("li",null,[Z,t(" \u2014 Choose to display the button on the "),l(n,{to:"/docs/app/content.md#item-page"},{default:o(()=>[t("Item Page")]),_:1}),t(", "),l(n,{to:"/docs/app/content.md#collection-page"},{default:o(()=>[t("Collection Page")]),_:1}),t(", or both.")]),ee,te]),e("p",null,[t("After the operation runs, a toast notification will appear in your "),l(n,{to:"/docs/app/overview.md#4-sidebar"},{default:o(()=>[t("sidebar")]),_:1}),t(" indicating whether the flow ran successfully.")]),oe])]),_:1})}}};export{ue as default,ce as description,re as modularExtension,he as readTime,ae as title};
