import{a as s,o as c,e as d,y as o,u as e,q as t,z as i}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("strong",null,"Database",-1),p=e("h2",{id:"upgrading-%2F-updating-a-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#upgrading-%2F-updating-a-project"},"#"),t(" Upgrading / Updating a Project")],-1),g=e("ol",null,[e("li",null,"Backup your project"),e("li",null,[t("Run "),e("code",null,"npm update")]),e("li",null,[t("Run "),e("code",null,"npx directus database migrate:latest"),t(" to update the DB")])],-1),m=e("h2",{id:"backing-up-a-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#backing-up-a-project"},"#"),t(" Backing-up a Project")],-1),f=e("ol",null,[e("li",null,[t("Make a copy of the "),e("strong",null,"files within each storage adapter"),t(", and store them in a safe place.")]),e("li",null,[t("Make a copy of the "),e("code",null,"/api/.env"),t(" file, and store it in a safe place.")]),e("li",null,"Create a database dump.")],-1),_=e("h2",{id:"migrating-a-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#migrating-a-project"},"#"),t(" Migrating a Project")],-1),y=e("p",null,"Directus doesn\u2019t rely on anything besides the database for it\u2019s operation. Therefore, migrating your Directus project can be done by moving the whole database to a new location using a database dump.",-1),b=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"File Storage"),e("p",null,"If you have files uploaded, make sure to copy those over as well, or use the same storage location in the new location of Directus.")],-1),v=e("h2",{id:"downgrading-a-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#downgrading-a-project"},"#"),t(" Downgrading a Project")],-1),w=e("p",null,[t("Directus can be reverted to an earlier version by going to your terminal, navigating into your project folder and running "),e("code",null,"npm install directus@<version>"),t(".")],-1),x=e("p",null,[t("If you ran any database migrations for a newer version, you can revert those by running "),e("code",null,"npx directus database migrate:down")],-1),k=e("h2",{id:"deleting-a-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#deleting-a-project"},"#"),t(" Deleting a Project")],-1),j=e("ol",null,[e("li",null,[t("Optional: "),e("strong",null,"Backup any local files"),t(" stored within the project\u2019s root directory")]),e("li",null,[t("Optional: "),e("strong",null,"Backup any custom code and extensions"),t(" within the project\u2019s root directory")]),e("li",null,[t("Optional: "),e("strong",null,"Backup your entire database"),t(", only system tables, or only project tables")]),e("li",null,[e("strong",null,"Delete the project\u2019s root directory"),t(" from the server")]),e("li",null,[e("strong",null,"Delete all Directus system tables"),t(" ("),e("code",null,"directus_*"),t(") from the database")])],-1),D=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Pure SQL"),e("p",null,"After completing this process, you will be left with a pure SQL database, with no trace that Directus was ever installed. Any external services connecting to your database\u2019s project tables directly (e.g., SQL queries) should continue working normally.")],-1),P=e("h2",{id:"migrating-from-version-8",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#migrating-from-version-8"},"#"),t(" Migrating from Version 8")],-1),B=e("p",null,"There are two ways to migrate from an existing Directus 8.X instance:",-1),T=e("ul",null,[e("li",null,[e("a",{href:"#automated-script"},"Automated Script"),t(" (recommended)")]),e("li",null,[e("a",{href:"#manual-database-export-import"},"Manual Database Export/Import")])],-1),A=e("p",null,[t("Be sure to check the "),e("a",{href:"#breaking-changes"},"Breaking changes"),t(" if you are consuming the API from an application.")],-1),I=e("h2",{id:"automated-script",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#automated-script"},"#"),t(" Automated Script")],-1),M=e("p",null,"We created a (community maintained) script, that will automatically copy over the schema, content, files, users, and roles from an existing v8 instance to a new v8 instance. This is the most hands-off approach to moving from a v8 to a version v9 instance, and is the recommended way of migrating your v8 instance.",-1),S=e("div",{class:"tip hint"},[e("p",null,[t("The script, and instructions on how to run it, can be found on the"),e("br"),e("a",{href:"https://github.com/directus-community/migration-tool",target:"_blank",rel:"noopener noreferrer"},[e("code",null,"directus-community/migration-tool")]),t(" repo.")])],-1),U=e("p",null,"This tool will copy over:",-1),F=e("ul",null,[e("li",null,"Schema (collections / fields)"),e("li",null,"Files (including file contents)"),e("li",null,"User data (e.g., all items in all collections)"),e("li",null,"Roles"),e("li",null,"Users")],-1),q=e("p",null,[t("Due to significant differences in data structure between versions, this tool will "),e("strong",null,"NOT"),t(" copy over:")],-1),N=e("ul",null,[e("li",null,"Interface/display configurations"),e("li",null,"Permissions"),e("li",null,"Activity / revisions")],-1),O=e("h2",{id:"manual-database-export%2Fimport",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#manual-database-export%2Fimport"},"#"),t(" Manual Database Export/Import")],-1),C=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Automated"),e("p",null,"We highly recommend using the automated migration tool mentioned above. If that\u2019s not possible, you can perform the following steps to migrate your v8 instance.")],-1),E=e("p",null,"Directus v9 is a breaking change coming from v8 (hence the major version bump), so you won\u2019t be able to just use your existing v8 database and run v9 on top of it. However, due to the database-mirroring approach of Directus, it\u2019s fairly straightforward to migrate your content from v8 to v9.",-1),L=e("h4",{id:"1)-setup-a-fresh-v9-instance",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#1)-setup-a-fresh-v9-instance"},"#"),t(" 1) Setup a Fresh v9 Instance")],-1),V=e("p",null,"By installing Directus \u201Cfresh\u201D, you\u2019re ensured your system tables are up-to-date and ready to go.",-1),Q=e("h4",{id:"2)-migrate-your-data",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#2)-migrate-your-data"},"#"),t(" 2) Migrate your Data")],-1),R=e("p",null,[t("Using a tool like "),e("a",{href:"http://sequelpro.com",target:"_blank",rel:"noopener noreferrer"},"Sequel Pro"),t(" or "),e("a",{href:"https://tableplus.com",target:"_blank",rel:"noopener noreferrer"},"TablePlus"),t(", export your v8 user-tables and import them into your v9 database.")],-1),z=e("p",null,"Directus v9 will automatically recognize your tables, and you\u2019ll be ready to get started in v9.",-1),W=e("p",null,[e("strong",null,"Note:"),t(" If you have references to users and files, make sure to update them to the new UUID format.")],-1),H=e("h4",{id:"3)-configure-directus",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#3)-configure-directus"},"#"),t(" 3) Configure Directus")],-1),X=e("p",null,"Once the tables are in, you can start configuring the details of the schema. This includes choosing the correct interfaces, displays, and their options for your fields.",-1),G=e("p",null,"This would also be a good time to reconfigure your permissions, to ensure they are accurate.",-1),J=e("h2",{id:"breaking-changes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#breaking-changes"},"#"),t(" Breaking changes")],-1),K=e("code",null,"/items/users?filter[comments.thread.title][like]=Directus",-1),Y=e("code",null,"/items/users?filter[comments][thread][title][_like]=Directus",-1),oe="Upgrades & Migrations",ae=!1,ne="A Project is a complete instance of Directus, including its **Database**, config file, asset storage, and any custom extensions.",se="4 min read",ie={__name:"upgrades-migrations",setup(Z,{expose:r}){const a={title:"Upgrades & Migrations",modularExtension:!1,description:"A Project is a complete instance of Directus, including its **Database**, config file, asset storage, and any custom extensions.",readTime:"4 min read"};return r({frontmatter:a}),($,ee)=>{const n=s("router-link"),l=s("docs-wrapper");return c(),d(l,{frontmatter:a},{default:o(()=>[e("div",u,[e("blockquote",null,[e("p",null,[t("A Project is a complete instance of Directus, including its "),h,t(", config file, asset storage, and any custom extensions. "),i(n,{to:"/docs/getting-started/glossary#projects"},{default:o(()=>[t("Learn more about Projects")]),_:1}),t(".")])]),p,g,m,f,_,y,b,v,w,x,k,j,D,P,B,T,A,I,M,S,U,F,q,N,O,C,E,L,V,Q,R,z,W,H,X,G,J,e("ul",null,[e("li",null,[i(n,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter operators")]),_:1}),t(" have changed, now they are preceded with an underscore e.g.: "),K,t(" is now "),Y])])])]),_:1})}}};export{ie as default,ne as description,ae as modularExtension,se as readTime,oe as title};
